// BoardSelect.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "svimon.h"
#include "BoardSelect.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBoardSelect _CAO


CBoardSelect::CBoardSelect(CSviUsbControl *a_SviUsbControl, CWnd* pParent /*=NULL*/)
	: CDialog(CBoardSelect::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBoardSelect)
	m_SviUsbControl = a_SviUsbControl;
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CBoardSelect::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBoardSelect)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBoardSelect, CDialog)
	//{{AFX_MSG_MAP(CBoardSelect)
	ON_BN_CLICKED(ID_SCAN, OnScan)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBoardSelect bZ[W nh

BOOL CBoardSelect::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Combo{bNX|C^擾
	CComboBox* selectCombo = (CComboBox*)this->GetDlgItem(ID_SEL_COMBO);

	// 擾foCXR{{bNXɐݒ
	// ڑ䐔擾
	int connectNum = m_SviUsbControl->GetBoardNum();

	// ڑ䐔0Ȃ΃R{{bNXɐڑĂȂƕ\0ȊOȂ΃foCXID\
	if(connectNum == 0)
	{
		// R{{bNXɃG[\
		CString errorString;
		errorString.LoadString(IDS_MSG_ERR_NODEVICE);
		selectCombo->SetWindowText(errorString);
	}
	else
	{
		// ڑ䐔̃foCXR{{bNXɐݒ
		for(int i = 0; i < connectNum; i++)
		{
			// 1䂸foCXID擾
			ULONG deviceID = m_SviUsbControl->GetDeviceID(i);
			CString devIDString;			// foCXID
			//CString dipIDString;			// foCXID̃fBbvXCb`ݒID
			
			// foCXID𕶎ɕύX
			devIDString.Format("%04x",(deviceID>>16)&0xffff);
			// foCXIDBR{{bNXɐݒ
			//devIDCombo->AddString(devIDString);
			// foCXID̉SWindowsݒ肷IDȂ̂ō폜܂
			//dipIDString = devIDString.Left(4);
			// DipSwitchIDR{{bNXɕ\
			selectCombo->AddString(devIDString);
		}
		// R{{bNX̃GfBbg{bNXɃXg̐擪̒lݒ
		selectCombo->SetCurSel(0);
	}
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CBoardSelect::OnScan() 
{
	// SVI-03{[hăXL
	m_SviUsbControl->ScanBoard();

	// Combo{bNX|C^擾
	CComboBox* selectCombo = (CComboBox*)this->GetDlgItem(ID_SEL_COMBO);

	// R{{bNX̓e폜܂
	for(int i=0;i<4;i++){
		selectCombo->DeleteString(0);
	}

	// 擾foCXR{{bNXɐݒ
	// ڑ䐔擾
	int connectNum = m_SviUsbControl->GetBoardNum();

	// ڑ䐔0Ȃ΃R{{bNXɐڑĂȂƕ\0ȊOȂ΃foCXID\
	if(connectNum == 0)
	{
		// R{{bNXɃG[\
		CString errorString;
		errorString.LoadString(IDS_MSG_ERR_NODEVICE);
		selectCombo->SetWindowText(errorString);
	}
	else
	{
		// ڑ䐔̃foCXR{{bNXɐݒ
		for(int i = 0; i < connectNum; i++)
		{
			// 1䂸foCXID擾
			ULONG deviceID = m_SviUsbControl->GetDeviceID(i);
			CString devIDString;			// foCXID
			CString dipIDString;			// foCXID̃fBbvXCb`ݒID
			
			// foCXID𕶎ɕύX
			devIDString.Format("%08x",deviceID);
			// foCXIDBR{{bNXɐݒ
			//devIDCombo->AddString(devIDString);
			// foCXID̉SWindowsݒ肷IDȂ̂ō폜܂
			dipIDString = devIDString.Left(4);
			// DipSwitchIDR{{bNXɕ\
			selectCombo->AddString(dipIDString);
		}
		// R{{bNX̃GfBbg{bNXɃXg̐擪̒lݒ
		selectCombo->SetCurSel(0);
	}
}

bool CBoardSelect::SetSelBoardNo()
{
	// 擾foCXR{{bNXɐݒ
	// ڑ䐔擾
	int connectNum = m_SviUsbControl->GetBoardNum();
	if(connectNum == 0){
		AfxMessageBox(ID_MSG_ERR_NO_SVI03);
		return false;
	}

	// Combo{bNX|C^擾
	CComboBox* selectCombo = (CComboBox*)this->GetDlgItem(ID_SEL_COMBO);

	// IĂCfbNXԍ擾܂
	int i = selectCombo->GetCurSel();

	// IꂽSVI-03ʒm܂
	m_SviUsbControl->SetSelBoardNo(i);

	return true;
}

void CBoardSelect::OnOK() 
{
	bool brc = SetSelBoardNo();	
	CDialog::OnOK();
}
