// FrameData.h: CFrameData NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FRAMEDATA_H__1A39DB1D_B85D_4180_B055_D46CB23BE769__INCLUDED_)
#define AFX_FRAMEDATA_H__1A39DB1D_B85D_4180_B055_D46CB23BE769__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SVIPluginComm.h"
#include "SVIComm.h"
#include SVIUSB20_H
#include "RGB.h"
#include "YUV.h"
#include <afxmt.h>

//t[Ǘ܂B
class CFrameData  
{
public:
	void get8x8data(CPoint pixcelPos, PBYTE pbData);
	CFrameData();
	virtual ~CFrameData();

	//t[wb_ݒ肵܂B
	void setFrameHeader(MON_HEADER* header);

	//t[wb_擾܂B
	const MON_HEADER* getFrameHeader(void){return &FrameHeader;};

	//摜tH[}bg̐ݒiUYVYɐݒj
	void setYUVMode(void){inputYUVMode = PicYUV;};

	//摜tH[}bg̐ݒiRGB565ɐݒj
	void setRGBMode(void){inputYUVMode = PicRGB;};

	//摜tH[}bg擾(UYVYH)
	bool IsYUVMode(void){return (inputYUVMode==PicYUV);};

	//摜tH[}bg擾(RGB565H)
	bool IsRGBMode(void){return (inputYUVMode==PicRGB);};

	//摜tH[}bg̐ݒiRAW-8bitɐݒj
	void setYMode(void){inputYUVMode = PicY;};

	//摜tH[}bg̐ݒiRAW-10bitɐݒj
	void setY10Mode(void){inputYUVMode = PicY10;};

	//摜tH[}bg̐ݒiRAW-12bitɐݒj
	void setY12Mode(void){inputYUVMode = PicY12;};

	//摜tH[}bg擾(RAW-8bitH)
	bool IsYMode(void){return (inputYUVMode==PicY);};

	//摜tH[}bg擾(RAW-10bitH)
	bool IsY10Mode(void){return (inputYUVMode==PicY10);};

	//摜tH[}bg擾(RAW-12bitH)
	bool IsY12Mode(void){return (inputYUVMode==PicY12);};

	//摜tH[}bg擾
	PictureType PicMode(void){return inputYUVMode;};

	//摜tH[}bg̐ݒiYUY2ɐݒj
	void setYUY2Mode(void){inputYUVMode = PicYUY2;};

	//摜tH[}bg̐ݒiYVYUɐݒj
	void setYVYUMode(void){inputYUVMode = PicYVYU;};

	//摜tH[}bg̐ݒiVYUYɐݒj
	void setVYUYMode(void){inputYUVMode = PicVYUY;};

	//摜tH[}bg擾(YUYVH)
	bool IsYUY2Mode(void){return (inputYUVMode==PicYUY2);};

	//摜tH[}bg擾(YVYUH)
	bool IsYVYUMode(void){return (inputYUVMode==PicYVYU);};

	//摜tH[}bg擾(VYUYH)
	bool IsVYUYMode(void){return (inputYUVMode==PicVYUY);};

#if 1 // 2005.12.26 V3.32 摜tH[}bgǉ
	//摜tH[}bg̐ݒiUYVY16ɐݒj
	void setUYVY16Mode(void){inputYUVMode = PicUYVY16;};

	//摜tH[}bg̐ݒiVYUY16ɐݒj
	void setVYUY16Mode(void){inputYUVMode = PicVYUY16;};

	//摜tH[}bg擾(UYVY16H)
	bool IsUYVY16Mode(void){return (inputYUVMode==PicUYVY16);};

	//摜tH[}bg擾(VYUY16H)
	bool IsVYUY16Mode(void){return (inputYUVMode==PicVYUY16);};
#endif // 2005.12.26 V3.32 摜tH[}bgǉ

#if 1 // 2006.03.22 V3.3.6.0 摜tH[}bgǉ
	//摜tH[}bg̐ݒiUYVY16ɐݒj
	void setYUY216Mode(void){inputYUVMode = PicYUY216;};

	//摜tH[}bg擾(UYVY16H)
	bool IsYUY216Mode(void){return (inputYUVMode==PicYUY216);};

	//摜tH[}bg擾(UYVY16H)
	void setDispRawMode(int disprawmode){dispRawMode = disprawmode;};
#endif // 2006.03.22 V3.3.6.0 摜tH[}bgǉ

	//摜f[^̃TCY
	int getImageSize(void){return ImageSize;};

	//摜f[^|C^擾
	unsigned char* getImageDataField(void){return ImageData;};

	//摜f[^
	int getImageSizeWidth(void)const{return FrameHeader.ulMonSizeW;};
	//摜f[^
	int getImageSizeHeight(void)const{return FrameHeader.ulMonSizeH;};

	//24bit-Bitmapf[^̃TCYiwb_͊܂܂܂j
	int get24BitmapImageDataSize(int width, int height)const
	{	
		int byteSplit = ((width*3) % 4) * height;//4byteE璷oCg
		return height * width * 3 + byteSplit;
	};

	//24bit-Bitmapf[^̃TCYiwb_͊܂܂܂j
	int get24BitmapImageDataSize(void)const
	{
#if 1 // 2006.01.29 V3.33
		return get24BitmapImageDataSize(getImageSizeWidth(),getImageSizeHeight());
#else // 2006.01.29 V3.33
		if(inputYUVMode==PicY)
			return get24BitmapImageDataSize(getImageSizeWidth()<<1,getImageSizeHeight());
		else if(inputYUVMode==PicY10 || inputYUVMode==PicY12 || inputYUVMode==PicUYVY16 || inputYUVMode==PicVYUY16)
			return get24BitmapImageDataSize(getImageSizeWidth()<<1,getImageSizeHeight());
#if 1 // 2006.03.22 V3.3.6.0
		else if(inputYUVMode==PicYUY216)
			return get24BitmapImageDataSize(getImageSizeWidth()<<1,getImageSizeHeight());
#endif // 2006.03.22 V3.3.6.0
		else
			return get24BitmapImageDataSize(getImageSizeWidth(),getImageSizeHeight());
#endif // 2006.01.29 V3.33
	};

	//24bit-BitmaptH[}bg摜f[^ɂꍇ̃TCY 	///file : BITMAPFILEHEADER܂܂邩
	int get24BitmapSize(bool file) const
	{
		if(file == true)
		{
			return sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + get24BitmapImageDataSize();	//t@Co͗pTCY
		}
		return sizeof(BITMAPINFO) + get24BitmapImageDataSize();	//f[^TCY
	};


	//24bit-BitmaptH[}bg摜̃f[^쐬܂B
	bool get24Bitmap(char* bitmapBuff, int buffSize, bool infoHeader, bool fileHeader, CRect* clip);

	//摜̃sNZJ[擾܂
	CYUV getPixelYUV(CPoint pixcelPos);

	//vOCpɃf[^o 
	void getDataForPlugin(unsigned char* outputData);

	//vOCpf[^̃TCY //includeHeader:wb_[t@C܂ނ
	int getDataSizeForPlugin(bool includeHeader);

	//j^OMt[[g擾܂
	double getFrameRate(void){return double(FrameHeader.ulFrameRate) / 100.;};

private:
	MON_HEADER FrameHeader;//j^Of[^̃wb_
	int ImageSize;//摜̃TCY
	unsigned char* ImageData;//摜f[^
	PictureType inputYUVMode;//͂t[f[^̃J[̎
#if 1 // 2006.03.22 V3.3.6.0
	int dispRawMode; // RAWf[^\[h(0:10-2-9,1:10-0-7,2:12-4-11,3:12-0-7)
#endif // 2006.03.22 V3.3.6.0
};

#endif // !defined(AFX_FRAMEDATA_H__1A39DB1D_B85D_4180_B055_D46CB23BE769__INCLUDED_)
