// MonitoringInfoDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "svimon.h"
#include "MonitoringInfoDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "SviOptions.h"

/////////////////////////////////////////////////////////////////////////////
// CMonitoringInfoDialog _CAO


CMonitoringInfoDialog::CMonitoringInfoDialog(CSVIOptions* option, CWnd* pParent /*=NULL*/)
	: CDialog(CMonitoringInfoDialog::IDD, pParent)
{
	//IvṼ|C^ۑ
	SviOptions = option;

	//{{AFX_DATA_INIT(CMonitoringInfoDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT


	//_CAOi[hXpj
	Create(CMonitoringInfoDialog::IDD,pParent);

}


void CMonitoringInfoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonitoringInfoDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMonitoringInfoDialog, CDialog)
	//{{AFX_MSG_MAP(CMonitoringInfoDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonitoringInfoDialog bZ[W nh

//nj
void CMonitoringInfoDialog::OnCancel() 
{
	this->DestroyWindow();
//	CDialog::OnCancel();
}

//LZ
void CMonitoringInfoDialog::OnOK() 
{
	this->DestroyWindow();
//	CDialog::OnOK();
}

//_CAO
BOOL CMonitoringInfoDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	//f[^XV
// 2005.03.31 V3.01 *********************************************************
// j^O~̃f[^XVǉ
#if 1  // ===================================================================
	refreshData(false);
#else  // ===================================================================
	refreshData();
#endif // ===================================================================
// 2005.03.31 V3.01 *********************************************************

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}


//\f[^tbV܂B
// 2005.03.31 V3.01 *********************************************************
// j^O~̃f[^XVǉ
#if 1  // ===================================================================
void CMonitoringInfoDialog::refreshData(bool monitoring)
#else  // ===================================================================
void CMonitoringInfoDialog::refreshData(void)
#endif // ===================================================================
// 2005.03.31 V3.01 *********************************************************
{
	GET_STATUS* status = SviOptions->SviStatus->getStatus();
	MON_HEADER header  = SviOptions->SviStatus->getMonheader();

	CString work;

	SetDlgItemInt(IDC_CAMERA_OUT_W,status->ulOrgSizeW);
	SetDlgItemInt(IDC_CAMERA_OUT_H,status->ulOrgSizeH);
	

	int cutOutSetW,cutOutSetH;
// 2005.03.31 V3.01 *********************************************************
// ؂oʒȕ\
#if 1  // ===================================================================
	int cutOutSetX, cutOutSetY;
#endif // ===================================================================
// 2005.03.31 V3.01 *********************************************************
	if(SviOptions->CutOutSize.IsRectEmpty() == TRUE)
	{
		//JbgAEgw肪̏ꍇ̓IWiTCYƓ
		cutOutSetW = status->ulOrgSizeW;
		cutOutSetH = status->ulOrgSizeH;
// 2005.03.31 V3.01 *********************************************************
// ؂oʒȕ\
#if 1  // ===================================================================
		cutOutSetX = 0;
		cutOutSetY = 0;
#endif // ===================================================================
// 2005.03.31 V3.01 *********************************************************
	}
	else
	{
		cutOutSetW = SviOptions->CutOutSize.Width();
		cutOutSetH = SviOptions->CutOutSize.Height();
// 2005.03.31 V3.01 *********************************************************
// ؂oʒȕ\
#if 1  // ===================================================================
		cutOutSetX = SviOptions->CutOutSize.left;
		cutOutSetY = SviOptions->CutOutSize.top;
#endif // ===================================================================
// 2005.03.31 V3.01 *********************************************************
	}

	
	SetDlgItemInt(IDC_CUT_SET_W,cutOutSetW);
	SetDlgItemInt(IDC_CUT_SET_H,cutOutSetH);
// 2005.03.31 V3.01 *********************************************************
// ؂oʒȕ\
#if 1  // ===================================================================
	SetDlgItemInt(IDC_CUT_SET_X,cutOutSetX);
	SetDlgItemInt(IDC_CUT_SET_Y,cutOutSetY);
#endif // ===================================================================
// 2005.03.31 V3.01 *********************************************************

// 2005.03.30 V3.01 *********************************************************
// InformationCutout SizeCutoutSettingƓl\Ă邽
// Monitoring wb_̃TCYݒ肷悤ɏC
#if 1  // ===================================================================
	if(monitoring) {
		SetDlgItemInt(IDC_CUT_SIZE_W,header.ulMonSizeW);
		SetDlgItemInt(IDC_CUT_SIZE_H,header.ulMonSizeH);
	}
	else {
		SetDlgItemText(IDC_CUT_SIZE_W,"");
		SetDlgItemText(IDC_CUT_SIZE_H,"");
	}
#else  // ===================================================================
	SetDlgItemInt(IDC_CUT_SIZE_W,status->ulCutSizeW);
	SetDlgItemInt(IDC_CUT_SIZE_H,status->ulCutSizeH);
#endif // ===================================================================
// 2005.03.30 V3.01 *********************************************************


	// JXe[^X : \
	//				  D0FVSYNC
	//                D1FHSYNC
	//                D2FDCK
	//                D3FSCL
	//                D4FSDA

	//                D8 : D0
	//                `   `
	//                D15 : D7

	//JXe[^X`FbN{bNXݒ
#if 1 // 2005.06.06 Kashiwagi V3.10 sɃ`FbN̂C
	if(status->ulCamStatus & Mask_CameraStatus_VSYNC)
		setCheckItem(IDC_VSYNC,TRUE);
	else
		setCheckItem(IDC_VSYNC,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_HSYNC)
		setCheckItem(IDC_HSYNC,TRUE);
	else
		setCheckItem(IDC_HSYNC,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_DCK)
		setCheckItem(IDC_DCK,TRUE);
	else
		setCheckItem(IDC_DCK,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_SCL)
		setCheckItem(IDC_SCL,TRUE);
	else
		setCheckItem(IDC_SCL,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_SDA)
		setCheckItem(IDC_SDA,TRUE);
	else
		setCheckItem(IDC_SDA,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_D0)
		setCheckItem(IDC_D0,TRUE);
	else
		setCheckItem(IDC_D0,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_D1)
		setCheckItem(IDC_D1,TRUE);
	else
		setCheckItem(IDC_D1,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_D2)
		setCheckItem(IDC_D2,TRUE);
	else
		setCheckItem(IDC_D2,FALSE);

	if(status->ulCamStatus&Mask_CameraStatus_D3)
		setCheckItem(IDC_D3,TRUE);
	else
		setCheckItem(IDC_D3,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_D4)
		setCheckItem(IDC_D4,TRUE);
	else
		setCheckItem(IDC_D4,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_D5)
		setCheckItem(IDC_D5,TRUE);
	else
		setCheckItem(IDC_D5,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_D6)
		setCheckItem(IDC_D6,TRUE);
	else
		setCheckItem(IDC_D6,FALSE);

	if(status->ulCamStatus & Mask_CameraStatus_D7)
		setCheckItem(IDC_D7,TRUE);
	else
		setCheckItem(IDC_D7,FALSE);
#else
	setCheckItem(IDC_VSYNC,(status->ulCamStatus&Mask_CameraStatus_VSYNC > 0));
	setCheckItem(IDC_HSYNC,(status->ulCamStatus&Mask_CameraStatus_HSYNC > 0));
	setCheckItem(IDC_DCK,(status->ulCamStatus&Mask_CameraStatus_DCK > 0));
	setCheckItem(IDC_SCL,(status->ulCamStatus&Mask_CameraStatus_SCL > 0));
	setCheckItem(IDC_SDA,(status->ulCamStatus&Mask_CameraStatus_SDA > 0));
	setCheckItem(IDC_D0,(status->ulCamStatus&Mask_CameraStatus_D0 > 0));
	setCheckItem(IDC_D1,(status->ulCamStatus&Mask_CameraStatus_D1 > 0));
	setCheckItem(IDC_D2,(status->ulCamStatus&Mask_CameraStatus_D2 > 0));
	setCheckItem(IDC_D3,(status->ulCamStatus&Mask_CameraStatus_D3 > 0));
	setCheckItem(IDC_D4,(status->ulCamStatus&Mask_CameraStatus_D4 > 0));
	setCheckItem(IDC_D5,(status->ulCamStatus&Mask_CameraStatus_D5 > 0));
	setCheckItem(IDC_D6,(status->ulCamStatus&Mask_CameraStatus_D6 > 0));
	setCheckItem(IDC_D7,(status->ulCamStatus&Mask_CameraStatus_D7 > 0));
#endif

	
// 2005.05.17 V3.08 *********************************************************
// t@[EFAyFPGÃo[W\
#if 1  // ===================================================================
#if 1 // 2005.06.06 Kashiwagi V3.10 H/W,F/Wo[W̕s\C
	unsigned long ulVal,ulVal2;
	ulVal = status->ulHWVersion;
	ulVal2  = (ulVal >> 8) & 0xf; ulVal2 *= 100;
	ulVal2 += ((ulVal >> 4) & 0xf) * 10;
	ulVal2 += ((ulVal >> 0) & 0xf) * 1;
	CString csValue;
	csValue.Format("%.02f", (double)ulVal2/100);
	SetDlgItemText(IDC_FPGAVER, csValue);
	ulVal = status->ulFWVersion;
	ulVal2  = (ulVal >> 8) & 0xf; ulVal2 *= 100;
	ulVal2 += ((ulVal >> 4) & 0xf) * 10;
	ulVal2 += ((ulVal >> 0) & 0xf) * 1;
	csValue.Format("%.02f", (double)ulVal2/100);
	SetDlgItemText(IDC_FWVER, csValue);
#else
	CString csValue;
	csValue.Format("%.02f", (double)status->ulHWVersion/100);
	SetDlgItemText(IDC_FPGAVER, csValue);
	csValue.Format("%.02f", (double)status->ulFWVersion/100);
	SetDlgItemText(IDC_FWVER, csValue);
#endif
#endif // ===================================================================
// 2005.03.10 V3.08 *********************************************************

// 2006.09.19 V3.3.7.0 ******************************************************
// {[ho[WAPLLݒl\
#if 1  // ===================================================================
	int iBoardVer, iPllData;
	SviOptions->SviStatus->getBoardInfo(&iBoardVer, &iPllData);
#if 1
	ulVal = iBoardVer;
#if 1 // 2010.06.15 V3.6.0.0 SVI-03,SVI-04Ή
	if(ulVal < 3){
#else
	if(ulVal != 3){
#endif // 2010.06.15 V3.6.0.0
		csValue.Format("??");
		SetDlgItemText(IDC_BDVER, csValue);
		SetDlgItemText(IDC_PLLVAL, csValue);
	}
	else {
		csValue.Format("%2d", ulVal);
		SetDlgItemText(IDC_BDVER, csValue);
#if 1 // 2010.06.15 V3.6.0.0 SVI-03,SVI-04Ή
		if((ulVal == 3 && ulVal2 >= 101) || (ulVal == 4 && ulVal2 >= 100)){
#else
		if(ulVal2 >= 101){
#endif // 2010.06.15 V3.6.0.0
			ulVal = iPllData;
			csValue.Format("%06d", ulVal);
		}else{
			csValue.Format("??");
		}
		SetDlgItemText(IDC_PLLVAL, csValue);
	}
#else
	ulVal = iBoardVer;
	csValue.Format("%08x", ulVal);
	SetDlgItemText(IDC_BDVER, csValue);
	ulVal = iPllData;
	csValue.Format("%08x", ulVal);
	SetDlgItemText(IDC_PLLVAL, csValue);
#endif
#endif // ===================================================================
// 2006.09.19 V3.3.7.0 ******************************************************

}


//`FbN{bNX̃`FbNݒ
void CMonitoringInfoDialog::setCheckItem(int idItem, bool check)
{
	if(check == true)
	{
		((CButton*)GetDlgItem(idItem))->SetCheck(1);
	}
	else
	{
		((CButton*)GetDlgItem(idItem))->SetCheck(0);
	}

}


void CMonitoringInfoDialog::PostNcDestroy() 
{

	//j[̃J[o[̃`FbN͂
	AfxGetMainWnd()->GetMenu()->CheckMenuItem(ID_MONITORING_INFO , MF_BYCOMMAND | MF_UNCHECKED);

	//鎞newĂ̂Ŏg폜
	delete this;

	
	CDialog::PostNcDestroy();
}

