// SVIMonView.h : CSVIMonView NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SVIMONVIEW_H__6D32E6E9_5962_4BE7_B4E4_0B22BFA33198__INCLUDED_)
#define AFX_SVIMONVIEW_H__6D32E6E9_5962_4BE7_B4E4_0B22BFA33198__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SVIMonDoc.h"
#include "MainFrm.h"
#include <afxmt.h>

#define  VIEW_BMP_MAX_SIZE 64*1024*1024 //\p64Mbytem

//̃EChEJ[ƔȂ悤ɂĂB16bitJ[lĂB
#define DXDISP_COLORKEY_R 64 // ]J[L[Red
#define DXDISP_COLORKEY_G 64 // ]J[L[Green
#define DXDISP_COLORKEY_B 64 // ]J[L[Blue

class CSVIMonView : public CView
{
protected: // VACY@\݂̂쐬܂B
	CSVIMonView();
	DECLARE_DYNCREATE(CSVIMonView)

// Agr[g
public:
	CSVIMonDoc* GetDocument();

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CSVIMonView)
	public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷ۂɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CSVIMonView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CSVIMonView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


public:
	//GDIɂt[`悩DirectXI
	void drawFrame(CWnd* pMainFrame)
	{
		MainFrame = pMainFrame;//Ct[̃|C^oɕێ
		DirectXMode	= false;
		drawFrameGDI();
	};

	//GDIɂ`悩DirectXI
	void draw()
	{
		DirectXMode	= false;
		drawFrame(AfxGetMainWnd());
	};

	//EChEړiCt[Ăяo܂j
	void OnMove(int x, int y);

	//Y[ύXiCt[Ăяo܂j
	void OnZoom(double zoom);

	//J[o[̒lXV܂B(w肵Ȃ΃}EXWŌvZ܂j
	void refreshColorBar(CPoint* pixelPoint=NULL);

	inline void StartInit()
	{
		BefoHeight	= 0;
		BefoWidth	= 0;
	}

	inline int GetViewWidth() { return BefoWidth; }
	inline int GetViewHeight() { return BefoHeight; }

	void ResetMemory(int newMemorySize);

private:
	//Jgt[`悵܂BɂCMainFramenĂ
	void drawFrameGDI(void);

	//oϐɂBitmapf[^`悵܂
	void drawGDI(int width = 0, int height = 0);

	//XN[o[tbV܂B
	void refreshScrollBar(void);

	//EChETCY
	void AutoResizeWindow();

	//Ct[̃|C^
	CWnd* MainFrame;

	//\𑜓xω`FbN
	int PrevHeight;
	int PrevWidth;
	double PrevZoom;

	//DIBrbg}bvp
	char* imageBitmapDIB;//BMPf[^
	bool BmpViewImageDataEnable; //Jg\pBMPf[^܂Ă邩B
	BITMAPINFO BitmapInfo;//\prbg}bṽwb_

	bool DirectXMode;//DirectXŕ`悷邩
	char BmpImageData[VIEW_BMP_MAX_SIZE];//DirectXp

	CString ClassStyleName;//DirectXp̃NXX^CiI[o[CΉj

	//XN[o[̕\ɃXN[o[\ԕύXȂׂɓ
	CCriticalSection cs;

	//ÕXN[o[\
	bool PrevHScroolEnable;
	bool PrevVScroolEnable;

	int BefoHeight;
	int BefoWidth;

	BITMAPINFO GDIBitmapInfo;

	LPBYTE m_lpCutBuff;

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_SVIMONVIEW_H__6D32E6E9_5962_4BE7_B4E4_0B22BFA33198__INCLUDED_)
