// SVIOptions.cpp: CSVIOptions NX̃Cve[V
//
// SVIViewɊւIvVݒێNX
// 2004/09/29 ktsushima
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SVIOptions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//RXgN^
CSVIOptions::CSVIOptions()
{
	//init@C΂ŏ܂B
	AppName = AfxGetAppName();
	IniFileName = "\\" + AppName + ".ini";
	TCHAR Path[MAX_PATH];
	GetCurrentDirectory(MAX_PATH,Path);
	IniFileName =  Path + IniFileName;


	CIniFileControl iniFile(AppName,IniFileName);

#if 1 // 2007.12.07 V3.4.1.0 InterlaseΉ
	// j^OZ[ũC^[X摜MtO
	// 0:Progressive ,1:Interlase
	isMonSaveInterlase = iniFile.getBool(INI_KEY_MONSAVEINT, DEFAULT_MONSAVEINT);
#endif // 2007.12.07 V3.4.1.0 InterlaseΉ

// 2005.12.21 V3.32 *********************************************************
	// M[h(TRUE:HIGH FALSE:LOW)
	bSyncMode = iniFile.getBool(INI_KEY_SYNCMODE, DEFAULT_SYNCMODE);
	// 摜f[^荞݃^C~O(TRUE:HIGH FALSE:LOW)
	bEdgeMode = iniFile.getBool(INI_KEY_EDGEMODE, DEFAULT_EDGEMODE);
// 2005.12.21 V3.32 *********************************************************

// 2007.10.23 V3.40 *********************************************************
#if 1
	// j^OZ[ủ摜\Ԋu
	MonSavePreviewTimeNum = iniFile.getInt(INI_KEY_MONSAVEPRETIMENUM, DEFAULT_MONSAVEPRETIMENUM);
	// j^OZ[ủ摜\tO
	isMonSavePreview = iniFile.getBool(INI_KEY_MONSAVEPRE, DEFAULT_MONSAVEPRE);
	// j^OZ[u̕ۑt@C
	MonSaveFileName = iniFile.getString(INI_KEY_MONSAVEFILE, DEFAULT_MONSAVEFILE);
#endif
// 2007.10.23 V3.40 *********************************************************

// 2005.10.14 V3.31 *********************************************************
	// j^Ot[ۑ
	MonSaveTimeNum = iniFile.getInt(INI_KEY_MONSAVETIMENUM, DEFAULT_MONSAVETIMENUM);
	// j^Ot[ۑt[
	MonSaveFrameNum = iniFile.getInt(INI_KEY_MONSAVEFRAMENUM, DEFAULT_MONSAVEFRAMENUM);
	// j^Ot[ۑ[h
	isMonSaveFrames = iniFile.getBool(INI_KEY_MONSAVEFRAMES, DEFAULT_MONSAVEFRAMES);
// 2005.10.14 V3.31 *********************************************************

// 2005.10.06 V3.30 *********************************************************
	//j^O[h擾
	bMonMode = iniFile.getBool(INI_KEY_MONMODE,DEFAULT_MONMODE);
	//RAWf[^rbgATCʎ擾
	iRawBitAss = iniFile.getInt(INI_KEY_RAWBITASS,DEFAULT_RAWBITASS);
// 2005.10.06 V3.30 *********************************************************

// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 0  // ===================================================================
	// Y[hL/擾
	IsYEnable	= iniFile.getBool(INI_KEY_REC_YMODEENABLE, DEFAULT_REC_YMODEENABLE);
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

// 2005.09.13 V3.21 *********************************************************
// Y(RAW)[hWƂėLƂ
#if 1  // ===================================================================
	// Y[hL
	IsYEnable	= TRUE;
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

	//Displayݒ
	Display = iniFile.getBool(INI_KEY_DISPLAY,DEFAULT_DISPLAY);

	//Zooml
	Zoom = iniFile.getFloat(INI_KEY_ZOOM,DEFAULT_ZOOM);

	//YUVl
// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 1  // ===================================================================
	PicType = (enumPictureType)iniFile.getInt(INI_KEY_PICTURETYPE,(int)PicYUV);
// 2005.10.05 V3.30 *********************************************************
// RAW(Y)[h̋ʂȂ悤ɂ
//	if(IsYEnable == DEFAULT_REC_YMODEENABLE && PicType == PicY) {
//		PicType = PicYUV;
//	}
// 2005.10.05 V3.30 *********************************************************
#else  // ===================================================================
	PictureType = (enumPictureType)iniFile.getInt(INI_KEY_PICTURETYPE,(int)YUV);
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

	//t[wŃR[fBO
	isFrames = iniFile.getBool(INI_KEY_ISFRAME,DEFAULT_ISFRAME);

	//t[obt@l
	FrameNum = iniFile.getInt(INI_KEY_REC_FRAME,DEFAULT_REC_FRAME);

	//MBytew菉l
	MByteNum = iniFile.getInt(INI_KEY_REC_MBYTE,DEFAULT_REC_MBYTE);

	//JbgAEg̒gݒ
	CutOutSize.left = iniFile.getInt(INI_KEY_CUTOUTSIZE_LEFT,0);
	CutOutSize.top = iniFile.getInt(INI_KEY_CUTOUTSIZE_TOP,0);
	CutOutSize.right = iniFile.getInt(INI_KEY_CUTOUTSIZE_RIGHT,2048);
	CutOutSize.bottom = iniFile.getInt(INI_KEY_CUTOUTSIZE_BOTTOM,1536);


	//Memoryݒ
	SharedMemorySizeMByte = iniFile.getInt(INI_KEY_SHARED_MEM,DEFAULT_SHARED_MEM);
	DisplayMemorySizeMByte = iniFile.getInt(INI_KEY_FRAME_MEM,DEFAULT_FRAME_MEM);

// 2005.03.28 V3.01 *********************************************************
// GDI`@\ǉ
#if 1  // ===================================================================
	isDXmode	= iniFile.getBool(INI_KEY_REC_DXMODE, DEFAULT_REC_DXMODE);
#endif // ===================================================================
// 2005.03.28 V3.01 *********************************************************

// 2005.04.06 V3.01 *********************************************************
// j^OG[Xe[^Xo[֕\
#if 1  // ===================================================================
	IsSTSErr	= iniFile.getBool(INI_KEY_REC_STSERR, DEFAULT_REC_STSERR);
#endif // ===================================================================
// 2005.04.06 V3.01 *********************************************************

// 2005.04.11 V3.02 *********************************************************
// Recording̃^CAEgԂݒ
#if 1  // ===================================================================
	RecordingTimeout = iniFile.getInt(INI_KEY_REC_TIMEOUT,DEFAULT_REC_TIMEOUT);
#endif // ===================================================================
// 2005.04.11 V3.02 *********************************************************

// 2005.07.30 V3.021 ********************************************************
// PxƃxN^[Otǂw
#if 0  // ===================================================================
	IsVectorGraph = iniFile.getBool(INI_KEY_ISVGRAPH,DEFAULT_ISVGRAPH);
#endif // ===================================================================
// 2005.07.30 V3.021 ********************************************************

// 2005.08.02 V3.021 ********************************************************
// Ot̉摜̑傫w 1/nZoom nZoom = 1 or 2
#if 0  // ===================================================================
	nZoom = iniFile.getInt(INI_KEY_VGRAPH_ZOOM,DEFAULT_VGRAPH_ZOOM);
#endif // ===================================================================
// 2005.07.30 V3.021 ********************************************************

// 2006.11.01 V3.37 *********************************************************
// Monitoring̃^CAEgԂݒ
#if 1  // ===================================================================
	MonitoringTimeout = iniFile.getInt(INI_KEY_MON_TIMEOUT,DEFAULT_MON_TIMEOUT);
#endif // ===================================================================
// 2006.11.01 V3.37 *********************************************************

#if 1 // 2010.05.21 V3.6.0.0 ۑ`ǉiFRM,AVI1.0,AVI2.0j
	// MonSave̕ۑ`i0:FRM, 1:AVI1.0, 2:AVI2.0j
	isMonSaveFormat = iniFile.getInt(INI_KEY_MONSAVEFMT,DEFAULT_MONSAVEFMT);
#endif // 2010.05.21 V3.6.0.0

}

CSVIOptions::~CSVIOptions()
{
	//݂̐ݒinit@Cɕۑ

	CIniFileControl iniFile(AppName,IniFileName);

#if 1 // 2007.12.07 V3.4.1.0 InterlaseΉ
	// j^OZ[ũC^[X摜MtO
	// 0:Progressive ,1:Interlase
	if(isMonSaveInterlase == 0)
		iniFile.setBool(INI_KEY_MONSAVEINT, false);
	else
		iniFile.setBool(INI_KEY_MONSAVEINT, true);
#endif // 2007.12.07 V3.4.1.0 InterlaseΉ

// 2005.12.21 V3.32 *********************************************************
	// M[h(TRUE:HIGH FALSE:LOW)
	iniFile.setBool(INI_KEY_SYNCMODE, bSyncMode);
	// 摜f[^荞݃^C~O(TRUE:HIGH FALSE:LOW)
	iniFile.setBool(INI_KEY_EDGEMODE, bEdgeMode);
// 2005.12.21 V3.32 *********************************************************

// 2007.10.23 V3.40 *********************************************************
	// j^OZ[ủ摜\Ԋu
	iniFile.setInt(INI_KEY_MONSAVEPRETIMENUM, MonSavePreviewTimeNum);
	// j^OZ[ủ摜\tO
	iniFile.setBool(INI_KEY_MONSAVEPRE, isMonSavePreview);
	// j^OZ[u̕ۑt@C
	iniFile.setString(INI_KEY_MONSAVEFILE, MonSaveFileName);
// 2007.10.23 V3.40 *********************************************************

// 2005.10.14 V3.31 *********************************************************
	// j^Ot[ۑ
	iniFile.setInt(INI_KEY_MONSAVETIMENUM, MonSaveTimeNum);
	// j^Ot[ۑt[
	iniFile.setInt(INI_KEY_MONSAVEFRAMENUM, MonSaveFrameNum);
	// j^Ot[ۑ[h
	iniFile.setBool(INI_KEY_MONSAVEFRAMES, isMonSaveFrames);
// 2005.10.14 V3.31 *********************************************************

// 2005.10.06 V3.30 *********************************************************
	//j^O[h擾
	iniFile.setBool(INI_KEY_MONMODE,bMonMode);
	//RAWf[^rbgATCʎ擾
	iniFile.setInt(INI_KEY_RAWBITASS,iRawBitAss);
// 2005.10.06 V3.30 *********************************************************

	//Displayݒ
	iniFile.setBool(INI_KEY_DISPLAY,Display);

	//Zoom
	iniFile.setFloat(INI_KEY_ZOOM,(float)Zoom);

	//YUV
// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 1  // ===================================================================
	iniFile.setInt(INI_KEY_PICTURETYPE,(int)PicType);
#else  // ===================================================================
	iniFile.setInt(INI_KEY_PICTURETYPE,(int)PictureType);
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

	//t[w
	iniFile.setBool(INI_KEY_ISFRAME,isFrames);

	//t[
	iniFile.setInt(INI_KEY_REC_FRAME,FrameNum);

	//MBytew
	iniFile.setInt(INI_KEY_REC_MBYTE,MByteNum);

	//JbgAEg̒gݒ
	iniFile.setInt(INI_KEY_CUTOUTSIZE_LEFT,CutOutSize.left);
	iniFile.setInt(INI_KEY_CUTOUTSIZE_TOP,CutOutSize.top);
	iniFile.setInt(INI_KEY_CUTOUTSIZE_RIGHT,CutOutSize.right);
	iniFile.setInt(INI_KEY_CUTOUTSIZE_BOTTOM,CutOutSize.bottom);


	//Memoryݒ
	iniFile.setInt(INI_KEY_SHARED_MEM,SharedMemorySizeMByte);
	iniFile.setInt(INI_KEY_FRAME_MEM,DisplayMemorySizeMByte);

// 2005.03.28 V3.01 *********************************************************
// GDI`@\ǉ
#if 1  // ===================================================================
	iniFile.setBool(INI_KEY_REC_DXMODE,isDXmode);
#endif // ===================================================================
// 2005.03.28 V3.01 *********************************************************

// 2005.04.11 V3.02 *********************************************************
// Recording̃^CAEgԂݒ
#if 1  // ===================================================================
	iniFile.setInt(INI_KEY_REC_TIMEOUT,RecordingTimeout);
#endif // ===================================================================
// 2005.04.11 V3.02 *********************************************************

// 2006.11.01 V3.37 *********************************************************
// Monitoring̃^CAEgԂݒ
#if 1  // ===================================================================
	iniFile.setInt(INI_KEY_MON_TIMEOUT,MonitoringTimeout);
#endif // ===================================================================
// 2006.11.01 V3.37 *********************************************************

// 2005.07.30 V3.021 ********************************************************
// PxƃxN^[Otǂw
#if 1  // ===================================================================
	iniFile.setBool(INI_KEY_ISVGRAPH,IsVectorGraph);
#endif // ===================================================================
// 2005.07.30 V3.021 ********************************************************

// 2005.08.02 V3.021 ********************************************************
// Ot̉摜̑傫w 1/nZoom nZoom = 1 or 2
#if 1  // ===================================================================
	iniFile.setInt(INI_KEY_VGRAPH_ZOOM,nZoom);
#endif // ===================================================================
// 2005.08.02 V3.021 ********************************************************

#if 1 // 2010.05.21 V3.6.0.0 ۑ`ǉiFRM,AVI1.0,AVI2.0j
	// MonSave̕ۑ`i0:FRM, 1:AVI1.0, 2:AVI2.0j
	iniFile.setInt(INI_KEY_MONSAVEFMT,isMonSaveFormat);
#endif // 2010.05.21 V3.6.0.0
}
