// SVIOptions.h: CSVIOptions NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SVIOPTIONS_H__D2FA8601_3034_4845_A81D_0145EB6C23E0__INCLUDED_)
#define AFX_SVIOPTIONS_H__D2FA8601_3034_4845_A81D_0145EB6C23E0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SVIComm.h"

#include "SviStatus.h"
#include "IniFileControl.h"

#if 1 // 2006.11.09 V3.3.7.0
#define MAX_FRAME_MEM 256
#define MAX_SHARED_MEM 256
#else
#define MAX_FRAME_MEM 128
#define MAX_SHARED_MEM 128
#endif // 2006.11.09 V3.3.7.0

#define INI_KEY_DISPLAY "Display"
#define DEFAULT_DISPLAY true

#define INI_KEY_ZOOM "Zoom"
#define DEFAULT_ZOOM 1.0

#define INI_KEY_PICTURETYPE "PictureType"
#define DEFAULT_PICTURETYPE YUV

#define INI_KEY_CUTOUTSIZE_LEFT "CutOutSizeLeft"
#define INI_KEY_CUTOUTSIZE_TOP "CutOutSizeTop"
#define INI_KEY_CUTOUTSIZE_RIGHT "CutOutSizeRight"
#define INI_KEY_CUTOUTSIZE_BOTTOM "CutOutSizeBottom"


#define INI_KEY_SHARED_MEM "SharedMemorySizeMByte"
#define DEFAULT_SHARED_MEM 128

#define INI_KEY_FRAME_MEM "DisplayMemorySizeMByte"
#define DEFAULT_FRAME_MEM 32

#define INI_KEY_ISFRAME "isFrames"
#define DEFAULT_ISFRAME true

#define INI_KEY_REC_FRAME "FrameNum"
#define DEFAULT_REC_FRAME 20

#define INI_KEY_REC_MBYTE "MByteNum"
#define DEFAULT_REC_MBYTE 128

// 2005.03.28 V3.01 *********************************************************
// GDI`@\ǉ
#if 1  // ===================================================================
#define INI_KEY_REC_DXMODE "DirectXMode"
#define DEFAULT_REC_DXMODE true
#endif // ===================================================================
// 2005.03.28 V3.01 *********************************************************

// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
// <RAWIvV{^\@>
// IvV_CAOY[hiRAWjIvV\ꍇɂ
// SVImon.init@CɈȉ̕ǉ܂Biuv͋LqȂj
// uYMODEENBL=truev
// ĹuDEFAULT_REC_YMODEENABLEvTRUEɕύXĂ\܂B
#if 1  // ===================================================================
#define INI_KEY_REC_YMODEENABLE "YMODEENBL"
#define DEFAULT_REC_YMODEENABLE false
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

// 2005.04.06 V3.01 *********************************************************
// j^OG[Xe[^Xo[֕\
#if 1  // ===================================================================
#define INI_KEY_REC_STSERR "STSERR_MSG"
#define DEFAULT_REC_STSERR false
#endif // ===================================================================
// 2005.04.06 V3.01 *********************************************************

// 2005.04.11 V3.02 *********************************************************
// Recording̃^CAEgԂݒ
#if 1  // ===================================================================
#define INI_KEY_REC_TIMEOUT "RECTIMEOUT"
#define DEFAULT_REC_TIMEOUT 60
#endif // ===================================================================
// 2005.04.11 V3.02 *********************************************************

// 2006.11.01 V3.37 *********************************************************
// Monitoring̃^CAEgԂݒ
#if 1  // ===================================================================
#define INI_KEY_MON_TIMEOUT "MONTIMEOUT"
#define DEFAULT_MON_TIMEOUT 10
#endif // ===================================================================
// 2006.11.01 V3.37 *********************************************************

// 2005.07.30 V3.021 ********************************************************
// PxƃxN^[Otǂw
#if 1  // ===================================================================
#define INI_KEY_ISVGRAPH "isVGraph"
#define DEFAULT_ISVGRAPH false
#endif // ===================================================================
// 2005.07.30 V3.021 ********************************************************

// 2005.08.02 V3.021 ********************************************************
// Ot̉摜̑傫w 1/nZoom nZoom = 1 or 2
#if 1  // ===================================================================
#define INI_KEY_VGRAPH_ZOOM "VGraphZoom"
#define DEFAULT_VGRAPH_ZOOM 1
#endif // ===================================================================
// 2005.08.02 V3.021 ********************************************************

// 2005.10.06 V3.30 ********************************************************
// j^O[h 0:ޯ̧ 1:ݸޯ̧
#define INI_KEY_MONMODE "MonMode"
#define DEFAULT_MONMODE 0
// RAWf[^rbgATC 0-3
#define INI_KEY_RAWBITASS "RawBitAss"
#define DEFAULT_RAWBITASS 0
// 2005.10.06 V3.30 ********************************************************

// 2007.10.23 V3.40 ********************************************************
// j^OZ[ủ摜\Ԋu
#define INI_KEY_MONSAVEPRETIMENUM "MonSavePreTimeNum"
#define DEFAULT_MONSAVEPRETIMENUM 1
// j^OZ[ủ摜\tO
#define INI_KEY_MONSAVEPRE "MonSavePreviewFlag"
#define DEFAULT_MONSAVEPRE true
// j^OZ[u̕ۑt@C
#define INI_KEY_MONSAVEFILE "MonSaveFileName"
#define DEFAULT_MONSAVEFILE "MonSave"

// 2007.10.23 V3.40 ********************************************************

#if 1 // 2007.12.07 V3.4.1.0 InterlaseΉ
	// j^OZ[ũC^[X摜MtO
	// 0:Progressive ,1:Interlase
#define INI_KEY_MONSAVEINT "MonSaveInterlase"
#define DEFAULT_MONSAVEINT false
#endif // 2007.12.07 V3.4.1.0 InterlaseΉ

// 2005.10.14 V3.31 ********************************************************
// j^Ot[ۑ
#define INI_KEY_MONSAVETIMENUM "MonSaveTimeNum"
#define DEFAULT_MONSAVETIMENUM 5
// j^Ot[ۑt[
#define INI_KEY_MONSAVEFRAMENUM "MonSaveFrameNum"
#define DEFAULT_MONSAVEFRAMENUM 10
// j^Ot[ۑ[h
#define INI_KEY_MONSAVEFRAMES "MonSaveFrames"
#define DEFAULT_MONSAVEFRAMES false
// 2005.10.14 V3.31 ********************************************************

// 2005.12.21 V3.32 *********************************************************
// M[h(TRUE:HIGH FALSE:LOW)
#define INI_KEY_SYNCMODE "SyncMode"
#define DEFAULT_SYNCMODE false
// 摜f[^荞݃^C~O(TRUE:HIGH FALSE:LOW)
#define INI_KEY_EDGEMODE "EdgeMode"
#define DEFAULT_EDGEMODE true
// 2005.12.21 V3.32 *********************************************************
#if 1 // 2010.05.21 V3.6.0.0 ۑ`ǉiFRM,AVI1.0,AVI2.0j
// MonSave̕ۑ`i0:FRM, 1:AVI1.0, 2:AVI2.0j
#define INI_KEY_MONSAVEFMT "MonSaveFormat"
#define DEFAULT_MONSAVEFMT 0
#endif // 2010.05.21 V3.6.0.0

//SVIMonŕێOptionݒp
class CSVIOptions
{
public:
#if 1 // 2010.05.21 V3.6.0.0 ۑ`ǉiFRM,AVI1.0,AVI2.0j
	int isMonSaveFormat; // MonSave̕ۑ`i0:FRM, 1:AVI1.0, 2:AVI2.0j
#endif // 2010.05.21 V3.6.0.0
#if 1 // 2007.12.07 V3.4.1.0 InterlaseΉ
	int isMonSaveInterlase;
#endif // 2007.12.07 V3.4.1.0 InterlaseΉ
// 2005.12.21 V3.32 ********************************************************
	bool bSyncMode;	// M[h(TRUE:HIGH FALSE:LOW)
	bool bEdgeMode;	// 摜f[^荞݃^C~O(TRUE:HIGH FALSE:LOW)
// 2005.12.21 V3.32 ********************************************************

	int MonSaveTimeNum;
	int MonSaveFrameNum;
	int MonSavePreviewTimeNum;
	bool isMonSaveFrames;
	bool isMonSavePreview;
	CString MonSaveFileName;
	CSVIOptions();
	virtual ~CSVIOptions();

// 2005.10.05 V3.30 ********************************************************
	//j^O[hݒ(0:ޯ̧A1:ݸޯ̧)
	bool bMonMode;
	//RAWf[^rbgATC(0-3)
	int iRawBitAss;
// 2005.10.05 V3.30 ********************************************************

	//Displayݒ
	bool Display; //R[fBOf[^\EChETCYt[̃TCYɎIɍ킹܂

	double Zoom; //Y[{

// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 1  // ===================================================================
	PictureType PicType;
#else  // ===================================================================
	//PictureTypeݒ
	enum enumPictureType
	{
		YUV, //R[fBOAj^O摜f[^YUVƂ݂Ȃ܂
		RGB  //R[fBOAj^O摜f[^RGBƂ݂Ȃ܂
	}PictureType;
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

	//JbgAEgTCY
	CRect CutOutSize;

	//Memoryݒ
	int SharedMemorySizeMByte;
	int DisplayMemorySizeMByte;


	//n[hEGAXe[^Xێ
	CSviStatus* SviStatus;

	//R[fBOݒ
	bool isFrames;//t[wŃR[fBOBfalseȂMBytew
	int FrameNum;//t[
	int MByteNum;//MBytew傫

	//init@CŎgp
	CString AppName;
	CString IniFileName;

// 2005.03.28 V3.01 *********************************************************
// GDI`@\ǉ
#if 1  // ===================================================================
	bool isDXmode;
#endif // ===================================================================
// 2005.03.28 V3.01 *********************************************************

// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
// BR}h
#if 1  // ===================================================================
	bool IsYEnable;
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

// 2005.04.06 V3.01 *********************************************************
// j^OG[Xe[^Xo[֕\
// BR}h
#if 1  // ===================================================================
	bool IsSTSErr;
#endif // ===================================================================
// 2005.04.06 V3.01 *********************************************************

// 2005.04.11 V3.02 *********************************************************
// Recording̃^CAEgԂݒ
#if 1  // ===================================================================
	int RecordingTimeout;
#endif // ===================================================================
// 2005.04.11 V3.02 *********************************************************

// 2006.11.01 V3.37 *********************************************************
// Monitoring̃^CAEgԂݒ
#if 1  // ===================================================================
	int MonitoringTimeout;
#endif // ===================================================================
// 2006.11.01 V3.37 *********************************************************

// 2005.07.30 V3.021 ********************************************************
// PxƃxN^[Otǂw
#if 1  // ===================================================================
	bool IsVectorGraph;
#endif // ===================================================================
// 2005.07.30 V3.021 ********************************************************

// 2005.08.02 V3.021 ********************************************************
// Ot̉摜̑傫w 1/nZoom nZoom = 1 or 2
#if 1  // ===================================================================
	int		nZoom;
#endif // ===================================================================
// 2005.08.02 V3.021 ********************************************************
};



#endif // !defined(AFX_SVIOPTIONS_H__D2FA8601_3034_4845_A81D_0145EB6C23E0__INCLUDED_)
