// SviStatus.cpp: CSviStatus NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SVIMon.h"
#include "SviStatus.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//ftHgRXgN^
CSviStatus::CSviStatus()
{
	memset(&SviStatus, 0, sizeof(GET_STATUS));
	memset(&SviMonheader, 0, sizeof(MON_HEADER));

}

//SVIn[hEGAXe[^XɂƂRXgN^
CSviStatus::CSviStatus(GET_STATUS &status)
{
	setStatus(status);
}


CSviStatus::~CSviStatus()
{

}

//SVIn[hEGAXe[^Xݒ肵܂
void CSviStatus::setStatus(GET_STATUS &status)
{
	//oϐɃRs[
	memcpy(&SviStatus, &status, sizeof(GET_STATUS));
}

//SVIn[hEGAXe[^X̂{Xe[^X݂̂ݒ肵܂
void CSviStatus::setBaseStatus(ULONG status)
{
	SviStatus.ulBasicStatus = status;
}

//{Xe[^XIǂ
bool CSviStatus::IsSuccess(void)
{
	switch(SviStatus.ulBasicStatus)
	{
	case SVI_STS_SUCCESS:
	case SVI_STS_FRAMEPENDING:
	case SVI_STS_CAPCANCELED:
		return true;
	default:
		break;
	}
	return false;
}
//{Xe[^X𕶎񉻂܂B
CString getBasicStatusString(ULONG basicStatus)
{
	CString outputString;
	switch(basicStatus)
	{
	case SVI_STS_SUCCESS:  
		outputString = " I";
		break;
	case SVI_STS_FRAMEPENDING:  
		outputString = " I (ۗt[/f[^)";
		break;
	case SVI_STS_CAPCANCELED    :  
		outputString = " I (Lv`~ꂽ)";
		break;
	case SVI_STS_BUSY           :  
		outputString = " rW[ŃR}hsł܂";
		break;
	case SVI_STS_RECOVERYMODE   :  
		outputString = " Jo[[ĥ߃R}hsł܂";
		break;
	case SVI_STS_I2CACTIVE      :  
		outputString = " I2CRg[ANeBu";
		break;
	case SVI_STS_CMD_INVALID    :  
		outputString = " R}hsł";
		break;
	case SVI_STS_PRM_INVALID    :  
		outputString = " p[^sł";
		break;
	case SVI_STS_SEQ_INVALID    :  
		outputString = " pPbg̔sV[PXsł";
		break;
	case SVI_STS_I2C_ACKTIMEOUT :  
		outputString = " I2CŃX[uACKMł^CAEg܂";
		break;
	case SVI_STS_I2C_PRETIMEOUT :  
		outputString = " I2CŃv^CAEg܂";
		break;
	case SVI_STS_I2C_POSTTIMEOUT: 
		outputString = " I2CŃ|Xg^CAEg܂";
		break;
	case SVI_STS_USB_ERROR      :  
		outputString = " USBʐMɃG[܂";
		break;
	case SVI_STS_UPDATE_INVALID :  
		outputString = " W[f[^sł";
		break;
	case SVI_STS_FROMERS_ERROR  :  
		outputString = " tbV[̏Ɏs܂";
		break;
	case SVI_STS_FROMWT_ERROR   :  
		outputString = " tbV[݂̏Ɏs܂";
		break;
	case SVI_STS_INTERNAL_ERROR :  
		outputString = " G[܂";
		break;
	case SVI_STS_RESOURCE_ERROR :  
		outputString = " \[Xsďsł܂";
		break;
	default:
		outputString = "G[ł܂";
		break;
	}
	return outputString;
}

// 2005.03.30 V3.01 *********************************************************
// InformationCutout SizeCutoutSettingƓl\Ă邽
// Monitoring wb_̃TCYݒ肷悤ɏC
#if 1  // ===================================================================
void CSviStatus::setMonheader(MON_HEADER Monheader)
{
	SviMonheader = Monheader;
}

MON_HEADER CSviStatus::getMonheader()
{
	return SviMonheader;
}
#endif // ===================================================================
// 2005.03.30 V3.01 *********************************************************
