// SviUsbControl.h: CSviUsbControl NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_)
#define AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SviStatus.h"
#include SVIUSB20_H
#include "FrameData.h"

//SVIUSB2.0hCoɑ΂鑀bv܂B
class CSviUsbControl  
{
public:
	int GetSelBoardNo();
	void SetSelBoardNo(int no);
	ULONG ulSelBoardNo;
	DWORD ScanBoard();
	ULONG GetDeviceID(int no);
	ULONG ulBoardNum;
	ULONG ulBoardInfo[4];
	ULONG GetBoardNum();
	int m_iMonTimeout;
	bool getBoardInfo(int *iBoardVer, int *iPllData);
	bool setEdgeMode(bool bEdgeMode);
	bool setSyncMode(bool bSyncMode);
	bool setBitCounts(int bits);
	//RXgN^
	CSviUsbControl();

	virtual ~CSviUsbControl();

	//SVIn[hEFA܂
	bool DeviceReset(void);

	//SVIhCoI[v܂
	bool open(void);

	//SVIXe[^XXV܂(onlyBaseStatus : {Xe[^X̂ݍXVj
	bool refreshStatus(bool onlyBaseStatus = false);

	//SVIXe[^X擾܂
	CSviStatus* getStatus(void){return &SviStatus;};

	//G[R[h擾܂BiG[R[h͏܂B)
	DWORD getLastError(void);

	//G[R[h𕶎ɕϊ܂B
	CString getLastErrorString(DWORD errorcode);

	//SVIn[hEGAɐݒʒm܂
	bool setParam(bool bMonMode, int iPicType);

	//j^OJn܂
	bool startMonitoring(int left,int top, int width, int height);

	//j^O~܂
	bool stopMonitoring(PictureType PicType);

	//j^Ot[f[^擾܂
	bool getMonitoringFrameData(CFrameData* frameData);

	//ۗt[f[^݂邩`FbN܂
	bool IsFramePending(void);

	//AChԂ`FbN܂B
	bool IsIdle(void);

	//SVIhCoN[Y܂
	void close();

private:
	void setVsyncSignal(int iMode);

	//G[`FbNPiprivate)
	bool CSviUsbControl::checkLastError(void);

	//hCopMobt@ƃj^Opobt@J
	void freeMem(void)
	{
		if(pReceiveBuff != NULL)delete[] pReceiveBuff;
		pReceiveBuff = NULL;
	}

	//^[R[h
	DWORD RC;

	//SVIn[hEGAXe[^X
	CSviStatus SviStatus;

	//hCoɓnobt@
	char* pReceiveBuff;


	//NeBJZNV
	CCriticalSection cs;

};

#endif // !defined(AFX_SVIUSBCONTROL_H__19B3D7F6_CEA6_4B17_9A40_CAD728E223C3__INCLUDED_)
