// PluginAccess.cpp: CPluginAccess NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PluginAccess.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

//RXgN^ŃAvP[VʂƃCEChẼnhnĂB
CPluginAccess::CPluginAccess()
{
	//ȍ
	hDLL = NULL;
	PluginID = -1;
	PluginStarted = false;
	hPluginWnd = NULL;
}

CPluginAccess::~CPluginAccess()
{

	if(IsStarted() == true)
	{
		ExitPlugin();
	}
	if (hDLL != NULL)
	{
		FreeLibrary(hDLL);
	}
}

//NX܂BgpOɍŏɕKĂяoĂB
void CPluginAccess::InitStatus(enumApp appMode, HWND hWnd, int pluginID)
{
	AppMode = appMode;
	hMainWnd = hWnd;
	PluginID = pluginID;
}

//vOC[h܂B
bool CPluginAccess::LoadPlugin(CString fileName)
{
	
	//vOCǂݍ݂܂
	hDLL = LoadLibrary(fileName);
	if (hDLL == NULL)
	{
		return false;//dllł͂Ȃ
	}
	

	//"plg_sviGetPluginInfo"̎擾
	LPFNDLLFUNC getInfoFunc =(LPFNDLLFUNC)GetProcAddress(hDLL,DEF_PROCNAME_INFO);
	if(getInfoFunc == NULL)
	{
		//vOCDEF_PROCNAME_INFO
		FreeLibrary(hDLL);
		hDLL = NULL;
		return false;
	}

	char callGlobalMemName[128];//Lݒ
	BOOL bPMode;//ĂяoʃtO
	if(AppMode == SVIView)
	{
		strcpy_s(callGlobalMemName,128,SHARED_VIEWER_NAME);
		bPMode = VMODE;
	}
	else if(AppMode == SVIMon)
	{
		strcpy_s(callGlobalMemName,128,SHARED_RECORDER_PLUGIN);
		bPMode = RMODE;
	}
	else ASSERT(false);

	
	char pluginInfo[128]; //vOC擾p
	int iSpec;//vOC擾p

	//vOC擾
#if 1 // 2005.12.21 V3.32 vOC֌ĂяoAvʂʒm
	getInfoFunc(hMainWnd,bPMode,callGlobalMemName,pluginInfo,&iSpec);
#else
	getInfoFunc(hMainWnd,FALSE,callGlobalMemName,pluginInfo,&iSpec);
#endif

	//","ŕ܂
	char *next_token1 = NULL;
	PluginName = strtok_s(pluginInfo,",",&next_token1);
	Version = strtok_s(NULL,",",&next_token1);
	StartupFuncName = strtok_s(NULL,",",&next_token1);

	//vOC
	if((iSpec&SPEC_MSK) == SPEC_MON)
	{
		PluginMode = SVIMon;
	}
	else if((iSpec&SPEC_MSK) == SPEC_VIEW)
	{
		PluginMode = SVIView;
	}
	else if((iSpec&SPEC_MSK) == SPEC_COMMON)
	{
		PluginMode = SVICommon;
	}
	else
	{
		FreeLibrary(hDLL);
		hDLL = NULL;
		return false;

	}

	//vOCʂ̃AvP[Vp`FbN
	if(PluginMode != AppMode && PluginMode != SVICommon)
	{
		FreeLibrary(hDLL);
		hDLL = NULL;
		return false;
	}

	//I[gN
	if((iSpec&AUTOSTART_MSK) == PLG_AUTO_ON)
	{
		AutoStartup = true;
	}
	else
	{
		AutoStartup = false;
	}
	

	if(AutoStartup == true)
	{
		//Ns
		return StartupPlugin();//vOCN
	}

	return true;
}

//vOCN܂B
bool CPluginAccess::StartupPlugin(void)
{
	if(hDLL==NULL)
	{
		return false;
	}
	
	//vOCNς݂ȂANeBuɂB
	if(PluginStarted == true)
	{
		SetForegroundWindow(this->hPluginWnd);
		return true;
	}

	//"plg_sviGetPluginInfo"̎擾
	PSHOWDIALOG getCreatePluginFunc = (PSHOWDIALOG)GetProcAddress(hDLL,StartupFuncName);

	if(getCreatePluginFunc == NULL)
	{
		return false;
	}

	//vOCN
	getCreatePluginFunc(PluginID);
	PluginStarted = true;
	return true;
}

//vOCI܂BiWM_CLOSEPARENTS̑Mj
bool CPluginAccess::ExitPlugin(void)
{
	//ڑmF
	if(IsConnect()==true)
	{
		//IbZ[W𑗐M
		PostMessage(hPluginWnd,WM_CLOSEPARENTS,NULL,NULL);
		//bZ[WMEChEnhJ
		hPluginWnd = NULL;
	}

	//s
	if(IsStarted()==true)
	{
		//I֐̎擾
		PWAITSIGNAL getExitPluginFunc = (PWAITSIGNAL)GetProcAddress(hDLL,DEF_PROCNAME_WAIT);
		if(getExitPluginFunc == NULL)
		{
			return false;
		}

		//I֐Ăяo
		getExitPluginFunc();
		PluginStarted = false;
	}
	return true;
}

//w胁bZ[W|Xg܂B
bool CPluginAccess::postMessageToPlugin(UINT Msg, WPARAM wParam, LPARAM lParam)
{
	//ڑmF
	if(IsConnect()==true)
	{
		BOOL rc = PostMessage(hPluginWnd,Msg,wParam,lParam);
		if(rc == TRUE)
		{
			return true;
		}
	}
	return false;
}



