/********************************************************************/
/*	SVIPlugin Common Header											*/
/********************************************************************/
#ifndef	_SVIPLUGINCOMM_H
#define	_SVIPLUGINCOMM_H

#include <stdio.h>
#include <stdlib.h>

/********************************************************/
/*	SVIUSB.h`										*/
/********************************************************/
#define SVIUSB20_H	"SVIUSB20.h"

/********************************************************/
/*	`												*/
/********************************************************/
typedef WORD			DMAD;				// DMA]f[^^Cv
typedef DMAD*			PDMAD;				// DMADւ̃|C^^

/********************************************************/
/*	YUV,RGB֘A											*/
/********************************************************/
#define	YUVLENGTH	4	// YUV
#define	RGB24LENGTH	3	// 24BitRGB
#define	RGB16LENGTH	2	// 16BitRGB

#define CONV_OFFSET	1000	// YUVϊItZbg

/********************************************************/
/*	t[̍ő吔									*/
/********************************************************/
#define	MAX_FRAME	500		// 擾t[̍ő吔

/********************************************************/
/*	1t[őTCY									*/
/********************************************************/
#define	MAX_FRAMEXSIZE	1600			// 1t[̍őwTCY
#define	MAX_FRAMEYSIZE	1600			// 1t[̍őxTCY

#define	MAX_FRAMESIZE	0x800000		// 1t[̏őTCY

/********************************************************/
/*	ԋplyѐ^Ul									*/
/********************************************************/
#define DEF_OK			1	// 
#define	DEF_ERR			-1	// ُ
#define	DEF_READ		1	// rbg}bvt@CǍ
#define DEF_UNREAD		-1	// rbg}bvt@CǍ
#define DEF_PREVIEW		1	// 摜vr[
#define DEF_UNPREVIEW	0	// 摜Xgbv
#define DEF_NONMON		-2	// obt@㏑
#define DEF_NONFRAME	-3	// Jo͉摜TCY0̂Ƃ
#define DEF_OVER64M		-4	// j^Ot[TCY64MB𒴂ꍇ 2004.03.22 kimura-add
#define DEF_NOTFOUNDPLG	-1	// vOCȂꍇ

/********************************************************/
/*	萔												*/
/********************************************************/
#define	MAX_16		16		// 萔16
#define	MAX_32		32		// 萔32
#define	MAX_64		64		// 萔64
#define	MAX_128		128		// 萔128
#define	MAX_256		256		// 萔256
#define	MAX_512		512		// 萔512
#define	MAX_1024	1024	// 萔1024
#define MAX_2048	2048	// 萔2048

#define MAX_FILEPATH	MAX_PATH + 1

/********************************************************/
/*	G[bZ[W									*/
/********************************************************/
#define	MSG_ERR_SHAREDMEMORY			"A shared memory was not securable."				// LmۂłȂƂ
#define	MSG_ERR_SHAREDMEMORYMUPPING		"Mapping of a shared memory went wrong."			// L̃}bsOɎsƂ
#define	MSG_ERR_SHAREDMEMORYNOTFOUND	"The shared memory is not secured."					// LȂƂ
#define MSG_ERR_BUFFERERROR				"Reservation of a buffer went wrong."				// obt@mێs
#define MSG_ERR_INPUTDATA				"An error is in an input."							// ̓f[^Ɍ肪ꍇ

/********************************************************/
/*	EBhEbZ[W								*/
/********************************************************/
// CommonbZ[W
#define	COMMONMESSAGE		WM_USER + 100

/********************************************************/
/*	ʃ֘A										*/
/********************************************************/
// eʃ
#define	SHARED_RECORDER_NAME		"SharedMonr"			// SVIMonpʃ
#define SHARED_RECORDER_PLUGIN		"SharedMonPlugin"		// vOCpRecorderʃ
#define	SHARED_VIEWER_NAME			"SharedView"			// SVIViewpʃ
#define SHARED_VIEWERONLY_NAME		"SharedViewOnly"		// SVIViewOnlypʃ

// eʃTCY
#define MONITORING_BUFFER_SIZE		0x4000000
#define	SHARED_MEMORY_SIZE			0x10000000				// ʃTCYi256MBj

/********************************************************/
/*	Datwb_֘A										*/
/********************************************************/
#define DEF_8BITSDAT	0	// 8BitsDatt@C
#define DEF_16BITSDAT	1	// 16BitsDatt@C
#define	DEF_OTHERFILE	2	// ُt@C

#define	DEF_SIGNPLUS	"+"
#define	DEF_SIGNMINUS	"-"

/********************************************************/
/*	AutoResize֘A										*/
/********************************************************/
#define DEF_AUTORESIZE		1
#define DEF_UNAUTORESIZE	0

/********************************************************/
/*	摜J[֘A										*/
/********************************************************/
//PictureTypeݒ
typedef enum enumPictureType
{
	PicYUV = 0,	//R[fBOAj^O摜f[^UYVYƂ݂Ȃ܂
	PicRGB,		//R[fBOAj^O摜f[^RGB565Ƃ݂Ȃ܂
	PicY,		//R[fBOAj^O摜f[^Y(RAW-8rbg)Ƃ݂Ȃ܂
	PicYUY2,	//R[fBOAj^O摜f[^YUY2Ƃ݂Ȃ܂
	PicYVYU,	//R[fBOAj^O摜f[^YVYUƂ݂Ȃ܂
	PicVYUY,	//R[fBOAj^O摜f[^VYUYƂ݂Ȃ܂
	PicY10,		//R[fBOAj^O摜f[^Y(RAW-10rbg)Ƃ݂Ȃ܂
	PicY12,		//R[fBOAj^O摜f[^Y(RAW-12rbg)Ƃ݂Ȃ܂
	PicUYVY16,	//R[fBOAj^O摜f[^UYVY-16rbgƂ݂Ȃ܂
	PicVYUY16,	//R[fBOAj^O摜f[^VYUY-16rbgƂ݂Ȃ܂
	PicYUY216,	//R[fBOAj^O摜f[^YUY2-16rbgƂ݂Ȃ܂
} PictureType, *PPictureType;

/********************************************************/
/*	t@C									*/
/********************************************************/
#define SVI_INIFILE			"SVIcomm.ini"		// init@C

// ʕ
#define	DEF_APPCOMMNAME			"SVI"				// ZNV
#define	DEF_MAXBUFFSIZEKEY		"MAXBUFFSIZE"		// j^Opobt@TCYL[
#define DEF_MAXFRAMEXSIZEKEY	"MAXFRAMEXSIZE"		// MAXFRAMEXSIZEL[
#define DEF_MAXFRAMEYSIZEKEY	"MAXFRAMEYSIZE"		// MAXFRAMEYSIZEL[
#define	DEF_SHAREDMEMORYSIZEKEY	"SHAREDMEMORYSIZE"	// RecorderLTCYL[

extern	_TCHAR	ggszCommIniFile[MAX_FILEPATH];	// init@CpX

/********************************************************/
/*	ʊ֐											*/
/********************************************************/

/********************************************************************/
/*	֐hcFIsFigure												*/
/*	֐́F`FbN										*/
/*	@\TvF^ꂽ񂪐ϊłDEF_OK,				*/
/*			  ϊłȂDEF_NGԂ						*/
/********************************************************************/
int	IsFigure(
			CString& strCheckData );	// [IN] `FbNf[^

/********************************************************************/
/*	֐hcFCreateMapping											*/
/*	֐́FL}bsO									*/
/*	@\TvFL}bsO							*/
/*  ߂l  F\z/ُ											*/
/********************************************************************/
int CreateMapping(
				HANDLE*	hMapping,				// [IO] L}bsOnh
				DWORD	dwMemorySize,			// [IN] LmۃTCY
				CString	strSharedMemoryName );	// [IN] L

/********************************************************************/
/*	֐hcFCheckMapping											*/
/*	֐́F}bvr[`FbN									*/
/*	@\TvF}bvꂽr[`FbN						*/
/*  ߂l  F/ُ												*/
/********************************************************************/
int CheckMapping(
						HANDLE*	hMapping,			// [IO] L}bsOnh
						void*	pMapViewAddress );	// [IN] }bvꂽr[̊JnAhX

/********************************************************************/
/*	֐hcFOpenMapping											*/
/*	֐́FLI[v									*/
/*	@\TvFLI[v								*/
/*  ߂l  F\z/ُ											*/
/********************************************************************/
int OpenMapping(
				DWORD	dwDesiredAccess,		// [IN] LANZX[h
				HANDLE*	hMapping,				// [IO] L}bsOnh
				CString	strSharedMemoryName );	// [IN] L

/********************************************************************/
/*	֐hcFCreateSharedMemory									*/
/*	֐́FL\z										*/
/*	@\TvFL\ziBYTE^j						*/
/*  ߂l  Fnh												*/
/********************************************************************/
HANDLE CreateSharedMemory(
							  LPBYTE*	pDataBuff,				// [OUT] Lւ̃|C^
							  HANDLE	hMapping,				// [IN]  L̃nh
							  DWORD		dwSharedMemorySize,		// [OUT] L̃TCY
							  CString	strSharedName );		// [IN]  L

/********************************************************************/
/*	֐hcFCreateSharedMemory									*/
/*	֐́FL\z										*/
/*	@\TvFL\ziBYTE^j						*/
/*  ߂l  Fnh												*/
/********************************************************************/
HANDLE CreateSharedMemory(
							  PDMAD*	pDataBuff,				// [OUT] Lւ̃|C^
							  HANDLE	hMapping,				// [IN]  L̃nh
							  DWORD		dwSharedMemorySize,		// [OUT] L̃TCY
							  CString	strSharedName );		// [IN]  L

/********************************************************************/
/*	֐hcFCalcPadding											*/
/*	֐́FpfBOvZ										*/
/*	@\TvF摜̃pfBOvZ							*/
/*  ߂l  F쐬/ُ											*/
/********************************************************************/
DWORD CalcPadding( DWORD dwXSize );

#endif	// _SVIPLUGINCOMM_H
