// ColorBarDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SVIMon.h"
#include "ColorBarDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorBarDialog _CAO


CColorBarDialog::CColorBarDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CColorBarDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColorBarDialog)
	//}}AFX_DATA_INIT
	Create(IDD_COLORBAR_DIALOG,pParent);
}


void CColorBarDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorBarDialog)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CColorBarDialog, CDialog)
	//{{AFX_MSG_MAP(CColorBarDialog)
	ON_WM_CTLCOLOR()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorBarDialog bZ[W nh
void CColorBarDialog::OnCancel() 
{
	this->DestroyWindow();
//	CDialog::OnCancel();
}

void CColorBarDialog::OnOK() 
{
	this->DestroyWindow();
//	CDialog::OnOK();
}


//}EẌʒuAFݒ肵܂B
// 2006.02.16 V3.33 *********************************************************
#if 1
void CColorBarDialog::SetMousePoint(CPoint point,CRGB rgb,CYUV yuv,PBYTE pbData)
#else
void CColorBarDialog::SetMousePoint(CPoint point,CRGB rgb,CYUV yuv)
#endif
// 2006.02.16 V3.33 *********************************************************
{
	CString str;

	CEdit *pedit = (CEdit*)this->GetDlgItem(IDC_MOUSEPOINT);
	str.Format("%d,%d",point.x,point.y);
	pedit->SetWindowText(str);

	SetEditVal(ID_YUV_Y,yuv.Y);
	SetEditVal(ID_YUV_U,yuv.U);
	SetEditVal(ID_YUV_V,yuv.V);
	SetEditVal(ID_RGB_R,rgb.R);
	SetEditVal(ID_RGB_G,rgb.G);
	SetEditVal(ID_RGB_B,rgb.B);

	m_rgb = rgb;
// 2005.03.28 V3.01 *********************************************************
// OnCtrColorăRg[̃uVύX
// CreateuVǂłDeleteĂȂB
// ̂GDIIuWFNgAŌɃnOAbvĂ܂B
// CStatic̔hNX쐬ÃNXWM_PAINTMA
// FillRectgĔwiFύXB
#if 1  // ===================================================================
	m_DrawStatic.DrawBkColor(m_rgb);
#else  // ===================================================================
	CStatic *pColor = (CStatic*)this->GetDlgItem(ID_COLORBOX);
	pColor->Invalidate();
#endif  // ===================================================================
// 2005.03.28 V3.01 *********************************************************
// 2006.02.16 V3.33 *********************************************************
// t[̂WW̐f[^HEX_v\܂
	{
		CString str;
		CEdit *pedit = (CEdit*)GetDlgItem(IDC_COLORDUMP);
		int i,j;
		char buf[32*8];
		for(i=j=0;i<8;i++){
			sprintf_s(&buf[j], (32*8)-j, "%02X,%02X,%02X,%02X,%02X,%02X,%02X,%02X\n",
					*(pbData+0),*(pbData+1),*(pbData+2),*(pbData+3),
					*(pbData+4),*(pbData+5),*(pbData+6),*(pbData+7));
			pbData += 8;
			j = (int)strlen(buf);
		}
		pedit->SetWindowText(buf);
	}
// 2006.02.16 V3.33 *********************************************************
}


void CColorBarDialog::SetEditVal(UINT id , int value)
{
	CString str;
	CEdit *pedit = (CEdit*)GetDlgItem(id);
	str.Format("%d",value);
	pedit->SetWindowText(str);
}

HBRUSH CColorBarDialog::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);	
	switch ( pWnd->GetDlgCtrlID() ) {
    case ID_COLORBOX :
// 2005.03.28 V3.01 *********************************************************
// OnCtrColorăRg[̃uVύX
// CreateuVǂłDeleteĂȂB
// ̂GDIIuWFNgAŌɃnOAbvĂ܂B
// CStatic̔hNX쐬ÃNXWM_PAINTMA
// FillRectgĔwiFύXB
#if 0  // ===================================================================
        pDC->SetBkColor(m_rgb);
        hbr = CreateSolidBrush(m_rgb);
#endif  // ===================================================================
// 2005.03.28 V3.01 *********************************************************
        break;
    }
	
	// TODO: ftHg̃uV]݂̂̂łȂꍇɂ́AႤuVԂĂ
	return hbr;
}


//EChEjꂽɌĂяo܂
void CColorBarDialog::PostNcDestroy() 
{
	//j[̃J[o[̃`FbN͂
	AfxGetMainWnd()->GetMenu()->CheckMenuItem(ID_COLOR_BAR , MF_BYCOMMAND | MF_UNCHECKED);

	//鎞newĂ̂Ŏg폜
	delete this;

	CDialog::PostNcDestroy();
}

// 2005.03.28 V3.01 *********************************************************
// OnCtrColorăRg[̃uVύX
// CreateuVǂłDeleteĂȂB
// ̂GDIIuWFNgAŌɃnOAbvĂ܂B
// CStatic̔hNX쐬ÃNXWM_PAINTMA
// FillRectgĔwiFύXB
#if 1  // ===================================================================
BOOL CColorBarDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	m_DrawStatic.AutoLoad(ID_COLORBOX, this);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
#endif  // ===================================================================
// 2005.03.28 V3.01 *********************************************************
