// FrameData.cpp: CFrameData NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SVIMon.h"
#include "FrameData.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CFrameData::CFrameData()
{
	ImageSize=0;//摜̃TCY
	ImageData = NULL;//摜f[^
// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 1  // ===================================================================
	inputYUVMode = PicYUV;//ftHgYUV[h
#else  // ===================================================================
	inputYUVMode = true;//ftHgYUV[h
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************
}

CFrameData::~CFrameData()
{
	if(ImageData != NULL)
	{
		delete[] ImageData;
		ImageData	= NULL;
	}
}

//t[wb_ݒ肵܂B
void CFrameData::setFrameHeader(MON_HEADER* header)
{
	memcpy(&FrameHeader,header,sizeof(MON_HEADER));

	//摜TCY̌vZ
	ULONG newImageSize;
#if 1 // 2006.01.29 V3.33 FPGA220Ή
	if(inputYUVMode == PicYUV || inputYUVMode == PicRGB || inputYUVMode == PicYUY2 || inputYUVMode == PicVYUY || inputYUVMode == PicYVYU){
		newImageSize = (FrameHeader.ulMonSizeW << 1) * FrameHeader.ulMonSizeH;
	}else if(inputYUVMode == PicY){
		newImageSize = (FrameHeader.ulMonSizeW << 0) * FrameHeader.ulMonSizeH;
	}else if(inputYUVMode == PicY10 || inputYUVMode == PicY12){
		newImageSize = (FrameHeader.ulMonSizeW << 1) * FrameHeader.ulMonSizeH;
	}else if(inputYUVMode == PicUYVY16 || inputYUVMode == PicVYUY16){
		newImageSize = (FrameHeader.ulMonSizeW << 1) * FrameHeader.ulMonSizeH;
#if 1 // 2006.03.22 V3.3.6.0
	}else if(inputYUVMode == PicYUY216){
		newImageSize = (FrameHeader.ulMonSizeW << 1) * FrameHeader.ulMonSizeH;
#endif // 2006.03.22 V3.3.6.0
	}
#else // 2006.01.29 V3.33
#if 1 // 2005.12.28 V3.32
	if( inputYUVMode == PicY10 || inputYUVMode == PicY12 || inputYUVMode == PicVYUY16 || inputYUVMode == PicUYVY16)
#else // 2005.12.28 V3.32
	if( inputYUVMode == PicY10 || inputYUVMode == PicY12)
#endif // 2005.12.28 V3.32
		newImageSize = (FrameHeader.ulMonSizeW << 2) * FrameHeader.ulMonSizeH;
	else
		newImageSize = (FrameHeader.ulMonSizeW << 1) * FrameHeader.ulMonSizeH;
#endif // 2006.01.29 V3.33

	// C[WTCY64̃oE_ɏ悹
	newImageSize = ((newImageSize + 63) / 64) * 64;

	if(newImageSize != (UINT)ImageSize)
	{
		if(ImageData != NULL)
		{
			delete[] ImageData;
			ImageData	= NULL;
		}
		//摜ۑ̈TCYύX
		ImageData = new unsigned char[newImageSize];
		ImageSize = newImageSize;
	}
}

//24bit-BitmaptH[}bg摜̃f[^쐬܂B
//
//bitmapBuff:o̓obt@̃|C^
//buffSize:o̓obt@̃TCY
//file:t@Cwb_t邩
//infoHeader:BITMAPINFOwb_t邩
//rect:Nbv̈ ͋ŗ^Ă)
bool CFrameData::get24Bitmap(char* bitmapBuff, int buffSize, bool infoHeader, bool fileHeader, CRect* clip = NULL)
{
	if(ImageData == NULL)
	{
		return false;//YUVf[^܂
	}
// 2005.03.30 V3.01 *********************************************************
// GDI`捂
#if 1  // ===================================================================
	if(bitmapBuff == NULL)
	{
		return false;	// RGBobt@Ȃ
	}
#endif // ===================================================================
// 2005.03.30 V3.01 *********************************************************

	//Nbv̈̒
	int clipLeft,clipTop,clipWidth,clipHeight;
	int imageWidth = getImageSizeWidth();    // FrameHeader.ulMonSizeW
	int imageHeight = getImageSizeHeight();  // FrameHeader.ulMonSizeH

#if 0 // 2006.01.29 V3.33 FPGA220Ή
// 2005.09.15 V3.22 *********************************************************
	if(IsYMode()) imageWidth <<= 1;
#if 1 // 2005.12.28 V3.32
	else if(inputYUVMode==PicY10 || inputYUVMode==PicY12  || inputYUVMode==PicUYVY16  || inputYUVMode==PicVYUY16) imageWidth <<= 1;
#else // 2005.12.28 V3.32
	else if(inputYUVMode==PicY10 || inputYUVMode==PicY12 ) imageWidth <<= 1;
#endif // 2005.12.28 V3.32
// 2005.09.15 V3.22 *********************************************************
#endif // 2006.01.29 V3.33 FPGA220Ή

	if(clip == NULL)//clipgĕKvNbv܂
	{
		clipLeft = 0;
		clipTop = 0;
		clipWidth = imageWidth;
		clipHeight = imageHeight;
	}
	else
	{
		clipLeft = clip->left;
		clipTop = clip->top;
		clipWidth = clip->right;
		clipHeight = clip->bottom;

		if((clipWidth % 2) == 1)//Ŗꍇ+1
		{
			clipWidth += 1;
		}
		//摜TCYNbv̈悪ĂȂ`FbN
		ASSERT(clipLeft < imageWidth);
		ASSERT(clipTop < imageHeight);

		//⍂Ăꍇɂ͏C
		if((clipLeft+clipWidth) > imageWidth)
		{
// 2005.09.15 V3.22 *********************************************************
#if 1
			clipWidth = imageWidth-clipLeft;
#else
			clipWidth = getImageSizeWidth()-clipLeft;
#endif
// 2005.09.15 V3.22 *********************************************************
			clipWidth = getImageSizeWidth()-clipLeft;
		}
		if((clipTop+clipHeight) > imageHeight)
		{
// 2005.09.15 V3.22 *********************************************************
#if 1
			clipHeight = imageHeight-clipTop;
#else
			clipHeight = getImageSizeHeight()-clipTop;
#endif
// 2005.09.15 V3.22 *********************************************************
		}

	}

	//Bitmappwb_
	BITMAPFILEHEADER bitmapFileHeader;
	BITMAPINFO bitmapInfo;
	
	if(fileHeader == true || infoHeader == true)
	{
		if(get24BitmapSize(fileHeader) > buffSize)
		{
			return false;//obt@s
		}
		//t@Cwb_[쐬
		bitmapFileHeader.bfType = 0x4D42;
		bitmapFileHeader.bfSize = get24BitmapSize(true);
		bitmapFileHeader.bfReserved1 = 0;
		bitmapFileHeader.bfReserved2 = 0;
		bitmapFileHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);


		//rbg}bvCtH쐬
		bitmapInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bitmapInfo.bmiHeader.biWidth = clipWidth;
		bitmapInfo.bmiHeader.biHeight = clipHeight;
		bitmapInfo.bmiHeader.biPlanes = 1;
		bitmapInfo.bmiHeader.biBitCount = 24;
		bitmapInfo.bmiHeader.biCompression = BI_RGB;
		bitmapInfo.bmiHeader.biSizeImage = get24BitmapImageDataSize(clipWidth,clipHeight);
		bitmapInfo.bmiHeader.biXPelsPerMeter = 0;
		bitmapInfo.bmiHeader.biYPelsPerMeter = 0;
		bitmapInfo.bmiHeader.biClrUsed = 0;
		bitmapInfo.bmiHeader.biClrImportant = 0;
		//bitmapInfo.bmiColors = 0;//J[pbg

		if(fileHeader == true)
		{
			//t@Cwb_o
			memcpy(bitmapBuff,&bitmapFileHeader,sizeof(BITMAPFILEHEADER));
			bitmapBuff += sizeof(BITMAPFILEHEADER);

			//rbg}bvCtHwb_o
			memcpy(bitmapBuff,&bitmapInfo.bmiHeader,sizeof(BITMAPINFOHEADER));
			bitmapBuff += sizeof(BITMAPINFOHEADER);
		}
#if 1 // 2005.07.29 V3.20 Ctrl+Cǉ******************************
		else if(infoHeader == true)
		{
			//rbg}bvCtHwb_o
			memcpy(bitmapBuff,&bitmapInfo.bmiHeader,sizeof(BITMAPINFOHEADER));
			bitmapBuff += sizeof(BITMAPINFOHEADER);
		}
#else  // 2005.07.29 V3.20 ===========================================
		else if(infoHeader == true)
		{
			//rbg}bvCtHwb_o
			memcpy(bitmapBuff,&bitmapInfo,sizeof(BITMAPINFO));
			bitmapBuff += sizeof(BITMAPINFO);
		}
#endif // 2005.07.29 V3.20 *******************************************
	}
	else
	{
		if(get24BitmapImageDataSize(clipWidth,clipHeight) > buffSize)
		{
			return false;//obt@s
		}

	}


	//Bitmap1Line4byteEłȂ΂Ȃ
	//4byteEvZ
	int byteSplit = (clipWidth*3) % 4;

	CRGB rgb;//Ɨp
	//sNZƂɕ`(bitmapł͉̕ɕ`悷j
	if(IsYUVMode() == true) // UYVY
	{
		// UYUVf[^iYUVf[^i#elseȉłYUVf[^ɑjUYUVf[^ɕύXBj
		// for̃[vɂĂ͈ȑÕvÔ܂ܗpB܂Ƃ߂Ƃ邪ȑÔ܂܎gpB
//		int len = (clipTop+clipHeight-1) * imageWidth;
		int len = (clipTop+clipHeight-1) * (imageWidth<<1); // 2006.01.29 v3.33
		int clipX = (clipLeft+clipWidth)-2;
		int x;
		int y;
		for(y = (clipTop+clipHeight)-1; y >= clipTop; y--)
		{
//			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<1);
			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<0); // 2006.01.29 V3.33
			for(x = clipLeft; x < clipX; x+=2)
			{
				rgb.setYUV(*(pixcel+1),*pixcel,*(pixcel+2), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
				//Qfڂ̋ߕύXiȑO͎YUVt[UVf[^擾Ă̂߂j
				rgb.setYUV(*(pixcel+3), *pixcel, *(pixcel+2),bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
				bitmapBuff += 6;
				pixcel += 4;
			}
			rgb.setYUV(*(pixcel+1),*pixcel,*(pixcel+2), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
			rgb.setYUV(*(pixcel+3),*pixcel,*(pixcel+2), bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
			bitmapBuff += 6;
			bitmapBuff += byteSplit;
//			len -= imageWidth;
			len -= (imageWidth<<1); // 2006.01.29 v3.33
		}
	}
#if 1  // 2005.12.26 V3.32 UYVY16ǉ******************************
	else if(IsUYVY16Mode() == true) // UYVY-16bit
	{
		// UYUVf[^iYUVf[^i#elseȉłYUVf[^ɑjUYUVf[^ɕύXBj
		// for̃[vɂĂ͈ȑÕvÔ܂ܗpB܂Ƃ߂Ƃ邪ȑÔ܂܎gpB
//		int len = (clipTop+clipHeight-1) * (imageWidth<<0);
		int len = (clipTop+clipHeight-1) * (imageWidth<<1); // 2006.01.29 V3.33
		int clipX = (clipLeft+clipWidth)-2;
		int x;
		int y;
		for(y = (clipTop+clipHeight)-1; y >= clipTop; y--)
		{
//			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<1);
			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<0); // 2006.01.29 V3.33
			for(x = clipLeft; x < clipX; x+=2)
			{
				rgb.setYUV(*(pixcel+1),*pixcel,*(pixcel+2), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
				//Qfڂ̋ߕύXiȑO͎YUVt[UVf[^擾Ă̂߂j
				rgb.setYUV(*(pixcel+3), *pixcel, *(pixcel+2),bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
				bitmapBuff += 6;
				pixcel += 4;
			}
			rgb.setYUV(*(pixcel+1),*pixcel,*(pixcel+2), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
			rgb.setYUV(*(pixcel+3),*pixcel,*(pixcel+2), bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
			bitmapBuff += 6;
			bitmapBuff += byteSplit;
//			len -= (imageWidth<<0);
			len -= (imageWidth<<1); // 2006.01.29 V3.33
		}
	}
#endif // 2005.12.26 V3.32 UYVY16ǉ******************************
//	else if(IsYUY2Mode() == true) // YUYV
	else if(IsYUY2Mode() == true || IsYUY216Mode() == true) // 2006.03.22 V3.3.6.0 YUYV
	{
		// YUY2f[^
//		int len = (clipTop+clipHeight-1) * imageWidth;
		int len = (clipTop+clipHeight-1) * (imageWidth<<1); // 2006.01.29 V3.33
		int clipX = (clipLeft+clipWidth)-2;
		int x;
		int y;
		for(y = (clipTop+clipHeight)-1; y >= clipTop; y--)
		{
//			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<1);
			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<0); // 2006.01.29 V3.33
			for(x = clipLeft; x < clipX; x+=2)
			{
				rgb.setYUV(*pixcel,*(pixcel+1),*(pixcel+3), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
				rgb.setYUV(*(pixcel+2),*(pixcel+1),*(pixcel+3),bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
				bitmapBuff += 6;
				pixcel += 4;
			}
			rgb.setYUV(*pixcel,*(pixcel+1),*(pixcel+3), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
			rgb.setYUV(*(pixcel+2),*(pixcel+1),*(pixcel+3), bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
			bitmapBuff += 6;
			bitmapBuff += byteSplit;
//			len -= imageWidth;
			len -= (imageWidth<<1); // 2006.01.29 V3.33
		}
	}
	else if(IsYVYUMode() == true) // YVYU
	{
		// YVYUf[^
//		int len = (clipTop+clipHeight-1) * imageWidth;
		int len = (clipTop+clipHeight-1) * (imageWidth<<1); // 2006.01.29 V3.33
		int clipX = (clipLeft+clipWidth)-2;
		int x;
		int y;
		for(y = (clipTop+clipHeight)-1; y >= clipTop; y--)
		{
//			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<1);
			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<0); // 2006.01.29 V3.33
			for(x = clipLeft; x < clipX; x+=2)
			{
				rgb.setYUV(*pixcel,*(pixcel+3),*(pixcel+1), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
				rgb.setYUV(*(pixcel+2),*(pixcel+3),*(pixcel+1),bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
				bitmapBuff += 6;
				pixcel += 4;
			}
			rgb.setYUV(*pixcel,*(pixcel+3),*(pixcel+1), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
			rgb.setYUV(*(pixcel+2),*(pixcel+3),*(pixcel+1), bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
			bitmapBuff += 6;
			bitmapBuff += byteSplit;
//			len -= imageWidth;
			len -= (imageWidth<<1); // 2006.01.29 V3.33
		}
	}	
	else if(IsVYUYMode() == true) // VYUY
	{
		// VYUYf[^
//		int len = (clipTop+clipHeight-1) * imageWidth;
		int len = (clipTop+clipHeight-1) * (imageWidth<<1); // 2006.01.29 V3.33
		int clipX = (clipLeft+clipWidth)-2;
		int x;
		int y;
		for(y = (clipTop+clipHeight)-1; y >= clipTop; y--)
		{
//			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<1);
			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<0); // 2006.01.29 V3.33
			for(x = clipLeft; x < clipX; x+=2)
			{
				rgb.setYUV(*(pixcel+1),*(pixcel+2),*pixcel, bitmapBuff+2, bitmapBuff+1, bitmapBuff);
				//Qfڂ̋ߕύXiȑO͎YUVt[UVf[^擾Ă̂߂j
				rgb.setYUV(*(pixcel+3),*(pixcel+2),*pixcel,bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
				bitmapBuff += 6;
				pixcel += 4;
			}
			rgb.setYUV(*(pixcel+1),*(pixcel+2),*pixcel, bitmapBuff+2, bitmapBuff+1, bitmapBuff);
			rgb.setYUV(*(pixcel+3),*(pixcel+2),*pixcel, bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
			bitmapBuff += 6;
			bitmapBuff += byteSplit;
//			len -= imageWidth;
			len -= (imageWidth<<1); // 2006.01.29 V3.33
		}
	}
#if 1  // 2005.12.26 V3.32 VYUY16ǉ******************************
	else if(IsVYUY16Mode() == true) // UYVY-16bit
	{
		// UYUVf[^iYUVf[^i#elseȉłYUVf[^ɑjUYUVf[^ɕύXBj
		// for̃[vɂĂ͈ȑÕvÔ܂ܗpB܂Ƃ߂Ƃ邪ȑÔ܂܎gpB
//		int len = (clipTop+clipHeight-1) * (imageWidth<<0);
		int len = (clipTop+clipHeight-1) * (imageWidth<<1); // 2006.01.29 V3.33
		int clipX = (clipLeft+clipWidth)-2;
		int x;
		int y;
		for(y = (clipTop+clipHeight)-1; y >= clipTop; y--)
		{
//			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<1);
			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft)<<0); // 2006.01.29 V3.33
			for(x = clipLeft; x < clipX; x+=2)
			{
#if 1 // 2010.05.31 V3.6.0.0 VYUY-16UYVY-16RGBϊĂsC
				rgb.setYUV(*(pixcel+1),*(pixcel+2),*(pixcel+0), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
				rgb.setYUV(*(pixcel+3), *(pixcel+2), *(pixcel+0),bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
#endif // 2010.05.31 V3.6.0.0 VYUY-16UYVY-16RGBϊĂsC
				bitmapBuff += 6;
				pixcel += 4;
			}
#if 1 // 2010.05.31 V3.6.0.0 VYUY-16UYVY-16RGBϊĂsC
			rgb.setYUV(*(pixcel+1),*(pixcel+2),*(pixcel+0), bitmapBuff+2, bitmapBuff+1, bitmapBuff);
			rgb.setYUV(*(pixcel+3),*(pixcel+2),*(pixcel+0), bitmapBuff+5, bitmapBuff+4, bitmapBuff+3);
#endif // 2010.05.31 V3.6.0.0 VYUY-16UYVY-16RGBϊĂsC
			bitmapBuff += 6;
			bitmapBuff += byteSplit;
//			len -= (imageWidth<<0);
			len -= (imageWidth<<1); // 2006.01.29 V3.33
		}
	}
#endif // 2005.12.26 V3.32 VYUY16ǉ******************************
	else if(IsRGBMode() == true) // RGB565
	{
		CYUV rgbGetBuff;
		// RGB565f[^
		for(int y=(clipTop+clipHeight)-1; y >= clipTop; y--)
		{
//			int len = (y * imageWidth); // 2006.03.10 V3.35 nop
//			int len = (y * (imageWidth<<1)); // 2006.01.29 V3.33 nop
			for(int x=clipLeft; x < (clipLeft+clipWidth); x++)
			{
				unsigned char* pixcel = (unsigned char*)ImageData + ((y * imageWidth) + x)*2; // 2006.03.10 V3.35
//				unsigned char* pixcel = (unsigned char*)ImageData + ((y * imageWidth) + x)*1; // 2006.01.29 V3.33
				
				//RGB565->RGBɕ(2005/7/20ʑ͂PŒlƂĈ)
				rgb.SeparationRGB(pixcel[0], pixcel[1], 1);
				//RGB->24bitYUV
				rgbGetBuff=	CYUV((CRGB)rgb);
				//24bitYUV->24bitRGB
				rgb = rgbGetBuff.getRGB();
				bitmapBuff[0] = rgb.B;
				bitmapBuff[1] = rgb.G;
				bitmapBuff[2] = rgb.R;
				bitmapBuff += 3;
			}
			bitmapBuff += byteSplit;
		}
	}
	else if( inputYUVMode == PicY ) // RAW-8bit
	{
		int len = (clipHeight-1) * imageWidth;
		int clipX = (clipLeft+clipWidth)-2;
		for(int y=(clipTop+clipHeight)-1; y >= clipTop; y--)
		{
			unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft));
			for(int x=clipLeft; x < clipX; x+=2)
			{
				*(bitmapBuff+0) = *pixcel; *(bitmapBuff+1) = *pixcel; *(bitmapBuff+2) = *pixcel;
				pixcel++;
				*(bitmapBuff+3) = *pixcel; *(bitmapBuff+4) = *pixcel; *(bitmapBuff+5) = *pixcel;
				pixcel++;
				bitmapBuff += 6;
			}
			*(bitmapBuff+0) = *pixcel; *(bitmapBuff+1) = *pixcel; *(bitmapBuff+2) = *pixcel;
			pixcel++;
			*(bitmapBuff+3) = *pixcel; *(bitmapBuff+4) = *pixcel; *(bitmapBuff+5) = *pixcel;
			pixcel++;
			bitmapBuff += 6;
			bitmapBuff += byteSplit;
			len -= imageWidth;
		}
	}
	else if( inputYUVMode == PicY10 ) // RAW-10bit
	{
		int len = (clipHeight-1) * (imageWidth << 1);
		int clipX = (clipLeft+clipWidth)-2;
		unsigned short pp;
#if 1 // 2006.03.22 V3.3.6.0
		if(dispRawMode == 0){
			for(int y=(clipTop+clipHeight)-1; y >= clipTop; y--)
			{
				unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft));
				for(int x=clipLeft; x < clipX; x+=2)
				{
					pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>2) | (((unsigned short)(*(pixcel+0)) & 0xff)<<6);
					*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
					pixcel+=2;
					pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>2) | (((unsigned short)(*(pixcel+0)) & 0xff)<<6);
					*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
					pixcel+=2;
					bitmapBuff += 6;
				}
				pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>2) | (((unsigned short)(*(pixcel+0)) & 0xff)<<6);
				*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
				pixcel+=2;
				pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>2) | (((unsigned short)(*(pixcel+0)) & 0xff)<<6);
				*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
				pixcel+=2;
				bitmapBuff += 6;
				bitmapBuff += byteSplit;
				len -= (imageWidth << 1);
			}
		}else if(dispRawMode == 1){
			for(int y=(clipTop+clipHeight)-1; y >= clipTop; y--)
			{
				unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft));
				for(int x=clipLeft; x < clipX; x+=2)
				{
					pp = (unsigned short)(*(pixcel+1)) & 0xff;
					*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
					pixcel+=2;
					pp = (unsigned short)(*(pixcel+1)) & 0xff;
					*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
					pixcel+=2;
					bitmapBuff += 6;
				}
				pp = (unsigned short)(*(pixcel+1)) & 0xff;
				*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
				pixcel+=2;
				pp = (unsigned short)(*(pixcel+1)) & 0xff;
				*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
				pixcel+=2;
				bitmapBuff += 6;
				bitmapBuff += byteSplit;
				len -= (imageWidth << 1);
			}
		}
#endif // 2006.03.22 V3.3.6.0
	}
	else if( inputYUVMode == PicY12 ) // RAW-12bit
	{
		int len = (clipHeight-1) * (imageWidth << 1);
		int clipX = (clipLeft+clipWidth)-2;
		unsigned short pp;
#if 1 // 2006.03.22 V3.3.6.0
		if(dispRawMode == 2){
			for(int y=(clipTop+clipHeight)-1; y >= clipTop; y--)
			{
				unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft));
				for(int x=clipLeft; x < clipX; x+=2)
				{
					pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>4) | (((unsigned short)(*(pixcel+0)) & 0xff)<<4);
					*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
					pixcel+=2;
					pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>4) | (((unsigned short)(*(pixcel+0)) & 0xff)<<4);
					*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
					pixcel+=2;
					bitmapBuff += 6;
				}
				pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>4) | (((unsigned short)(*(pixcel+0)) & 0xff)<<4);
				*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
				pixcel+=2;
				pp = (((unsigned short)(*(pixcel+1)) & 0xff)>>4) | (((unsigned short)(*(pixcel+0)) & 0xff)<<4);
				*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
				pixcel+=2;
				bitmapBuff += 6;
				bitmapBuff += byteSplit;
				len -= (imageWidth << 1);
			}
		}else if(dispRawMode == 3){
			for(int y=(clipTop+clipHeight)-1; y >= clipTop; y--)
			{
				unsigned char* pixcel = (unsigned char*)ImageData + ((len + clipLeft));
				for(int x=clipLeft; x < clipX; x+=2)
				{
					pp = (unsigned short)(*(pixcel+1)) & 0xff;
					//pp = ((unsigned short)((*(pixcel+1) >> 2) | (*(pixcel+0) << 6))) & 0xff;
					//pp = (unsigned short)(*(pixcel+1)>>2) & 0xff;
					*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
					pixcel+=2;
					pp = (unsigned short)(*(pixcel+1)) & 0xff;
					//pp = ((unsigned short)((*(pixcel+1) >> 2) | (*(pixcel+0) << 6))) & 0xff;
					//pp = (unsigned short)(*(pixcel+1)>>2) & 0xff;
					*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
					pixcel+=2;
					bitmapBuff += 6;
				}
				pp = (unsigned short)(*(pixcel+1)) & 0xff;
				*(bitmapBuff+0) = (unsigned char)pp; *(bitmapBuff+1) = (unsigned char)pp; *(bitmapBuff+2) = (unsigned char)pp;
				pixcel+=2;
				pp = (unsigned short)(*(pixcel+1)) & 0xff;
				*(bitmapBuff+3) = (unsigned char)pp; *(bitmapBuff+4) = (unsigned char)pp; *(bitmapBuff+5) = (unsigned char)pp;
				pixcel+=2;
				bitmapBuff += 6;
				bitmapBuff += byteSplit;
				len -= (imageWidth << 1);
			}
		}
#endif // 2006.03.22 V3.3.6.0
	}

	return true;
}

//摜̃sNZJ[擾܂
CYUV CFrameData::getPixelYUV(CPoint pixcelPos)
{
// 2006.01.29 V3.33 \[X̂#ifA#elseA#endif폜܂

	//`FbN
	if( IsYMode() == true || IsY10Mode() == true || IsY12Mode() == true ){
		if( ImageData == NULL ||
//			pixcelPos.x >= (getImageSizeWidth()<<1) || pixcelPos.y >= getImageSizeHeight() ||
			pixcelPos.x >= (getImageSizeWidth()<<0) || pixcelPos.y >= getImageSizeHeight() || // 2006.01.29 V3.33
			pixcelPos.x < 0 || pixcelPos.y < 0 )
		{
			return CYUV(0,0,0);//G[
		}
	}else{
		if( ImageData == NULL ||
			pixcelPos.x >= getImageSizeWidth() || pixcelPos.y >= getImageSizeHeight() ||
			pixcelPos.x < 0 || pixcelPos.y < 0 )
		{
			return CYUV(0,0,0);//G[
		}
	}

	int LineSize = getImageSizeWidth() * 2;

	// t[f[^̃J[̎ނ̎ʕ@ύX
	if(IsYUVMode() == true)//YUV[h(UYVY)
	{
		// t[f[^̃J[̎ނ̎ʕ@ύX
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		if(pixcelPos.x%2 == 0)
		{
			//sNZ 0,2,4,6,8.....
			return CYUV(pixcel[1],pixcel[0],pixcel[2]);
		}
		else
		{
			//sNZ 1,3,6,7,9.....
			BYTE U;
			BYTE Y;
			BYTE V;
			if(pixcelPos.x == (getImageSizeWidth()-1))
			{
				//C̍Ō̃sNZ̏ꍇ
				U = pixcel[-2];
				Y = pixcel[1];
				V = pixcel[0];
			}
			else
			{
				U = (pixcel[-2]>>1) + (pixcel[2]>>1);
				Y = pixcel[1];
				V = (pixcel[0]>>1) + (pixcel[4]>>1);
			}
			return CYUV(Y,U,V);
		}
	}
	else if(IsYUY2Mode() == true)//YUY2[h
	{
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		//PsNZɂ͂PUrbg̃f[^蓖ĂĂB
		//Ƃ΁uYUYVYUYVEEEvƂf[^łꍇAPsNZɂ́uYUv
		//̃sNZɂ́uYVvƂɂȂB̂ߊƋsNZł
		//YUV̕тقȂ邽߁Aꍇ킯sB		
		if(pixcelPos.x%2 == 0)
		{
			//sNZ 0,2,4,6,8.....
			return CYUV(pixcel[0],pixcel[1],pixcel[3]);
		}
		else
		{
			//sNZ 1,3,6,7,9.....
			BYTE U;
			BYTE Y;
			BYTE V;
			if(pixcelPos.x != (getImageSizeWidth()-1))
			{
				U = (pixcel[-1]>>1) + (pixcel[3]>>1);
				Y = pixcel[0];
				V = (pixcel[-3]>>1) + (pixcel[1]>>1);
			}
			else
			{
				//C̍Ō̃sNZ̏ꍇ
				U = pixcel[-1];
				Y = pixcel[0];
				V = pixcel[1];
			}
			return CYUV(Y,U,V);
		}
	}
	else if(IsVYUYMode() == true)//VYUY[h
	{
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		if(pixcelPos.x%2 == 0)
		{
			//sNZ 0,2,4,6,8.....
			return CYUV(pixcel[1],pixcel[2],pixcel[0]);
		}
		else
		{
			//sNZ 1,3,6,7,9.....
			BYTE U;
			BYTE Y;
			BYTE V;
			if(pixcelPos.x != (getImageSizeWidth()-1))
			{
				U = (pixcel[0]>>1) + (pixcel[4]>>1);
				Y = pixcel[1];
				V = (pixcel[-2]>>1) + (pixcel[2]>>1);
			}
			else
			{
				//C̍Ō̃sNZ̏ꍇ
				U = pixcel[0];
				Y = pixcel[1];
				V = pixcel[-2];
			}
			return CYUV(Y,U,V);
		}
	}
	else if(IsUYVY16Mode() == true) // 2006.01,29 V3.33 add UYVY16[h
	{
		// t[f[^̃J[̎ނ̎ʕ@ύX
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		if(pixcelPos.x%2 == 0)
		{
			//sNZ 0,2,4,6,8.....
			return CYUV(pixcel[1],pixcel[0],pixcel[2]);
		}
		else
		{
			//sNZ 1,3,6,7,9.....
			BYTE U;
			BYTE Y;
			BYTE V;
			if(pixcelPos.x == (getImageSizeWidth()-1))
			{
				//C̍Ō̃sNZ̏ꍇ
				U = pixcel[-2];
				Y = pixcel[1];
				V = pixcel[0];
			}
			else
			{
				U = (pixcel[-2]>>1) + (pixcel[2]>>1);
				Y = pixcel[1];
				V = (pixcel[0]>>1) + (pixcel[4]>>1);
			}
			return CYUV(Y,U,V);
		}
	}
	else if(IsVYUY16Mode() == true) // 2006.01,29 V3.33 add VYUY16[h
	{
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		if(pixcelPos.x%2 == 0)
		{
			//sNZ 0,2,4,6,8.....
			return CYUV(pixcel[1],pixcel[2],pixcel[0]);
		}
		else
		{
			//sNZ 1,3,6,7,9.....
			BYTE U;
			BYTE Y;
			BYTE V;
			if(pixcelPos.x != (getImageSizeWidth()-1))
			{
				U = (pixcel[0]>>1) + (pixcel[4]>>1);
				Y = pixcel[1];
				V = (pixcel[-2]>>1) + (pixcel[2]>>1);
			}
			else
			{
				//C̍Ō̃sNZ̏ꍇ
				U = pixcel[0];
				Y = pixcel[1];
				V = pixcel[-2];
			}
			return CYUV(Y,U,V);
		}
	}
	else if(IsYVYUMode() == true)//YVYU[h
	{
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		if(pixcelPos.x%2 == 0)
		{
			//sNZ 0,2,4,6,8.....
			return CYUV(pixcel[0],pixcel[3],pixcel[1]);
		}
		else
		{
			//sNZ 1,3,6,7,9.....
			BYTE U;
			BYTE Y;
			BYTE V;
			if(pixcelPos.x != (getImageSizeWidth()-1))
			{
				U = (pixcel[-3]>>1) + (pixcel[1]>>1);
				Y = pixcel[0];
				V = (pixcel[-1]>>1) + (pixcel[3]>>1);
			}
			else
			{
				//C̍Ō̃sNZ̏ꍇ
				U = pixcel[1];
				Y = pixcel[0];
				V = pixcel[-1];
			}
			return CYUV(Y,U,V);
		}
	}
	else if(IsYMode() == true) // RAW-8bit[h
	{
		// RAW8bit,̎LineSizeX1/2{
		LineSize >>= 1; // 1C̃oCg
		//sNZʒu擾
//		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 0); // 2006.01.29 V3.33
		BYTE U = 128;
		BYTE V = 128;
		return CYUV(pixcel[0],U,V);
	}
	else if(IsY10Mode() == true) // RAW-10bit[h
	{
		// RAW10bit,RAW12bit̎LineSizeX2{
//		LineSize <<= 1; // 1C̃oCg
		LineSize <<= 0; // 2006.01.29 V3.33 1C̃oCg
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		BYTE U = 128;
		BYTE V = 128;
		return CYUV(pixcel[1],U,V);
	}
	else if(IsY12Mode() == true) // RAW-12bit[h
	{
		// RAW10bit,RAW12bit̎LineSizeX2{
		LineSize <<= 1; // 1C̃oCg
		LineSize <<= 0; // 2006.01.29 V3.33 1C̃oCg
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		BYTE U = 128;
		BYTE V = 128;
		return CYUV(pixcel[1],U,V);
	}
	else if(IsRGBMode() == true)//YUV[h
	{
		// t[f[^̃J[̎ނ̎ʕ@ύX
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
		//rgb̂ǂ̈ʑɂΉł悤RGB@ύXB
		//RGB̈ʑŏꍇ킯ۂɂ́AIF𑝂₵
		//IF̏ɍSeparationRGB̈ʑKXς邾B
		CRGB rgb;
		//RGB565->RGBɕ(2005/7/20ʑ͂PŒlƂĈ)
		rgb.SeparationRGB(pixcel[0], pixcel[1], 1);
		//RGB->24bitYUV
		return CYUV((CRGB)rgb);

	}
	// t[f[^̃J[̎ނ̎ʕ@ύX
	else {
		//sNZʒu擾
		unsigned char* pixcel = ImageData + (pixcelPos.y * LineSize) + pixcelPos.x;
		return CYUV(CRGB(pixcel[0],128,128));
	}
}

//vOCpf[^̃TCY //includeHeader:wb_[t@C܂ނ
int CFrameData::getDataSizeForPlugin(bool includeHeader)
{
// 2006.01.29 V3.33 \[X̂#ifA#elseA#endif폜܂

	int dataSize;
//	if(IsYUVMode() == true)
	if(IsYUVMode() || IsVYUYMode() || IsYUY2Mode() || IsYVYUMode() || IsUYVY16Mode() || IsVYUY16Mode()) // 2006.01.29 V3.33
	{	//YUV422[h1f3byte
		dataSize = getImageSizeWidth() * getImageSizeHeight() * 3;
	}
	else if(IsRGBMode())
	{	//RGB[h1f2byte
		dataSize = getImageSizeWidth() * getImageSizeHeight() * 2;
	}
//	else
	else if(IsYMode()) // 2006.01.29 V3.33
	{	// Raw-8bit[h1f3byte
		dataSize = getImageSizeWidth() * getImageSizeHeight() * 3;
	}
	else if(IsYMode() || IsYMode() || IsY12Mode()) // 2006.01.29 V3.33
	{	// Raw-10bit[h,Raw-12bit[h1f3byte
		dataSize = getImageSizeWidth() * getImageSizeHeight() * 3;
	}

	if(includeHeader == true)
	{//wb_[TCY
		dataSize += sizeof(FrameHeader);
	}
	return dataSize;

}

//vOCpɃf[^o 
void CFrameData::getDataForPlugin(unsigned char* outputData)
{
// 2006.01.29 V3.33 \[X̂#ifA#elseA#endif폜܂

	//wb_[̃Rs[
	CopyMemory(outputData,&FrameHeader,sizeof(FrameHeader));

	unsigned char* workOutput = outputData + sizeof(FrameHeader);

//	if(IsYUVMode() == true)
	if(IsYUVMode() || IsUYVY16Mode()) // 2006.01.29 V3.33
	{	//YUV̏ꍇUYVY->YUVϊsBf[^TCY1.5{ɂȂ܂B
		int imageWidth = FrameHeader.ulMonSizeW;
		int imageHeight = FrameHeader.ulMonSizeH;
		unsigned char* pixcel = (unsigned char*)ImageData;

		for(int y=0; y <imageHeight; y++)
		{
			for(int x=0; x < imageWidth-2; x+=2)
			{
				//YCrCb4:2:2 to YUV
				*workOutput = *(pixcel+1);/* Y */ *(workOutput+1) = *pixcel;/* U */ *(workOutput+2) = *(pixcel+2);/* V */
				*(workOutput+3) = *(pixcel+3);/* Y */ *(workOutput+4) = (*pixcel >> 1)+(*(pixcel+4) >> 1);/* U */ *(workOutput+5) = (*(pixcel+2) >> 1)+(*(pixcel+6) >> 1);/* V */

				workOutput += 6;
				pixcel += 4;
			}
			*workOutput = *(pixcel+1);/* Y */ *(workOutput+1) = *pixcel;/* U */ *(workOutput+2) = *(pixcel+2);/* V */
			*(workOutput+3) = *(pixcel+3);/* Y */ *(workOutput+4) = *(pixcel+0);/* U */ *(workOutput+5) = *(pixcel+2);/* V */
			workOutput += 6;
			pixcel += 4;
		}
	}
	if(IsVYUYMode() || IsVYUY16Mode()) // 2006.01.29 V3.33
	{	//YUV̏ꍇUYVY->YUVϊsBf[^TCY1.5{ɂȂ܂B
		int imageWidth = FrameHeader.ulMonSizeW;
		int imageHeight = FrameHeader.ulMonSizeH;
		unsigned char* pixcel = (unsigned char*)ImageData;

		for(int y=0; y <imageHeight; y++)
		{
			for(int x=0; x < imageWidth-2; x+=2)
			{
				//YCrCb4:2:2 to YUV
				*(workOutput+0) = *(pixcel+1); /* Y */
				*(workOutput+1) = *(pixcel+2); /* U */
				*(workOutput+2) = *(pixcel+0); /* V */
				*(workOutput+3) = *(pixcel+3); /* Y */
				*(workOutput+4) = (*(pixcel+2) >> 1)+(*(pixcel+6) >> 1); /* U */
				*(workOutput+5) = (*(pixcel+0) >> 1)+(*(pixcel+4) >> 1); /* V */

				workOutput += 6;
				pixcel += 4;
			}
			*(workOutput+0) = *(pixcel+1); /* Y */
			*(workOutput+1) = *(pixcel+2); /* U */
			*(workOutput+2) = *(pixcel+0); /* V */
			*(workOutput+3) = *(pixcel+3); /* Y */
			*(workOutput+4) = *(pixcel+2); /* U */
			*(workOutput+5) = *(pixcel+0); /* V */
			workOutput += 6;
			pixcel += 4;
		}
	}
	else if(IsRGBMode())
	{//RGB̏ꍇ̓f[^̂܂܃Rs[iRGB565)

		CopyMemory(workOutput,ImageData,ImageSize);
	}
	else if(IsYUY2Mode()) // 2006.01.29 V3.33
	{
		int imageWidth = FrameHeader.ulMonSizeW;
		int imageHeight = FrameHeader.ulMonSizeH;
		unsigned char* pixcel = (unsigned char*)ImageData;

		for(int y=0; y <imageHeight; y++)
		{
			for(int x=0; x < imageWidth-2; x+=2)
			{
				//YCrCb4:2:2 to YUV
				*(workOutput+0) = *(pixcel+0); // Y
				*(workOutput+1) = *(pixcel+1); // U
				*(workOutput+2) = *(pixcel+3); // V
				*(workOutput+3) = *(pixcel+2); // Y
				*(workOutput+4) = (*(pixcel+1) >> 1)+(*(pixcel+5) >> 1); // U
				*(workOutput+5) = (*(pixcel+3) >> 1)+(*(pixcel+7) >> 1); // V
				workOutput += 6;
				pixcel += 4;
			}
			*(workOutput+0) = *(pixcel+0); // Y
			*(workOutput+1) = *(pixcel+1); // U
			*(workOutput+2) = *(pixcel+3); // V
			*(workOutput+3) = *(pixcel+2); // Y
			*(workOutput+4) = *(pixcel+1); // U
			*(workOutput+5) = *(pixcel+3); // V
			workOutput += 6;
			pixcel += 4;
		}
	}
	else if(IsYVYUMode()) // 2006.01.29 V3.33
	{
		int imageWidth = FrameHeader.ulMonSizeW;
		int imageHeight = FrameHeader.ulMonSizeH;
		unsigned char* pixcel = (unsigned char*)ImageData;

		for(int y=0; y <imageHeight; y++)
		{
			for(int x=0; x < imageWidth-2; x+=2)
			{
				//YCrCb4:2:2 to YUV
				*(workOutput+0) = *(pixcel+0); // Y
				*(workOutput+1) = *(pixcel+3); // U
				*(workOutput+2) = *(pixcel+1); // V
				*(workOutput+3) = *(pixcel+2); // Y
				*(workOutput+4) = (*(pixcel+3) >> 1)+(*(pixcel+7) >> 1); // U
				*(workOutput+5) = (*(pixcel+1) >> 1)+(*(pixcel+5) >> 1); // V
				workOutput += 6;
				pixcel += 4;
			}
			*(workOutput+0) = *(pixcel+0); // Y
			*(workOutput+1) = *(pixcel+3); // U
			*(workOutput+2) = *(pixcel+1); // V
			*(workOutput+3) = *(pixcel+2); // Y
			*(workOutput+4) = *(pixcel+3); // U
			*(workOutput+5) = *(pixcel+1); // V
			workOutput += 6;
			pixcel += 4;
		}
	}
	else if(IsYMode()) // 2006.01.29 V3.33
	{
		int imageWidth = FrameHeader.ulMonSizeW;
		int imageHeight = FrameHeader.ulMonSizeH;
		unsigned char* pixcel = (unsigned char*)ImageData;

		for(int y=0; y <imageHeight; y++)
		{
			for(int x=0; x < imageWidth; x++)
			{
				// RAW-8bit to YUV
				*(workOutput+0) = *(pixcel+0); // Y
				*(workOutput+1) = 128;         // U
				*(workOutput+2) = 128;         // V
				workOutput += 3;
				pixcel += 1;
			}
		}
	}
	else if(IsY10Mode() || IsY12Mode()) // 2006.01.29 V3.33
	{
		int imageWidth = FrameHeader.ulMonSizeW;
		int imageHeight = FrameHeader.ulMonSizeH;
		unsigned char* pixcel = (unsigned char*)ImageData;

		for(int y=0; y <imageHeight; y++)
		{
			for(int x=0; x < imageWidth; x++)
			{
				// RAW-8bit to YUV
				*(workOutput+0) = *(pixcel+0); // Y
				*(workOutput+1) = 128;         // U
				*(workOutput+2) = 128;         // V
				workOutput += 3;
				pixcel += 2;
			}
		}
	}
}

// 2006.02.16 V3.33 *********************************************************
// wŴWW̐f[^擾
void CFrameData::get8x8data(CPoint pixcelPos, PBYTE pbData)
{
	int LineSize,col,lin,i;
	PBYTE pixcel;

	//`FbN
	if( ImageData == NULL || pbData == NULL ) return;
	memset(pbData,0x0,64); // zero clear
	if( pixcelPos.x >= getImageSizeWidth()  ||
		pixcelPos.y >= getImageSizeHeight() ||
		pixcelPos.x < 0 || pixcelPos.y < 0 ) return;
	col = getImageSizeWidth() - pixcelPos.x;
	if(col > 8) col = 8;
	lin  = getImageSizeHeight() - pixcelPos.y;
	if(lin > 8) lin = 8;

	// t[f[^̃J[̎ނ
	if(IsYUVMode() == true) //YUV[h(UYVY)
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsYUY2Mode() == true) //YUY2[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsVYUYMode() == true) //VYUY[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsUYVY16Mode() == true) // UYVY16[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsVYUY16Mode() == true) // VYUY16[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsYVYUMode() == true) //YVYU[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsYMode() == true) // RAW-8bit[h
	{
		LineSize = getImageSizeWidth() * 1;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 0);
	}
	else if(IsY10Mode() == true) // RAW-10bit[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsY12Mode() == true) // RAW-12bit[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else if(IsRGBMode() == true) //RGB565[h
	{
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}
	else { // ???
		LineSize = getImageSizeWidth() * 2;
		pixcel = ImageData + (pixcelPos.y * LineSize) + (pixcelPos.x << 1);
	}

	// f[^Rs[
	for(;lin > 0;lin--){
		for(i=0;i<col;i++){
			*(pbData+i) = *(pixcel+i);
		}
		pbData += 8;
		pixcel += LineSize;
	}
}
// 2006.02.16 V3.33 *********************************************************
