// MainFrm.cpp : CMainFrame NX̓̒`s܂B
//

#include "stdafx.h"
#include "SVIMon.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_MONITORING_START, OnMonitoringStart)
	ON_WM_TIMER()
	ON_COMMAND(ID_MONITORING_STOP, OnMonitoringStop)
	ON_COMMAND(ID_ZOOM_UP, OnZoomUp)
	ON_COMMAND(ID_ZOOM_DOWN, OnZoomDown)
	ON_WM_MOVE()
	ON_COMMAND(ID_COLOR_BAR, OnColorBar)
	ON_COMMAND(ID_OPTION, OnOption)
	ON_COMMAND(ID_MONITORING_INFO, OnMonitoringInfo)
	ON_WM_CLOSE()
	ON_UPDATE_COMMAND_UI(ID_MONITORING_START, OnUpdateMonitoringStart)
	ON_UPDATE_COMMAND_UI(ID_MONITORING_STOP, OnUpdateMonitoringStop)
	ON_WM_DESTROY()
	ON_COMMAND(ID_SELECT, OnSelect) // 2008.01.05 V3.50 add
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_STATUS_INFO,           // Xe[^X C CWP[^
	ID_STATUS_SIZE,
	ID_STATUS_RATE,
	ID_STATUS_MAG,
	ID_STATUS_MODE,
};


/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

CMainFrame::CMainFrame() 
{
	// TODO: ̈ʒuɃȍR[hǉĂB
	Monitoring = false;
	MonitoringError = false;
	pMonitoringThread = NULL;
	MonView = NULL;
	brink = true;
	m_pMonitoringInfoDialog = NULL;
	m_pColorBarDialog = NULL;
	isKeyFrame = false;
	FrameMemHandle = NULL;
	FrameMemSize = 0;
	SharedMemHandle = NULL;
	SharedMemSize = 0;
	ReceiveFrameRate=0;
	MonitoringRestert=0;
}

CMainFrame::~CMainFrame()
{
	//XbhI
	MonitoringThreadTerm();

	//L폜
	if(SharedMemHandle != NULL)
	{
		::CloseHandle(SharedMemHandle);
	}
	if(FrameMemHandle != NULL)
	{
		::CloseHandle(FrameMemHandle);
	}

	LOGWRT( ( LOGstr, 512, "SVImon initialize & End\n" ) );
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		LOGWRT( ( LOGstr, 512, "c[o[\zs\n" ) );
		return -1;      // 쐬Ɏs
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		LOGWRT( ( LOGstr, 512, "Xe[^Xo[\zs\n" ) );
		return -1;      // 쐬Ɏs
	}

	//Xe[^Xo[̕\̈ݒ
	m_wndStatusBar.SetPaneStyle(STATUS_INDEX_INFO,SBPS_NOBORDERS|SBPS_STRETCH);
	m_wndStatusBar.SetPaneInfo(STATUS_INDEX_SIZE,m_wndStatusBar.GetItemID(STATUS_INDEX_SIZE),SBPS_NOBORDERS,60);
	m_wndStatusBar.SetPaneInfo(STATUS_INDEX_RATE,m_wndStatusBar.GetItemID(STATUS_INDEX_RATE), SBPS_NOBORDERS,80);
	m_wndStatusBar.SetPaneInfo(STATUS_INDEX_MAG,m_wndStatusBar.GetItemID(STATUS_INDEX_MAG), SBPS_NOBORDERS,50);
	m_wndStatusBar.SetPaneInfo(STATUS_INDEX_MODE,m_wndStatusBar.GetItemID(STATUS_INDEX_MODE), SBPS_NOBORDERS,50);
	m_wndStatusBar.SetPaneInfo(STATUS_INDEX_MODE,m_wndStatusBar.GetItemID(STATUS_INDEX_MODE), SBPS_NOBORDERS,96);

	//Ct[ɑ薼\
	this->SetWindowText(MONNAME);

	// j[͋֎~OFF
	this->m_bAutoMenuEnable = FALSE;

	//c[o[
	
	//Xgbv{^ŏ͕\Ȃ
	//START(RUN){^ꂽɁAւ
	m_wndToolBar.GetToolBarCtrl().HideButton(ID_MONITORING_STOP);

	//run  stop̃C[WԍۑĂ
	RunIndex =	m_wndToolBar.CommandToIndex(ID_MONITORING_START);
	StopIndex = m_wndToolBar.CommandToIndex(ID_MONITORING_STOP);
	UINT dumyID,dumyStyle;
	m_wndToolBar.GetButtonInfo(RunIndex,dumyID,dumyStyle,RunImage);
	m_wndToolBar.GetButtonInfo(StopIndex,dumyID,dumyStyle,StopImage);

	// ACR̐ݒ
	HICON hicon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	this->SetIcon(hicon,TRUE);
	this->SetIcon(hicon,FALSE);

	//L̍\z
	FrameMemSize = SviOptions.DisplayMemorySizeMByte*1024*1024;
	SharedMemSize = SviOptions.SharedMemorySizeMByte*1024*1024;
	int rc1 = CreateMapping(&FrameMemHandle,FrameMemSize,SHARED_RECORDER_PLUGIN);//j^Op
	int rc2 = CreateMapping(&SharedMemHandle,SharedMemSize,SHARED_RECORDER_NAME);//R[fBOf[^p
	if(rc1 == DEF_ERR || rc2 == DEF_ERR)
	{
		AfxMessageBox(IDS_SHARED_MEM_ERROR,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "L\zs fm:%d sm:%d\n", rc1, rc2 ) );
		this->PostMessage( WM_CLOSE );//AvI
		return 0;
	}

	LOGWRT( ( LOGstr, 512, "SVImon initialize & Start\n" ) );
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// jꂽ CWnd qEBhEŁAWS_EX_NOPARENTNOTIFY X^C
	// ݒ肳ĂȂƁAWM_PARENTNOTIFY bZ[WeEBhEɑ܂B
	//cs.style |= WS_EX_NOPARENTNOTIFY;
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^C
	//       CĂB

	//Ct[̃LvVύX\ɂ
	cs.style^= FWS_ADDTOTITLE;

	// jꂽ CWnd qEBhEŁAWS_EX_NOPARENTNOTIFY X^C
	// ݒ肳ĂȂƁAWM_PARENTNOTIFY bZ[WeEBhEɑ܂B
	//cs.style |= WS_EX_NOPARENTNOTIFY;

	return TRUE;
}

//Run Stop{^̉摜؂ւ
void CMainFrame::setToolBarImageStart(bool isStart)
{
	UINT tempID,tempStyle;
	int dumyImage;
	if(isStart == true)
	{
		//START{^ɐݒ
		m_wndToolBar.GetButtonInfo(RunIndex,tempID,tempStyle,dumyImage);
		m_wndToolBar.SetButtonInfo(RunIndex,ID_MONITORING_START,tempStyle,RunImage);
	}
	else
	{
		//STOP{^ɐݒ
		m_wndToolBar.GetButtonInfo(RunIndex,tempID,tempStyle,dumyImage);
		m_wndToolBar.SetButtonInfo(RunIndex,ID_MONITORING_STOP,tempStyle,StopImage);
	}
}

//Xe[^Xo[֏ݒ
void CMainFrame::SetStatusBarInfo(LPCTSTR info, int width, int height, double viewRate, double frameRate, double Zoom, LPCTSTR mode) 
{
	CString strMsg;

	//CtH[V
	m_wndStatusBar.SetPaneText(STATUS_INDEX_INFO, info);

	//摜TCY
	strMsg.Format(MSG_SIZEINFO, width, height);
	m_wndStatusBar.SetPaneText(STATUS_INDEX_SIZE, strMsg);

	//t[[g
	strMsg.Format(MSG_FRAME_RATE, viewRate, frameRate);
	m_wndStatusBar.SetPaneText(STATUS_INDEX_RATE, strMsg);

	//{
	if(Zoom < 1)
	{
		strMsg.Format(MSG_ZOOMDOWNINFO, (1 / Zoom));
	}
	else
	{
		strMsg.Format(MSG_ZOOMUPINFO, Zoom);
	}
	m_wndStatusBar.SetPaneText(STATUS_INDEX_MAG, strMsg);

	m_wndStatusBar.SetPaneText(STATUS_INDEX_MODE, mode);
}

//Xe[^Xo[֏ݒNA
void CMainFrame::ClearStatusBarInfo() 
{
	m_wndStatusBar.SetPaneText(STATUS_INDEX_INFO, _T(""));
	m_wndStatusBar.SetPaneText(STATUS_INDEX_SIZE, _T(""));
	m_wndStatusBar.SetPaneText(STATUS_INDEX_RATE, _T(""));
	m_wndStatusBar.SetPaneText(STATUS_INDEX_MAG, _T(""));
}

//Xe[^Xo[փG[bZ[Ŵݕ\
void CMainFrame::SetStatusBarErrorInfo(LPCTSTR errinfo) 
{
	m_wndStatusBar.SetPaneText(STATUS_INDEX_INFO, errinfo);
	m_wndStatusBar.SetPaneText(STATUS_INDEX_SIZE, _T(""));
	m_wndStatusBar.SetPaneText(STATUS_INDEX_RATE, _T(""));
	m_wndStatusBar.SetPaneText(STATUS_INDEX_MAG, _T(""));
	m_wndStatusBar.SetPaneText(STATUS_INDEX_MODE, _T(""));
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

//j^OJn
void CMainFrame::OnMonitoringStart() 
{
	SviUsbControl.m_iMonTimeout = SviOptions.MonitoringTimeout;

	if(!SviUsbControl.open()) {
		AfxMessageBox(IDS_MONITORING_START_ERROR,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "OnMonStart : n[hEFAݒ擾s open\n" ) );
		SviUsbControl.DeviceReset();
		SviUsbControl.close();
		return;
	}

	//VIF8bit16bitw肷
	if(SviOptions.PicType == PicY10 || SviOptions.PicType == PicY12 || SviOptions.PicType == PicUYVY16 || SviOptions.PicType == PicVYUY16 || SviOptions.PicType == PicYUY216){
		if(SviUsbControl.setBitCounts(16) == false)
		{
			AfxMessageBox(IDS_VIDEO_PARA1,NULL,MB_ICONERROR);
			LOGWRT( ( LOGstr, 512, "OnMonStart :SviUsbControl.setBitCounts(16) error\n" ) );
		}
	}else{
		if(SviUsbControl.setBitCounts(8) == false)
		{
			AfxMessageBox(IDS_VIDEO_PARA1,NULL,MB_ICONERROR);
			LOGWRT( ( LOGstr, 512, "OnMonStart : SviUsbControl.setBitCounts(8) error\n" ) );
		}
	}

	//j^O[h(0:ޯ̧A1:ݸޯ̧)w肷
	if(SviUsbControl.setParam(SviOptions.bMonMode,(int)SviOptions.PicType) == false) // 2005.12.27
	{
		AfxMessageBox(IDS_SETPARAM_ERROR,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "OnMonStart :SviUsbControl.setParam() error\n" ) );
	}

	//M[hw肷
	if(SviUsbControl.setSyncMode(SviOptions.bSyncMode) == false)
	{
		AfxMessageBox(IDS_VIDEO_PARA1,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "OnMonStart :SviUsbControl.setSyncMode() error\n" ) );
	}

	//sNZNbN荞݋ɐw肷
	if(SviUsbControl.setEdgeMode(SviOptions.bEdgeMode) == false)
	{
		AfxMessageBox(IDS_VIDEO_PARA1,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "OnMonStart :SviUsbControl.setEdgeMode() error\n" ) );
	}

	Sleep(100);

	//n[hEGA̐ݒ擾
	if(SviUsbControl.refreshStatus() == false)
	{
		AfxMessageBox(IDS_MONITORING_START_ERROR,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "OnMonStart : n[hEFAݒ擾s refreshStatus\n" ) );
		if(!IsMonitoringInfoDialogEnable())
		// foCXs莞̏ǉ
		// Jւ̘AANZX̊JnƏIɃI[v/N[Ys
		{
			SviUsbControl.DeviceReset();
			SviUsbControl.close();
			SviUsbControl.open();
		}
		return;
	}
	//n[hEGÃ|C^IvVɕۑ
	SviOptions.SviStatus = SviUsbControl.getStatus();

	int x;
	int y;
	int width;
	int height;

	//JbgAEgTCYw肪邩ǂ
	if(SviOptions.CutOutSize.IsRectEmpty() == TRUE)
	{
		//JbgAEgwȂ
		x=0;
		y=0;
		width = SviOptions.SviStatus->getOriginalWidth();
		height = SviOptions.SviStatus->getOriginalHeight();
	}
	else
	{
		//JbgAEg
		x = SviOptions.CutOutSize.left;
		y = SviOptions.CutOutSize.top;
		width = SviOptions.CutOutSize.Width();
		height = SviOptions.CutOutSize.Height();
	}
	if( width <=0 || height <= 0 )
	{
		//JbgAEgw̓J̐ݒ肪B
		AfxMessageBox(IDS_MONITORING_START_ERROR,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "OnMonStart : CutoutSize Check x:%d y:%d w:%d h:%d\n", x, y, width, height ) );
		// foCXs莞̏ǉ
		// Jւ̘AANZX̊JnƏIɃI[v/N[Ys
		SviUsbControl.close();
		return;
	}

	//j^OJnw
	if(SviUsbControl.startMonitoring(x, y, width, height) == false)
	{
		AfxMessageBox(IDS_MONITORING_START_ERROR,NULL,MB_ICONERROR);
		LOGWRT( ( LOGstr, 512, "OnMonStart : Monitoring Start error\n" ) );
		// Jւ̘AANZX̊JnƏIɃI[v/N[Ys
		SviUsbControl.close();
		return;
	}

	//f[^MXbhJn
	ThreadStop = false;
	MonitoringError = false;
	pMonitoringThread = AfxBeginThread(MonitoringThread,this);
	pMonitoringThread->m_bAutoDelete = FALSE;//Xbh̎폜͂Ȃ

	Monitoring = true;
	SetTimer(MONTIMER,MONITORING_TIMER_SPEED,NULL);
	SetTimer(MONTIMER_FPS,TIMER_STATUSSPEED,NULL);
	
	MonView = this->GetTopWindow();//SVIMonViewւ̃|C^擾

	//L[t[tO𗧂Ă
	isKeyFrame = true;

	//c[o[̃{^XgbvɕύX
	setToolBarImageStart(false);

	//t[[gvpZbg
	ViewFrameRate.reset();

	//^CAEgvp
	TimeOutCheck = timeGetTime();

	((CSVIMonView*)MonView)->OnZoom(SviOptions.Zoom);

	//Xe[^Xo[֏󋵕\
	SetStatusBarInfo(MSG_MONITORING,SviOptions.SviStatus->getMonSizeWidth(),SviOptions.SviStatus->getMonSizeHeight(),
					0,0,SviOptions.Zoom, _T(""));
}

//^C}[bZ[W擾
void CMainFrame::OnTimer(UINT_PTR nIDEvent) 
{
	if(nIDEvent == MONTIMER && Monitoring == true)//j^O
	{
		//j^O摜XV
		((CSVIMonView*)MonView)->drawFrame(this);

		//MG[ĂȂ
		if(MonitoringError == true)
		{
			OnMonitoringStop();//j^O~
		}
		else
		{
			//M
			MonitoringEvent.SetEvent();
		}
	}

	if(nIDEvent == MONITORING_INFO) // Monitoring Information
	{
		if(IsMonitoringInfoDialogEnable() == true)
		{
			if(!Monitoring) {
				SviUsbControl.open();
				//n[hEGA̐ݒ擾
				SviUsbControl.refreshStatus();
			}
			// Monitoring InformationXV
			m_pMonitoringInfoDialog->refreshData(Monitoring);
			if(!Monitoring) {
				SviUsbControl.close();
			}
		}
		else 
		{
			// ^C}[Xgbv
			KillTimer(MONITORING_INFO);
		}
	}

	if(nIDEvent == MONTIMER_FPS && Monitoring == true)//j^O
	{
		//\t[[g̕傫̂͌덷̂߂Ȃ̂ŎMt[[gɍ킹B
		if(!SviUsbControl.refreshStatus(false)) {
			if(Monitoring)
				MonitoringError	= true;
		}
		double viewFrameRate = min(ViewFrameRate.getFps(),ReceiveFrameRate);
		
		//10boĂ0fps̏ꍇ̓j^O~
		if( (SviUsbControl.m_iMonTimeout > 0) && ((SviUsbControl.m_iMonTimeout*1000) < (int)(timeGetTime()-TimeOutCheck)) && (viewFrameRate == 0) )
		{
			OnMonitoringStop();
			LOGWRT( ( LOGstr, 512, "OnTimer : The image was not able to be acquired though 10 seconds passed after it began to monitor it.\n" ) );
			if(SviOptions.IsSTSErr) {
				CString strError;
				strError.LoadString(IDS_MONITORING_ERROR_STOP);
				SetStatusBarErrorInfo(strError);
			}
			else {
				AfxMessageBox(IDS_UNEXPEND_MONITORING_ERROR,NULL,MB_ICONERROR);
			}
			return;
		}
		
		//Xe[^Xo[֏󋵕\
		MonView = this->GetTopWindow();//SVIMonViewւ̃|C^擾
		CString strMode;
		strMode = "GDI";
		SetStatusBarInfo(MSG_MONITORING,((CSVIMonView*)MonView)->GetViewWidth(),
										((CSVIMonView*)MonView)->GetViewHeight(),
										viewFrameRate,ReceiveFrameRate,SviOptions.Zoom,strMode);

		//R[fBO̕iXe[^Xo[ju
		if(brink == true)
		{
			brink = false;
		}
		else
		{
			m_wndStatusBar.SetPaneText(STATUS_INDEX_INFO,"");
			brink = true;
		}

	}

	CFrameWnd::OnTimer(nIDEvent);
}

//摜擾pXbh֐(p[^ɂ́@CMainFramẽ|C^nĂ)
UINT CMainFrame::MonitoringThread( LPVOID pMainFrame )
{
	bool isErrorIgnore = false;//G[𖳎邩
	int nTimeout = 0;
	int nStatusErrCount = 0;

	CMainFrame* mainFrame = (CMainFrame*)pMainFrame;

	while(true)
	{
		WaitForSingleObject(mainFrame->MonitoringEvent,INFINITE);
		if(mainFrame->ThreadStop == true)
		{
			return 0;//XbhI
		}
		if(mainFrame->MonitoringError == true)
		{
			continue;//CXbhIʒm܂ő҂B
		}
		
		if(mainFrame->SviUsbControl.IsFramePending() == false)
		{
			//ǂݍ߂t[f[^Ȃ
			nTimeout++;
			if(nTimeout>100) {
				if(mainFrame->ViewFrameRate.getFps()) {
					LOGWRT( ( LOGstr, 512, "MonitoringThread : error FramePending\n" ) );
					mainFrame->ViewFrameRate.reset();
				}
				nTimeout = 0;
			}
			Sleep(5); // 2005.07.25 wait 20msec -> 5msec
			continue;
		}

		mainFrame->TimeOutCheck = timeGetTime(); // ^C}JE^Zbg
		nTimeout = 0;

		//n[hEGAXe[^XXV
		int rc = mainFrame->SviUsbControl.refreshStatus();
		if(!rc) {
			nStatusErrCount++;
			if(nStatusErrCount>3) {
				// 擾3񎸔sG[Ƃ
				mainFrame->MonitoringError = true;
			}
			continue;
		}

		CFrameData* frameData = mainFrame->FrameDataControl.getWriteFrameDataAndLock();//t[f[^i[pIuWFNg擾

		if(frameData == NULL)
		{
			//݂łt[Ȃ
			LOGWRT( ( LOGstr, 512, "MonitoringThread : write frame nothing\n" ) );
			continue;
		}

		//J[[hݒ
		if(mainFrame->SviOptions.PicType == PicYUV)
		{
			frameData->setYUVMode();
		}
		else if(mainFrame->SviOptions.PicType == PicY) 
		{
			frameData->setYMode();
		}
		else if(mainFrame->SviOptions.PicType == PicY10) 
		{
			frameData->setY10Mode();
		}
		else if(mainFrame->SviOptions.PicType == PicY12) 
		{
			frameData->setY12Mode();
		}
		else if(mainFrame->SviOptions.PicType == PicYUY2) 
		{
			frameData->setYUY2Mode();
		}
		else if(mainFrame->SviOptions.PicType == PicYVYU) 
		{
			frameData->setYVYUMode();
		}
		else if(mainFrame->SviOptions.PicType == PicVYUY) 
		{
			frameData->setVYUYMode();
		}
		else if(mainFrame->SviOptions.PicType == PicUYVY16) 
		{
			frameData->setUYVY16Mode();
		}
		else if(mainFrame->SviOptions.PicType == PicVYUY16) 
		{
			frameData->setVYUY16Mode();
		}
		else if(mainFrame->SviOptions.PicType == PicYUY216) 
		{
			frameData->setYUY216Mode();
		}
		else
		{
			frameData->setRGBMode();
		}
		frameData->setDispRawMode(mainFrame->SviOptions.iRawBitAss);

		// foCXG[̓j^O~
		if(mainFrame->SviUsbControl.getMonitoringFrameData(frameData) == false)
		{
			mainFrame->MonitoringError = true;
		}

		//t[[g擾
		mainFrame->ReceiveFrameRate = frameData->getFrameRate();

		mainFrame->FrameDataControl.UnLockWriteFrameData(true);
	}

	// Jւ̘AANZX̊JnƏIɃI[v/N[Ys
	mainFrame->SviUsbControl.close();

	return 0;
}

//j^O~Jnw
void CMainFrame::OnMonitoringStop() 
{
	if(Monitoring == false)	return;

	//~OɃj^O摜XV
	((CSVIMonView*)MonView)->drawFrame(this);

	//j^O~Jnw
	Monitoring = false;
	KillTimer(MONTIMER);
	KillTimer(MONTIMER_FPS);

	//XbhI
	MonitoringThreadTerm();

	//c[o[̃{^X^[gɕύX
	setToolBarImageStart(true);
}

//j^OXbhI
void CMainFrame::MonitoringThreadTerm(void)
{
	if(pMonitoringThread == NULL)
	{
		return;//XbhȂ
	}

	//Xbh~߂
	ThreadStop = true;
	MonitoringEvent.SetEvent();


	//Xbh̏IĎ
	DWORD ExitCode = STILL_ACTIVE; 
	for(int i=0; ExitCode == STILL_ACTIVE; i++)
	{
		//XbhImF
		GetExitCodeThread( pMonitoringThread->m_hThread, &ExitCode );
		Sleep(100);

		if(i > 100)
		{
			//Xbh̋Ii댯j
			TerminateThread(pMonitoringThread->m_hThread,-1);
			TRACE("j^OXbhI܂B");
			Sleep(100);
			
			//ISviUsbControl.stopMonitoring()ĂяoƋAĂȂB

			//Xbh̔p
			delete pMonitoringThread;
			pMonitoringThread = NULL;
			return;

		}

	}

	//Xbh̔p
	delete pMonitoringThread;
	pMonitoringThread = NULL;

	ClearStatusBarInfo();

	if(MonitoringError){
		AfxMessageBox(IDS_UNEXPEND_MONITORING_ERROR);
		goto Mon_Err;
	}

	if(SviUsbControl.stopMonitoring(SviOptions.PicType) == false)
	{
		LOGWRT( ( LOGstr, 512, "MonThreadTerm : stopMonitoring error\n" ) );

		AfxMessageBox(IDS_UNEXPEND_MONITORING_ERROR);
	}
Mon_Err:

	if(!IsMonitoringInfoDialogEnable())	SviUsbControl.close();
}

//g
void CMainFrame::OnZoomUp() 
{
	if(SviOptions.Zoom > 32.)
	{
		//32{ȏ㐧
		return;
	}

	SviOptions.Zoom *= 2.;

	if(MonView != NULL)
	{
		((CSVIMonView*)MonView)->OnZoom(SviOptions.Zoom);
	}


	//{\ύX
	CString strMsg;
	if(SviOptions.Zoom < 1)
	{
		strMsg.Format(MSG_ZOOMDOWNINFO, (1 / SviOptions.Zoom));
	}
	else
	{
		strMsg.Format(MSG_ZOOMUPINFO, SviOptions.Zoom);
	}
	m_wndStatusBar.SetPaneText(STATUS_INDEX_MAG, strMsg);
}

//k
void CMainFrame::OnZoomDown() 
{
	if(SviOptions.Zoom < (1./8.))
	{
		//1/8{ȉ
		return;
	}

	SviOptions.Zoom /= 2.; 
	if(MonView != NULL)
	{
		((CSVIMonView*)MonView)->OnZoom(SviOptions.Zoom);
	}

	//{\ύX
	CString strMsg;
	if(SviOptions.Zoom < 1)
	{
		strMsg.Format(MSG_ZOOMDOWNINFO, (1 / SviOptions.Zoom));
	}
	else
	{
		strMsg.Format(MSG_ZOOMUPINFO, SviOptions.Zoom);
	}
	m_wndStatusBar.SetPaneText(STATUS_INDEX_MAG, strMsg);

}

//EChEړiCt[Ăяo܂j
void CMainFrame::OnMove(int x, int y) 
{
	CFrameWnd::OnMove(x, y);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if(MonView != NULL)
	{
		((CSVIMonView*)MonView)->OnMove(x,y);
	}

}

//J[o[̕\
void CMainFrame::OnColorBar() 
{
	// J[o[̃`FbN
	if(GetMenu()->CheckMenuItem(ID_COLOR_BAR , MF_BYCOMMAND | MF_CHECKED) != MF_CHECKED)
	{
		m_pColorBarDialog = new CColorBarDialog(this->GetTopWindow());
		// J[o[_CAO\
		m_pColorBarDialog->ShowWindow(SW_SHOW);

	}
	else
	{
		// J[o[̃`FbNOFFA_CAO\
		GetMenu()->CheckMenuItem(ID_COLOR_BAR , MF_BYCOMMAND | MF_UNCHECKED);
		m_pColorBarDialog->DestroyWindow();
		delete m_pColorBarDialog;
		m_pColorBarDialog = NULL;

	}
}

//J[o[̕\L
bool CMainFrame::IsColorBarEnable()
{
	// J[o[̕\̃`FbN
	UINT check = GetMenu()->GetMenuState(ID_COLOR_BAR , MF_BYCOMMAND);
	if((check & MF_CHECKED) > 0 )
	{
		return true;
	}
	return false;
}


//j[IvVI
void CMainFrame::OnOption() 
{
	bool bDevOpen = false;

	if(IsMonitoringInfoDialogEnable() == true) {
		// MonitoringInfo̍ăX^[gΉ
		OnMonitoringInfo();
		MonitoringInfoRestart	= true;
	}
	if(Monitoring == false)//j^O~
	{
		SviUsbControl.open();
		bDevOpen = true;
	}

	//n[hEGA̐ݒ擾
	bool rc = SviUsbControl.refreshStatus();
	if(Monitoring == true)//j^O
	{
		//j^O~
		OnMonitoringStop();
		MonitoringRestert = true;
	}
	if(bDevOpen) {
		SviUsbControl.close();
	}
	if(rc == false) 
	{
		LOGWRT( ( LOGstr, 512, "OnOption : refreshStatusError\n" ) );
		AfxMessageBox(IDS_GETOPTION_ERROR,NULL,MB_ICONERROR);
		return;
	}
	//n[hEGAIvVɕۑ
	SviOptions.SviStatus = SviUsbControl.getStatus();
	
	CSVIOptionDialog dlg(&SviOptions);
	if(IDCANCEL == dlg.DoModal())
	{
		if(	MonitoringRestert == true)
		{
			//j^OĊJ
			OnMonitoringStart();
			MonitoringRestert = false;
		}
		if(MonitoringInfoRestart == true) {
			OnMonitoringInfo();
			MonitoringInfoRestart = false;
		}
		return;
	}


	if(FrameMemSize != SviOptions.DisplayMemorySizeMByte*1024*1024 ||
		SharedMemSize != SviOptions.SharedMemorySizeMByte*1024*1024)
	{
		//L̍č\z
		::CloseHandle(FrameMemHandle);
		::CloseHandle(SharedMemHandle);
		FrameMemSize = SviOptions.DisplayMemorySizeMByte*1024*1024;
		SharedMemSize = SviOptions.SharedMemorySizeMByte*1024*1024;
		int rc1 = CreateMapping(&FrameMemHandle,FrameMemSize,SHARED_RECORDER_PLUGIN);//j^Op
		int rc2 = CreateMapping(&SharedMemHandle,SharedMemSize,SHARED_RECORDER_NAME);//R[fBOf[^p
		if(rc1 == DEF_ERR || rc2 == DEF_ERR)
		{
			FrameMemHandle=NULL;
			SharedMemHandle=NULL;
			AfxMessageBox(IDS_SHARED_MEM_ERROR,NULL,MB_ICONERROR);
			this->PostMessage( WM_CLOSE );//AvI
			return;
		}
	}

	if(	MonitoringRestert == true)
	{
		//j^OĊJ
		OnMonitoringStart();
		MonitoringRestert = false;
	}
	
	// MonitoringInfo̍ăX^[gΉ
	if(MonitoringInfoRestart == true) {
		OnMonitoringInfo();
		MonitoringInfoRestart = false;
	}
}

//j^OCtH[V_CAO\܂B
void CMainFrame::OnMonitoringInfo() 
{
	// j[Ƀ`FbN
	if(GetMenu()->CheckMenuItem(ID_MONITORING_INFO , MF_BYCOMMAND | MF_CHECKED) != MF_CHECKED)
	{
		//n[hEGA̐ݒ擾
		SviUsbControl.refreshStatus();
		//n[hEGÃ|C^IvVɕۑ
		SviOptions.SviStatus = SviUsbControl.getStatus();
		SviUsbControl.getBoardInfo(&m_iBoardVer, &m_iPllData);
		//{[h̃|C^IvVɕۑ
		SviOptions.SviStatus->setBoardInfo(m_iBoardVer, m_iPllData);

		m_pMonitoringInfoDialog = new CMonitoringInfoDialog(&SviOptions,this->GetTopWindow());
		// j^OCtH_CAO\
		m_pMonitoringInfoDialog->ShowWindow(SW_SHOW);

		SetTimer(MONITORING_INFO,MONINFO_TIMER_SPEED,NULL);
	}
	else
	{
		// j^OCtH̃`FbNOFFA_CAO\
		GetMenu()->CheckMenuItem(ID_MONITORING_INFO , MF_BYCOMMAND | MF_UNCHECKED);
		m_pMonitoringInfoDialog->DestroyWindow();
		m_pMonitoringInfoDialog = NULL;
	}
	
}

//j^O_CAO̕\L
bool CMainFrame::IsMonitoringInfoDialogEnable()
{
	// J[o[̕\̃`FbN
	if(!this->GetSafeHwnd()) return false;
	UINT check = GetMenu()->GetMenuState(ID_MONITORING_INFO , MF_BYCOMMAND);
	if((check & MF_CHECKED) > 0 )
	{
		return true;
	}
	return false;
}

//EChE鎞̏
void CMainFrame::OnClose() 
{
	// I̒ǉ
	if(Monitoring)
		OnMonitoringStop();

	//NX̌Ăяo
	CFrameWnd::OnClose();
}

void CMainFrame::OnUpdateMonitoringStart(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(!Monitoring);	
}

void CMainFrame::OnUpdateMonitoringStop(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
	pCmdUI->Enable(Monitoring);	
}

void CMainFrame::PostNcDestroy() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

	delete this;
}

void CMainFrame::OnDestroy() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
}

//ݕ\Ă郂j^O摜BMPƂăO[o[ɃRs[܂B
bool CMainFrame::CopyFrameImageToClipboard()
{
	//\t[擾bN
	CFrameData* frameData = FrameDataControl.getViewEndFrameAndLock();
	if(frameData == NULL && Monitoring == true)
	{
		for(int i=0;i<10;i++)
		{
			Sleep(10);
			frameData = FrameDataControl.getViewEndFrameAndLock();
			if(frameData != NULL) break;
		}
	}
	if(frameData == NULL)
	{
		//ۑ\ȃt[f[^܂łB
		AfxMessageBox(IDS_BITMAP_SAVE_ERROR,NULL,MB_ICONERROR);
		return false;
	}

	int fileSize = frameData->get24BitmapSize(true);

	//Nbv{[hRs[p̃O[o[m
	//iGlobalAllocGMEM_FIXED̏ꍇ̖߂l̓nhł͂Ȃ|C^ɂȂ܂Bj
	HGLOBAL hMem = GlobalAlloc(GMEM_FIXED, fileSize);
	//擾O[o[̃|C^LXg܂B
	char* fileImage  = (char*)hMem;



	//rbg}bvf[^擾
	bool rc = frameData->get24Bitmap(fileImage,fileSize,true,false,NULL);
	if(rc == false)
	{
		FrameDataControl.UnLockViewEndFrame();
		//ۑ\ȃt[f[^܂łB
		AfxMessageBox(IDS_BITMAP_SAVE_ERROR,NULL,MB_ICONERROR);
		delete[] fileImage;
		return false;
	} 
	FrameDataControl.UnLockViewEndFrame();


	// Nbv{[h̃I[v
	if( !::OpenClipboard(*this) )
	{
		//ۑ\ȃt[f[^܂łB
		AfxMessageBox(IDS_BITMAP_SAVE_ERROR,NULL,MB_ICONERROR);
		return false;
	}
	// Nbv{[h֕Rs[AN[Y
	EmptyClipboard();	// Nbv{[h̒gɂ
	HANDLE hHandels= SetClipboardData(CF_DIB, hMem);
	CloseClipboard();
	return true;
}

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	
	if(pMsg->message == WM_KEYDOWN)
	{
		//Ctrl+C ꂽƂɂ̓Nbv{[hRs[֐s
		if (pMsg->wParam == 'C' && GetKeyState(VK_CONTROL) < 0)
		{
			CopyFrameImageToClipboard();
			return true;
		}
	}
	return CFrameWnd::PreTranslateMessage(pMsg);
}
// j^Ot[ۑs
void CMainFrame::OnSelect() 
{
	//SVI-03I_CAO\	
	CBoardSelect SelDlg(&SviUsbControl, NULL);

	//SVI-03I_CAO\
	if(SelDlg.DoModal() == IDOK){
		CString apName;
		apName.Format("SVImon-%d",SviUsbControl.GetSelBoardNo());
		this->SetWindowText(apName);
	}
}
