// MainFrm.h : CMainFrame NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__956144D0_A027_4A9C_8B6A_C16DEFD8BCDA__INCLUDED_)
#define AFX_MAINFRM_H__956144D0_A027_4A9C_8B6A_C16DEFD8BCDA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SVIPluginComm.h"
#include "SVIComm.h"
#include "SviUsbControl.h"
#include "SVIOptions.h"
#include "SVIMonView.h"
#include "FrameDataControl.h"
#include "ColorBarDialog.h"
#include "SVIOptionDialog.h"
#include "MonitoringInfoDialog.h"
#include "BoardSelect.h"
#include <mmsystem.h>

#define MONTIMER_FPS  MONTIMER+1
#define MONTIMER_REC  MONTIMER+2

// Informationj^OƔ񓯊œ삳
#define MONITORING_INFO MONTIMER+3
#define MONTIMER_SAVE  MONTIMER+4
#define MONTIMER_REC2  MONTIMER+5

//vOCj[̈ʒuiK\[Xƍ킹ĉj
#define PLUGIN_MENU_POS 3

//ꎞt@C̖O
#define TEMP_FILE_NAME "_temp_file_svi_mon.tmp"

//j^O^CAEg
#define MONITORING_TIME_OUT 10000

//Y[\iXe[^Xo[j
#define MSG_ZOOMUPINFO  _T("x%-2.0f ")
#define MSG_ZOOMDOWNINFO  _T("x1/%-3.0f ")
#define MSG_SIZEINFO  _T("%d x %d ")
#define MSG_FRAME_RATE _T("%5.2f/%-5.2ffps")


//Xe[^Xo[ɕ\ʒũCfbNX
#define STATUS_INDEX_INFO 0 //Xe[^X
#define STATUS_INDEX_SIZE 1 //摜TCY
#define STATUS_INDEX_RATE 2 //t[[g
#define STATUS_INDEX_MAG 3 //{
#define STATUS_INDEX_MODE 4 //\[h

//j^Õ|[OXs[h(msec)
#define MONITORING_TIMER_SPEED 0

//SVIViewN܂ł̑҂(sec)
#define VIEW_STARTUP_WAIT 10

// Monitoring Information̓Xs[h
#define MONINFO_TIMER_SPEED 300

#include <list>
using namespace std;



//ԌvpNX
class CWatchRefreshRate
{
public:
	CWatchRefreshRate()
	{
		PrevTime=0;
	};

	//Zbg
	void reset(void)
	{
		PrevTime=0;
		SpanTime.clear();
	};

	//1t[ƂɌĂяoĂ
	void rap(void)
	{
		DWORD now = timeGetTime();
		if(PrevTime > 0)
		{
			SpanTime.push_back(now - PrevTime);

			if(SpanTime.size() > 16)//ŐV16ςɂ
			{
				SpanTime.pop_front();
			}
		}
		PrevTime = now;
	}


	//tbV[g擾܂
	double getFps(void)
	{
		DWORD TotalSpanTime = 0;
		if(SpanTime.size()==0)return 0.;
		list<DWORD>::iterator ite = SpanTime.begin();
		for(int i=0; i<(int)SpanTime.size(); i++)
		{
			TotalSpanTime += *ite;
			ite++;
		}
		if(TotalSpanTime == 0)
		{
			return 0;
		}
		return (double(SpanTime.size())/double(TotalSpanTime))*1000.;
	}
	
private:
	DWORD PrevTime;
	list<DWORD> SpanTime;

};

//Ct[
class CMainFrame : public CFrameWnd
{
	
protected: // VACY@\݂̂쐬܂B
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Agr[g
public:

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:  // Rg[ o[po
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	
public: //SVIMon֘A
	int m_iPllData;
	int m_iBoardVer;
	void startMonitoringSave();

// foCXs莞̏ǉ
// J̃t[擾łȂ܂͓dOFFƂȂꍇl
// ^CAEgǉ
	inline void MonitoringStop() 
	{
		if(this->GetSafeHwnd()) {
			OnMonitoringStop();
		}
	}

	bool Monitoring;//j^Oł邩ǂ
	bool MonitoringError;//j^OɃG[Ă邩B
	CSVIOptions SviOptions;//IvVݒ

	CFrameDataControl FrameDataControl;//t[f[^igvobt@őΉj


	CEvent MonitoringEvent;//j^OUSBMCxg

	//J[o[̕\L
	bool IsColorBarEnable(void);

	//j^O_CAO̕\L
	bool IsMonitoringInfoDialogEnable();


	CColorBarDialog* m_pColorBarDialog;//J[o[_CAÕ|C^

	CMonitoringInfoDialog* m_pMonitoringInfoDialog;//j^OCtH_CAÕ|C^

	bool brink;

	bool isKeyFrame;//L[t[tOivOC̕`XVbZ[Wpj

	HANDLE FrameMemHandle;//j^Oobt@pLnh
	int FrameMemSize;
	HANDLE SharedMemHandle;//Lnh(R[fBOpj
	int SharedMemSize;//LTCY

	double ReceiveFrameRate;//Mt[[g
	CWatchRefreshRate ViewFrameRate;//\t[[gv

	bool CMainFrame::CopyFrameImageToClipboard();

private:
	//j^O摜擾pXbh֐(p[^ɂ́@CMainFramẽ|C^nĂ)
	static UINT CMainFrame::MonitoringThread( LPVOID pMainFrame );

	//XbhI
	void MonitoringThreadTerm(void);

	//Run Stop{^̉摜؂ւ
	void setToolBarImageStart(bool isStart);

	//Xe[^Xo[֏ݒ
	void SetStatusBarInfo(LPCTSTR info,  int width, int height, double viewRate, double frameRate, double Zoom, LPCTSTR mode);
	
	//Xe[^Xo[֏ݒNA
	void ClearStatusBarInfo();

	// G[Xe[^Xo[֕\܂
	void SetStatusBarErrorInfo(LPCTSTR errinfo);

	bool ThreadStop;//Xbh̃[v𐧌ifalseɂƃXbh͏I܂B)

	CSviUsbControl SviUsbControl;//SVIUSB2.0ʐM

	CWinThread* pMonitoringThread;//XbhIuWFNg

	CWnd* MonView;//viewIuWFNg

	//c[o[̃{^C[WIύXp
	int RunIndex;
	int StopIndex;
	int RunImage;
	int StopImage;

	bool PaintStopFromPlugin;//vOCɂ\XV~tO

	CRect CutOutSizeFroPlugin;//JbgAEgTCYvOCɒʒm邽߂̃CX^X

	bool MonitoringRestert;//j^OɃR[fBOsꍇɏIɃX^[gtO

	DWORD TimeOutCheck;//j^OJn^CAEg

	bool MonitoringInfoRestart;	// j^OCtH[VɃR[fBOsꍇɏIɃX^[gtO

// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnMonitoringStart();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnMonitoringStop();
	afx_msg void OnZoomUp();
	afx_msg void OnZoomDown();
	afx_msg void OnMove(int x, int y);
	afx_msg void OnColorBar();
	afx_msg void OnOption();
	afx_msg void OnMonitoringInfo();
	afx_msg void OnClose();
	afx_msg void OnUpdateMonitoringStart(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMonitoringStop(CCmdUI* pCmdUI);
	afx_msg void OnDestroy();
	afx_msg void OnSelect();
	//}}AFX_MSG


DECLARE_MESSAGE_MAP()
};


//J[\҂ԂɕύXNX
class CChageCursor
{
public:
	//RXgN^iύXJ[\̃\[XIDnĂj
	CChageCursor(LPCTSTR id)
	{
		PrevCursor = SetCursor(AfxGetApp()->LoadCursor(id));
	};
	//fXgN^iJ[\ɖ߂܂j
	virtual ~CChageCursor()
	{
		SetCursor(PrevCursor);
	};
	HCURSOR PrevCursor;
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_MAINFRM_H__956144D0_A027_4A9C_8B6A_C16DEFD8BCDA__INCLUDED_)
