// SVIMonView.cpp : CSVIMonView NX̓̒`s܂B
//

#include "stdafx.h"
#include "SVIMon.h"
#include "SVIMonDoc.h"
#include "SVIMonView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSVIMonView

IMPLEMENT_DYNCREATE(CSVIMonView, CView)

BEGIN_MESSAGE_MAP(CSVIMonView, CView)
	//{{AFX_MSG_MAP(CSVIMonView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIMonView NX̍\z/

CSVIMonView::CSVIMonView()
{
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB
	BmpViewImageDataEnable = false;
	DirectXMode = false;//DirectX[h
	PrevWidth = 0;
	PrevHeight = 0;
	PrevZoom = 1.;
	MainFrame = NULL;
	PrevVScroolEnable = false;
	PrevHScroolEnable = false;
	imageBitmapDIB	= NULL;
	BefoHeight	= 0;
	BefoWidth	= 0;

	GDIBitmapInfo.bmiHeader.biSize				= sizeof( BITMAPINFOHEADER );
	GDIBitmapInfo.bmiHeader.biPlanes			= 1;
	GDIBitmapInfo.bmiHeader.biBitCount			= 24;
	GDIBitmapInfo.bmiHeader.biCompression		= BI_RGB;
	GDIBitmapInfo.bmiHeader.biXPelsPerMeter		= 0;
	GDIBitmapInfo.bmiHeader.biYPelsPerMeter		= 0;
	GDIBitmapInfo.bmiHeader.biClrUsed			= 0;
	GDIBitmapInfo.bmiHeader.biClrImportant		= 0;

	m_lpCutBuff = new BYTE[2048*1536*3];
}

CSVIMonView::~CSVIMonView()
{
	if(imageBitmapDIB) {
		delete [] imageBitmapDIB;
		imageBitmapDIB = NULL;
	}
	if(m_lpCutBuff) {
		delete [] m_lpCutBuff;
		m_lpCutBuff = NULL;
	}
}

BOOL CSVIMonView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB

#if 1
	//I[o[C\pɃEChENXX^Co^AView̃X^CύX

	HBRUSH hBrushOverlay = 0;
	{
		LOGBRUSH lb;
		lb.lbStyle	= BS_SOLID;
		lb.lbColor	= RGB(DXDISP_COLORKEY_R,DXDISP_COLORKEY_G,DXDISP_COLORKEY_B);
		lb.lbHatch	= 0;
		hBrushOverlay = (HBRUSH)CreateBrushIndirect(&lb);
	}

	ClassStyleName = AfxRegisterWndClass(
      CS_VREDRAW | CS_HREDRAW,
      ::LoadCursor(NULL, IDC_ARROW),
      hBrushOverlay,
      ::LoadIcon(NULL, IDI_APPLICATION));

	cs.lpszClass = ClassStyleName;
#endif
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSVIMonView NX̕`

void CSVIMonView::OnDraw(CDC* pDC)
{
	//CSVIMonDoc* pDoc = GetDocument();
	//ASSERT_VALID(pDoc);

	// TODO: ̏ꏊɃlCeBu f[^p̕`R[hǉ܂B
	drawFrame(AfxGetMainWnd());

}

//Jgt[`悵܂B
void CSVIMonView::drawFrameGDI()
{
	CMainFrame* mainFrame = (CMainFrame*)MainFrame;

	if(mainFrame == NULL)
	{
		return;
	}

	//t[f[^擾
	CFrameData* frameData = mainFrame->FrameDataControl.getViewFrameDataAndLock();
	if(frameData == NULL)
	{
		drawGDI(BefoWidth, BefoHeight);
		return;
	}

	//摜TCY擾
	int width = frameData->getImageSizeWidth();
	int height = frameData->getImageSizeHeight();

	if(width != BefoWidth || height != BefoHeight || !imageBitmapDIB) {
		if(imageBitmapDIB) {
			delete [] imageBitmapDIB;
			imageBitmapDIB = NULL;
		}
		int w = ((width * 3) % 4) + (width*3);
		imageBitmapDIB	= new char[w*height];
		if(!imageBitmapDIB) {
			return;
		}
		BefoWidth	= width;
		BefoHeight	= height;
	}

	AutoResizeWindow();//EChETCY

	//t[擾
	if(PrevHeight != int(height*PrevZoom) || PrevWidth != int(width*PrevZoom))
	{
		PrevHeight = int(height*PrevZoom);
		PrevWidth = int(width*PrevZoom);

		refreshScrollBar();	//XN[o[̒

	}

	//24bitBMPf[^擾
	if(frameData->get24Bitmap(imageBitmapDIB,frameData->get24BitmapImageDataSize(),false,false,NULL) == false)
	{
		//BMP쐬s
		mainFrame->FrameDataControl.UnLockViewFrameData();
		drawGDI();
		return;
	}

	BmpViewImageDataEnable = true;

	//Ńt[[gvXV
	mainFrame->ViewFrameRate.rap();

	drawGDI(width, height);

	//t[f[^AbN
	mainFrame->FrameDataControl.UnLockViewFrameData();
}

// oϐɂBitmapf[^`悵܂
void CSVIMonView::drawGDI(int width, int height)
{
	if(BmpViewImageDataEnable == false)
	{
		return;//bmpf[^ꍇ
	}

	// foCXReLXg
	// foCXReLXg擾
	CClientDC pDC(this);

	CDC dcMem;
	dcMem.CreateCompatibleDC(&pDC);

	CMainFrame* mainFrame = (CMainFrame*)MainFrame;

	//]̃TCY
	int viewWidth,viewHeight;
	viewWidth = int(width*PrevZoom);
	viewHeight = int(height*PrevZoom);

	CBitmap bitmap;
	bitmap.CreateCompatibleBitmap(&pDC, viewWidth, viewHeight);
	CBitmap* pOldBitmap = dcMem.SelectObject(&bitmap);

	dcMem.SelectStockObject(NULL_BRUSH);

	// 摜̐Lk[hZbg
	::SetStretchBltMode( dcMem, COLORONCOLOR );

	int x = GetScrollPos(SB_HORZ);
	int y = GetScrollPos(SB_VERT);

	char* image = imageBitmapDIB;// + sizeof(BITMAPINFO);
	GDIBitmapInfo.bmiHeader.biWidth			= width;
	GDIBitmapInfo.bmiHeader.biHeight		= height;
	GDIBitmapInfo.bmiHeader.biSizeImage		= width * height * 3;

	TRACE("%d, %d, %f\n", x, y, PrevZoom);

	::StretchDIBits(dcMem,
					0 - x,
					0 - y,
					viewWidth,
					viewHeight,  // ]
					0,
					0,
					width,
					height,  // ]
					image, &GDIBitmapInfo, DIB_RGB_COLORS, SRCCOPY);

	CRect clientRect;
	this->GetClientRect(&clientRect);
	COLORREF bkClr = RGB(DXDISP_COLORKEY_R-1,DXDISP_COLORKEY_G,DXDISP_COLORKEY_B);

	// 摜ȊOO[œhԂ

	// foCXReLXg
	clientRect.top = viewHeight;
	clientRect.left = 0;
	pDC.FillSolidRect( &clientRect, bkClr );
	clientRect.top = 0;
	clientRect.left = viewWidth;
	pDC.FillSolidRect( &clientRect, bkClr );

	pDC.BitBlt(0, 0, viewWidth, viewHeight, &dcMem, 0, 0, SRCCOPY);
	dcMem.SelectObject(pOldBitmap);

	//J[o[̍XVs܂
	refreshColorBar();

}

/////////////////////////////////////////////////////////////////////////////
// CSVIMonView NX̐ff

#ifdef _DEBUG
void CSVIMonView::AssertValid() const
{
	CView::AssertValid();
}

void CSVIMonView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSVIMonDoc* CSVIMonView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSVIMonDoc)));
	return (CSVIMonDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSVIMonView NX̃bZ[W nh


int CSVIMonView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;

	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ

	return 0;
}


void CSVIMonView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	//XN[o[tbV
	refreshScrollBar();
}

//EChEړiCt[Ăяo܂j
void CSVIMonView::OnMove(int x, int y)
{
}

//Y[ύXiCt[Ăяo܂j
void CSVIMonView::OnZoom(double zoom)
{
	//{oɕۑ
	PrevZoom = zoom;
	drawFrameGDI();
}

//XN[o[tbV܂B
void CSVIMonView::refreshScrollBar(void)
{
	//XN[o[𕡐XVȂ
	CSingleLock scrollLock(&cs);

	//NCAg̈擾
	CRect clientRect;
	GetClientRect(clientRect);
	int cx = clientRect.Width();
	int cy = clientRect.Height();

	int PageW, PageH;
	// GDI mode
	PageW = cx;
	PageH = cy;

	//XN[̃Wݒ
	{
		SCROLLINFO sclInfo;
		sclInfo.cbSize = sizeof(SCROLLINFO);
		sclInfo.fMask = SIF_PAGE | SIF_RANGE;
		sclInfo.nMax = PrevWidth - 1;
		sclInfo.nMin = 0;
		sclInfo.nPage = PageW;
		SetScrollInfo(SB_HORZ,&sclInfo,TRUE);
	}

	{
		//XN[̃Wݒ
		SCROLLINFO sclInfo;
		sclInfo.cbSize = sizeof(SCROLLINFO);
		sclInfo.fMask = SIF_PAGE | SIF_RANGE;
		sclInfo.nMax = PrevHeight - 1;
		sclInfo.nMin = 0;
		sclInfo.nPage = PageH;
		SetScrollInfo(SB_VERT,&sclInfo,TRUE);
	}
}

void CSVIMonView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ
	// XN[o[̈ʒuύX
	int posMove = GetScrollPos(SB_HORZ);
	switch ( nSBCode ) {
	case SB_LINERIGHT :
		posMove+=2;
		if(posMove > GetScrollLimit(SB_HORZ)) posMove = GetScrollLimit(SB_HORZ);
		break;
	case SB_LINELEFT :
		posMove-=2;
		if(posMove < 0) posMove = 0;
		break;
	case SB_RIGHT :
		posMove = GetScrollLimit(SB_HORZ);
		break;
	case SB_LEFT :
		posMove = 0;
		break;
	case SB_PAGERIGHT :
		posMove += 6;
		if(posMove > GetScrollLimit(SB_HORZ)) posMove = GetScrollLimit(SB_HORZ);
		break;
	case SB_PAGELEFT :
		posMove -= 6;
		if(posMove < 0) posMove = 0;
		break;

	case SB_THUMBPOSITION :
	case SB_THUMBTRACK :
		posMove = nPos;
		break;
	}
	SetScrollPos(SB_HORZ, posMove);

	// ĕ`
	drawFrame(AfxGetMainWnd());

	CView::OnHScroll(nSBCode, nPos, pScrollBar);
}

//XN[
void CSVIMonView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// XN[o[̈ʒuύX
	int posMove = GetScrollPos(SB_VERT);

	switch ( nSBCode ) {
	case SB_LINEDOWN :
		posMove+=2;
		if(posMove > GetScrollLimit(SB_VERT)) posMove = GetScrollLimit(SB_VERT);
		break;
	case SB_LINEUP :
		posMove-=2;
		if(posMove < 0) posMove = 0;
		SetScrollPos(SB_VERT, posMove);
		break;
	case SB_BOTTOM :
		posMove = GetScrollLimit(SB_VERT);
		break;
	case SB_TOP :
		posMove = 0;
		break;
	case SB_PAGEDOWN :
		posMove += 6;
		if(posMove > GetScrollLimit(SB_VERT)) posMove = GetScrollLimit(SB_VERT);
		break;
	case SB_PAGEUP :
		posMove -= 6;
		if(posMove < 0) posMove = 0;
		break;

	case SB_THUMBPOSITION :
	case SB_THUMBTRACK :
		posMove = nPos;
		break;
	}

	SetScrollPos(SB_VERT, posMove);

	// ĕ`
	drawFrame(AfxGetMainWnd());

	CView::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CSVIMonView::OnMouseMove(UINT nFlags, CPoint point)
{
	//J[o[̍XV
	refreshColorBar(&point);

	CView::OnMouseMove(nFlags, point);
}

//EChETCY
void CSVIMonView::AutoResizeWindow()
{
	CMainFrame* mainFrame = (CMainFrame*)MainFrame;
	if(mainFrame == NULL)
	{
		return;
	}


	// AutoWindowSize  ő剻,ŏ\ȊO
	if(mainFrame->SviOptions.Display==true)
	{
		CRect rectClient,rectFrame;

			CMainFrame* frm = (CMainFrame*)AfxGetMainWnd();
			this->GetClientRect(&rectClient);
			frm->GetWindowRect(&rectFrame);
			int Width = (int)((double)BefoWidth*mainFrame->SviOptions.Zoom) + rectFrame.Width() - rectClient.Width();
			int Height = (int)((double)BefoHeight*mainFrame->SviOptions.Zoom) + rectFrame.Height() - rectClient.Height();


			if(Width < 320) {
				Width	= 320 + rectFrame.Width() - rectClient.Width();
			}
			if(GetSystemMetrics(SM_CXSCREEN) < Width || GetSystemMetrics(SM_CYSCREEN) < Height)
			{
				//ʃTCYWidthHeight傫ꍇ̓EChEő剻܂B
				frm->ShowWindow(SW_MAXIMIZE);
			}
			else
			{
				if(!frm->IsIconic())
					//ő剻ĂƂ͖߂܂B
					frm->ShowWindow(SW_SHOWNORMAL);
				frm->MoveWindow(rectFrame.left,rectFrame.top,Width,Height);
			}
	}
}

//J[o[̒lXV܂Biw肵Ȃ΁AŃ}EXWvZ܂j
void CSVIMonView::refreshColorBar(CPoint* pixelPoint)
{
	if(/*DXDisp != NULL && */MainFrame != NULL)
	{
		CMainFrame* mainFrame = (CMainFrame*)MainFrame;
		if(mainFrame->IsColorBarEnable() == true)
		{
			CPoint point;

			if(pixelPoint == NULL)//wȂ
			{
				//}EXJ[\݈̌ʒu擾
				GetCursorPos(&point);
				ScreenToClient(&point);//NCAgWɕϊ
			}
			else
			{
				point = *pixelPoint;
			}

			//zoomƃXN[l
			point.x = long(point.x + (int)((double)GetScrollPos(SB_HORZ))/PrevZoom);
			point.y = long(point.y + (int)((double)GetScrollPos(SB_VERT))/PrevZoom);

			//t[f[^擾
			CFrameData* frameData = mainFrame->FrameDataControl.getViewEndFrame();
			if(frameData == NULL)
			{
				return;
			}
			//t[f[^J[擾
			CYUV yuv = frameData->getPixelYUV(point);
			//t[f[^8x8f[^擾
			BYTE bData[64];
			frameData->get8x8data(point, bData);
			//J[o[_CAOɏ𑗐M
			mainFrame->m_pColorBarDialog->SetMousePoint(point,yuv.getRGB(),yuv,bData);
		}
	}
}
