// SVIOptionDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "svimon.h"
#include "SVIOptionDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSVIOptionDialog _CAO


CSVIOptionDialog::CSVIOptionDialog(CSVIOptions* option, CWnd* pParent /*=NULL*/)
	: CDialog(CSVIOptionDialog::IDD, pParent)
{

	SviOptions = option;

	//{{AFX_DATA_INIT(CSVIOptionDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CSVIOptionDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSVIOptionDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSVIOptionDialog, CDialog)
	//{{AFX_MSG_MAP(CSVIOptionDialog)
	ON_BN_CLICKED(IDC_BTN_OUTPUT_SIZE, OnBtnOutputSize)
	ON_BN_CLICKED(IDC_RADIO_Y, OnRadioY)
	ON_BN_CLICKED(IDC_RADIO_Y10, OnRadioY10)
	ON_BN_CLICKED(IDC_RADIO_Y12, OnRadioY12)
	ON_BN_CLICKED(IDC_RADIO_YUY2, OnRadioYuy2)
	ON_BN_CLICKED(IDC_RADIO_YVYU, OnRadioYvyu)
	ON_BN_CLICKED(IDC_RADIO_YUV, OnRadioYuv)
	ON_BN_CLICKED(IDC_RADIO_VYUY, OnRadioVyuy)
	ON_BN_CLICKED(IDC_RADIO_RGB, OnRadioRgb)
	ON_BN_CLICKED(IDC_BIT_ASS0, OnBitAss0)
	ON_BN_CLICKED(IDC_BIT_ASS1, OnBitAss1)
	ON_BN_CLICKED(IDC_BIT_ASS2, OnBitAss2)
	ON_BN_CLICKED(IDC_BIT_ASS3, OnBitAss3)
	ON_BN_CLICKED(IDC_RADIO_UYVY16, OnRadioUYVY16)
	ON_BN_CLICKED(IDC_RADIO_VYUY16, OnRadioVYUY16)
	ON_BN_CLICKED(IDC_RADIO_YUY216, OnRadioYuy216)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIOptionDialog bZ[W nh

//JbgAEg̃TCYJTCYɕύX
void CSVIOptionDialog::OnBtnOutputSize()
{
	//JOutputƓݒɂ
	SviOptions->CutOutSize.SetRectEmpty();
	SviOptions->CutOutSize.right = SviOptions->SviStatus->getOriginalWidth();
	SviOptions->CutOutSize.bottom = SviOptions->SviStatus->getOriginalHeight();


	CString strWork;

	//JbgAEgTCY
	strWork.Format("%d",SviOptions->CutOutSize.left);
	SetDlgItemText(IDC_CUTOUT_X,strWork);

	strWork.Format("%d",SviOptions->CutOutSize.top);
	SetDlgItemText(IDC_CUTOUT_Y,strWork);

	strWork.Format("%d",SviOptions->CutOutSize.right);
	SetDlgItemText(IDC_CUTOUT_WIDTH,strWork);

	strWork.Format("%d",SviOptions->CutOutSize.bottom);
	SetDlgItemText(IDC_CUTOUT_HEIGHT,strWork);


}

BOOL CSVIOptionDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ

	//IvV̐ݒ𔽉f܂

	CString strWork;
	CRect rectOriginal;
	rectOriginal.SetRectEmpty();
	rectOriginal.right = SviOptions->SviStatus->getOriginalWidth();
	rectOriginal.bottom = SviOptions->SviStatus->getOriginalHeight();

	//Jo͂TCY
	SetDlgItemInt(IDC_CAMERA_OUTPUT_SIZE_WIDTH,rectOriginal.Width());
	SetDlgItemInt(IDC_CAMERA_OUTPUT_SIZE_HEIGHT,rectOriginal.Height());

	//JbgAEgTCY
	if(SviOptions->CutOutSize.IsRectEmpty() == TRUE)
	{
		//l̓JOutput
		SviOptions->CutOutSize = rectOriginal;
	}

	//JbgAEgTCY
	SetDlgItemInt(IDC_CUTOUT_X,SviOptions->CutOutSize.left);
	SetDlgItemInt(IDC_CUTOUT_Y,SviOptions->CutOutSize.top);
	SetDlgItemInt(IDC_CUTOUT_WIDTH,SviOptions->CutOutSize.Width());
	SetDlgItemInt(IDC_CUTOUT_HEIGHT,SviOptions->CutOutSize.Height());


	//Picture Type
	if(SviOptions->PicType == PicYUV)
	{
		((CButton*)GetDlgItem(IDC_RADIO_YUV))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicRGB)
	{
		((CButton*)GetDlgItem(IDC_RADIO_RGB))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicYUY2)
	{
		((CButton*)GetDlgItem(IDC_RADIO_YUY2))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicYVYU)
	{
		((CButton*)GetDlgItem(IDC_RADIO_YVYU))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicVYUY)
	{
		((CButton*)GetDlgItem(IDC_RADIO_VYUY))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicY)
	{
		((CButton*)GetDlgItem(IDC_RADIO_Y))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicY10)
	{
		((CButton*)GetDlgItem(IDC_RADIO_Y10))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicY12)
	{
		((CButton*)GetDlgItem(IDC_RADIO_Y12))->SetCheck(1);
	}
// 2005.12.21 V3.32 *********************************************************
	else if(SviOptions->PicType == PicUYVY16)
	{
		((CButton*)GetDlgItem(IDC_RADIO_UYVY16))->SetCheck(1);
	}
	else if(SviOptions->PicType == PicVYUY16)
	{
		((CButton*)GetDlgItem(IDC_RADIO_VYUY16))->SetCheck(1);
	}
// 2005.12.21 V3.32 *********************************************************
// 2006.03.22 V3.3.6.0 *********************************************************
	else if(SviOptions->PicType == PicYUY216)
	{
		((CButton*)GetDlgItem(IDC_RADIO_YUY216))->SetCheck(1);
	}
// 2006.03.22 V3.3.6.0 *********************************************************
	else
	{
		SviOptions->PicType = PicYUV;
		((CButton*)GetDlgItem(IDC_RADIO_YUV))->SetCheck(1);
	}

// 2005.09.13 V3.21 *********************************************************
// RAW[hKIł悤ɂ
// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 0  // ===================================================================
	// Y[hL/擾
	if(SviOptions->IsYEnable == DEFAULT_REC_YMODEENABLE) {
		((CButton*)GetDlgItem(IDC_RADIO_Y))->ShowWindow(SW_HIDE);
	}
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

	//AutoResizeWindow
	if(SviOptions->Display == true)
	{
		((CButton*)GetDlgItem(IDC_AUTO_WINDOW_SIZE))->SetCheck(1);
	}
	else
	{
		((CButton*)GetDlgItem(IDC_AUTO_WINDOW_SIZE))->SetCheck(0);
	}

	//Memory
	SetDlgItemInt(IDC_DISPLAY_MEM_SIZE,SviOptions->DisplayMemorySizeMByte);
	SetDlgItemInt(IDC_SHARED_MEM_SIZE,SviOptions->SharedMemorySizeMByte);

// 2005.03.28 V3.01 *********************************************************
// GDI`@\ǉ
#if 1  // ===================================================================
	if(SviOptions->isDXmode == true)
		((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->SetCheck(1);
	else
		((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->SetCheck(0);
#endif // ===================================================================
// 2005.03.28 V3.01 *********************************************************

// 2005.04.11 V3.02 *********************************************************
// Recording̃^CAEgԂݒ
#if 1  // ===================================================================
	strWork.Format("%d",SviOptions->RecordingTimeout);
	SetDlgItemText(IDC_REC_TIMEOUT,strWork);
#endif // ===================================================================
// 2005.04.11 V3.02 *********************************************************

// 2006.11.01 V3.37 *********************************************************
// Monitoring̃^CAEgԂݒ
#if 1  // ===================================================================
	strWork.Format("%d",SviOptions->MonitoringTimeout);
	SetDlgItemText(IDC_MON_TIMEOUT,strWork);
#endif // ===================================================================
// 2006.11.01 V3.37 *********************************************************

// 2005.07.30 V3.021 ********************************************************
// PxƃxN^[Otǂw
#if 0  // ===================================================================
	if(SviOptions->IsVectorGraph == true)
		((CButton*)GetDlgItem(IDC_VGRAPH))->SetCheck(1);
	else
		((CButton*)GetDlgItem(IDC_VGRAPH))->SetCheck(0);
#endif // ===================================================================
// 2005.07.30 V3.021 ********************************************************

// 2005.08.02 V3.021 ********************************************************
// Ot̉摜̑傫w 1/nZoom nZoom = 1 or 2
#if 0  // ===================================================================
	if(SviOptions->nZoom == 2)
		((CButton*)GetDlgItem(IDC_RADIO_VGRAPH_1PER2))->SetCheck(1);
	else
		((CButton*)GetDlgItem(IDC_RADIO_VGRAPH_1PER1))->SetCheck(1);
#endif // ===================================================================
// 2005.08.02 V3.021 ********************************************************


// 2005.04.11 V3.03 *********************************************************
// CEdit͕̓
#if 1  // ===================================================================
	((CEdit*)GetDlgItem(IDC_CAMERA_OUTPUT_SIZE_WIDTH))->SetLimitText(5);
	((CEdit*)GetDlgItem(IDC_CAMERA_OUTPUT_SIZE_HEIGHT))->SetLimitText(5);
	((CEdit*)GetDlgItem(IDC_CUTOUT_X))->SetLimitText(5);
	((CEdit*)GetDlgItem(IDC_CUTOUT_Y))->SetLimitText(5);
	((CEdit*)GetDlgItem(IDC_CUTOUT_WIDTH))->SetLimitText(5);
	((CEdit*)GetDlgItem(IDC_CUTOUT_HEIGHT))->SetLimitText(5);
	((CEdit*)GetDlgItem(IDC_DISPLAY_MEM_SIZE))->SetLimitText(3);
	((CEdit*)GetDlgItem(IDC_SHARED_MEM_SIZE))->SetLimitText(3);
	((CEdit*)GetDlgItem(IDC_REC_TIMEOUT))->SetLimitText(3);
#endif // ===================================================================
// 2005.04.11 V3.03 *********************************************************

// 2005.10.05 V3.30 ********************************************************
// j^O[h(0:ޯ̧A1:ݸޯ̧)
	if(SviOptions->bMonMode == 0)
		((CButton*)GetDlgItem(IDC_MONMODE_0))->SetCheck(1);
	else
		((CButton*)GetDlgItem(IDC_MONMODE_1))->SetCheck(1);
// 2005.10.05 V3.30 ********************************************************

// 2005.10.05 V3.30 ********************************************************
// RAWrbgATC(0-3)
	if(SviOptions->iRawBitAss == 0)
		((CButton*)GetDlgItem(IDC_BIT_ASS0))->SetCheck(1);
	else if(SviOptions->iRawBitAss == 1)
		((CButton*)GetDlgItem(IDC_BIT_ASS1))->SetCheck(1);
	else if(SviOptions->iRawBitAss == 2)
		((CButton*)GetDlgItem(IDC_BIT_ASS2))->SetCheck(1);
	else if(SviOptions->iRawBitAss == 3)
		((CButton*)GetDlgItem(IDC_BIT_ASS3))->SetCheck(1);
// 2005.10.05 V3.30 ********************************************************

// 2005.10.17 V3.31 ********************************************************
	//Jo̓tH[}bgRAWȂGDI\݂̂Ƃ
	if(SviOptions->PicType == PicY || SviOptions->PicType == PicY10 || SviOptions->PicType == PicY12){
		if(((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->GetCheck()){
			SviOptions->isDXmode = false;
			((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->SetCheck(0);
		}
		this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(FALSE);
	}
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	if(SviOptions->PicType != PicY10 && SviOptions->PicType != PicY12){
		this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
		this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
		this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
		this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
	}
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłRAWrbgATC𑀍삷
	else if(SviOptions->PicType == PicY10){
		if(SviOptions->iRawBitAss == 2 || SviOptions->iRawBitAss == 3){
			SviOptions->iRawBitAss = 0;
			((CButton*)GetDlgItem(IDC_BIT_ASS0))->SetCheck(1);
		}
		this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(TRUE);
		this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(TRUE);
		this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
		this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
	}else if(SviOptions->PicType == PicY12){
		if(SviOptions->iRawBitAss == 0 || SviOptions->iRawBitAss == 1){
			SviOptions->iRawBitAss = 2;
			((CButton*)GetDlgItem(IDC_BIT_ASS2))->SetCheck(1);
		}
		this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
		this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
		this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(TRUE);
		this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(TRUE);
	}
// 2005.10.17 V3.31 ********************************************************

// 2005.12.21 V3.32 ********************************************************
	// M[h(TRUE:HIGH FALSE:LOW)
	if(SviOptions->bSyncMode == false)
		((CButton*)GetDlgItem(IDC_SYNCMODE_L))->SetCheck(1);
	else
		((CButton*)GetDlgItem(IDC_SYNCMODE_H))->SetCheck(1);
	// 摜f[^荞݃^C~O(TRUE:HIGH FALSE:LOW)
	if(SviOptions->bEdgeMode == false)
		((CButton*)GetDlgItem(IDC_EDGE_L))->SetCheck(1);
	else
		((CButton*)GetDlgItem(IDC_EDGE_H))->SetCheck(1);
// 2005.12.21 V3.32 ********************************************************

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CSVIOptionDialog::OnOK()
{
	// TODO: ̈ʒuɂ̑̌ؗp̃R[hǉĂ

	//̓f[^ؗpR[h
	BOOL check1,check2,check3,check4,check5,check6;

	int cutOutX = GetDlgItemInt(IDC_CUTOUT_X,&check1,FALSE);
	int cutOutY = GetDlgItemInt(IDC_CUTOUT_Y,&check2,FALSE);
	int cutOutWidth = GetDlgItemInt(IDC_CUTOUT_WIDTH,&check3,FALSE);
	int cutOutHeight = GetDlgItemInt(IDC_CUTOUT_HEIGHT,&check4,FALSE);

	//Memory
	int displayMem = GetDlgItemInt(IDC_DISPLAY_MEM_SIZE,&check5,FALSE);
	int sharedMem = GetDlgItemInt(IDC_SHARED_MEM_SIZE,&check6,FALSE);


	//l̃`FbN
	if(cutOutX < 0||cutOutY < 0||cutOutWidth < 1||cutOutHeight < 1 || displayMem < 1 || sharedMem < 1||
		sharedMem > MAX_SHARED_MEM )
	{
		AfxMessageBox(IDS_INPUT_ERROR,NULL,MB_ICONERROR);
		return;
	}

	if(cutOutWidth%2==1)
	{
		//Cutout Setting Widthɂ͋w肵ĂB
		AfxMessageBox(IDS_ERROR_CUTOUT_SETTING_WIDTH,NULL,MB_ICONERROR);
		return;
	}


	//Pictype擾
	if(((CButton*)GetDlgItem(IDC_RADIO_YUV))->GetCheck() == 1)
	{
		SviOptions->PicType = PicYUV;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_RGB))->GetCheck() == 1)
	{
		SviOptions->PicType = PicRGB;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_YUY2))->GetCheck() == 1)
	{
		SviOptions->PicType = PicYUY2;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_YVYU))->GetCheck() == 1)
	{
		SviOptions->PicType = PicYVYU;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_VYUY))->GetCheck() == 1)
	{
		SviOptions->PicType = PicVYUY;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_Y))->GetCheck() == 1)
	{
		SviOptions->PicType = PicY;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_Y10))->GetCheck() == 1)
	{
		SviOptions->PicType = PicY10;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_Y12))->GetCheck() == 1)
	{
		SviOptions->PicType = PicY12;
	}
// 2005.12.21 V3.32 *********************************************************
	else if(((CButton*)GetDlgItem(IDC_RADIO_UYVY16))->GetCheck() == 1)
	{
		SviOptions->PicType = PicUYVY16;
	}
	else if(((CButton*)GetDlgItem(IDC_RADIO_VYUY16))->GetCheck() == 1)
	{
		SviOptions->PicType = PicVYUY16;
	}
// 2005.12.21 V3.32 *********************************************************
// 2006.03.22 V3.3.6.0 *********************************************************
	else if(((CButton*)GetDlgItem(IDC_RADIO_YUY216))->GetCheck() == 1)
	{
		SviOptions->PicType = PicYUY216;
	}
// 2006.03.22 V3.3.6.0 *********************************************************

	//AutoResizeWindow
	if(((CButton*)GetDlgItem(IDC_AUTO_WINDOW_SIZE))->GetCheck() == 1)
	{
		SviOptions->Display = true;
	}
	else
	{
		SviOptions->Display = false;
	}

	//CutOutSize
	SviOptions->CutOutSize.top = cutOutY;
	SviOptions->CutOutSize.left = cutOutX;
	SviOptions->CutOutSize.right = cutOutX + cutOutWidth;
	SviOptions->CutOutSize.bottom = cutOutY + cutOutHeight;


	//J̏o̓TCYƃJbgAEgTCYȂJbgAEgKpȂ
	CRect rectOriginal;
	rectOriginal.SetRectEmpty();
	rectOriginal.right = SviOptions->SviStatus->getOriginalWidth();
	rectOriginal.bottom = SviOptions->SviStatus->getOriginalHeight();
	if(SviOptions->CutOutSize == rectOriginal)
	{
		SviOptions->CutOutSize.SetRectEmpty();
	}

	//Memory
	SviOptions->DisplayMemorySizeMByte = displayMem;
	SviOptions->SharedMemorySizeMByte = sharedMem;

	//DirextX or GDI
	if(((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->GetCheck())
		SviOptions->isDXmode = true;
	else
		SviOptions->isDXmode = false;

	// Recording̃^CAEgԂݒ
	int RecordingTimeout = GetDlgItemInt(IDC_REC_TIMEOUT,&check1,FALSE);
	if(RecordingTimeout < 1) {
		AfxMessageBox(IDS_RECTIMEOUT_ERROR);
		return;
	}
	SviOptions->RecordingTimeout = RecordingTimeout;

// 2006.11.01 V3.37 *********************************************************
// Monitoring̃^CAEgԂݒ
#if 1  // ===================================================================
	int MonitoringTimeout = GetDlgItemInt(IDC_MON_TIMEOUT,&check1,FALSE);
	if(MonitoringTimeout < 0) {
		AfxMessageBox(IDS_MONTIMEOUT_ERROR);
		return;
	}
	SviOptions->MonitoringTimeout = MonitoringTimeout;
#endif // ===================================================================
// 2006.11.01 V3.37 *********************************************************

// 2005.07.30 V3.021 ********************************************************
// PxƃxN^[Otǂw
#if 0  // ===================================================================
	if(((CButton*)GetDlgItem(IDC_VGRAPH))->GetCheck())
		SviOptions->IsVectorGraph = true;
	else
		SviOptions->IsVectorGraph = false;
#endif // ===================================================================
	SviOptions->IsVectorGraph = false;
// 2005.07.30 V3.021 ********************************************************

// 2005.08.02 V3.021 ********************************************************
// Ot̉摜̑傫w 1/nZoom nZoom = 1 or 2
#if 0  // ===================================================================
	if(((CButton*)GetDlgItem(IDC_RADIO_VGRAPH_1PER2))->GetCheck())
		SviOptions->nZoom = 2;
	else
		SviOptions->nZoom = 1;
#endif // ===================================================================
// 2005.08.02 V3.021 ********************************************************

// 2005.10.05 V3.30 ********************************************************
// j^O[h(0:ޯ̧A1:ݸޯ̧)
	if(((CButton*)GetDlgItem(IDC_MONMODE_0))->GetCheck())
		SviOptions->bMonMode = 0;
	else
		SviOptions->bMonMode = 1;
// 2005.10.05 V3.30 ********************************************************

// 2005.10.05 V3.30 ********************************************************
// RAWrbgATC(0-3)
	if(((CButton*)GetDlgItem(IDC_BIT_ASS0))->GetCheck())
		SviOptions->iRawBitAss = 0;
	else if(((CButton*)GetDlgItem(IDC_BIT_ASS1))->GetCheck())
		SviOptions->iRawBitAss = 1;
	else if(((CButton*)GetDlgItem(IDC_BIT_ASS2))->GetCheck())
		SviOptions->iRawBitAss = 2;
	else if(((CButton*)GetDlgItem(IDC_BIT_ASS3))->GetCheck())
		SviOptions->iRawBitAss = 3;
// 2005.10.05 V3.30 ********************************************************

// 2005.12.21 V3.32 ********************************************************
	// M[h(TRUE:HIGH FALSE:LOW)
	if(((CButton*)GetDlgItem(IDC_SYNCMODE_L))->GetCheck())
		SviOptions->bSyncMode = false;
	else
		SviOptions->bSyncMode = true;
	// 摜f[^荞݃^C~O(TRUE:HIGH FALSE:LOW)
	if(((CButton*)GetDlgItem(IDC_EDGE_L))->GetCheck())
		SviOptions->bEdgeMode = false;
	else
		SviOptions->bEdgeMode = true;
// 2005.12.21 V3.32 ********************************************************

	CDialog::OnOK();
}

// 2005.10.17 V3.31 ********************************************************
void CSVIOptionDialog::OnRadioY() 
{
	//Jo̓tH[}bgRAWłDirectX[h͖Ƃ
	if(((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->GetCheck()){
		SviOptions->isDXmode = false;
		((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->SetCheck(0);
	}
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(FALSE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}


void CSVIOptionDialog::OnRadioY10() 
{
	//Jo̓tH[}bgRAWłDirectX[h͖Ƃ
	if(((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->GetCheck()){
		SviOptions->isDXmode = false;
		((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->SetCheck(0);
	}
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(FALSE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłRAWrbgATC𑀍삷
	if(SviOptions->iRawBitAss == 2 || SviOptions->iRawBitAss == 3){
		if(SviOptions->iRawBitAss == 2){
			((CButton*)GetDlgItem(IDC_BIT_ASS2))->SetCheck(0);
		}else{
			((CButton*)GetDlgItem(IDC_BIT_ASS3))->SetCheck(0);
		}
		SviOptions->iRawBitAss = 0;
		((CButton*)GetDlgItem(IDC_BIT_ASS0))->SetCheck(1);
	}
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(TRUE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(TRUE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}

void CSVIOptionDialog::OnRadioY12() 
{
	//Jo̓tH[}bgRAWłDirectX[h͖Ƃ
	if(((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->GetCheck()){
		SviOptions->isDXmode = false;
		((CButton*)GetDlgItem(IDC_DIRECTX_DISPLAY))->SetCheck(0);
	}
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(FALSE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłRAWrbgATC𑀍삷
	if(SviOptions->iRawBitAss == 0 || SviOptions->iRawBitAss == 1){
		if(SviOptions->iRawBitAss == 0){
			((CButton*)GetDlgItem(IDC_BIT_ASS0))->SetCheck(0);
		}else{
			((CButton*)GetDlgItem(IDC_BIT_ASS1))->SetCheck(0);
		}
		SviOptions->iRawBitAss = 2;
		((CButton*)GetDlgItem(IDC_BIT_ASS2))->SetCheck(1);
	}
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(TRUE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(TRUE);
}

void CSVIOptionDialog::OnRadioYuy2() 
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}

void CSVIOptionDialog::OnRadioYvyu() 
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}

void CSVIOptionDialog::OnRadioYuv() 
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}

void CSVIOptionDialog::OnRadioVyuy() 
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}

void CSVIOptionDialog::OnRadioRgb() 
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}

void CSVIOptionDialog::OnBitAss0() 
{
	SviOptions->iRawBitAss = 0;
}

void CSVIOptionDialog::OnBitAss1() 
{
	SviOptions->iRawBitAss = 1;
}

void CSVIOptionDialog::OnBitAss2() 
{
	SviOptions->iRawBitAss = 2;
}

void CSVIOptionDialog::OnBitAss3() 
{
	SviOptions->iRawBitAss = 3;
}
// 2005.10.17 V3.31 ********************************************************

// 2005.12.21 V3.32 ********************************************************
void CSVIOptionDialog::OnRadioUYVY16() 
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}

void CSVIOptionDialog::OnRadioVYUY16() 
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}
// 2005.12.21 V3.32 ********************************************************

// 2006.03.22 V3.3.6.0 ********************************************************
void CSVIOptionDialog::OnRadioYuy216()
{
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂDirectX[h͗LƂ
	this->GetDlgItem(IDC_DIRECTX_DISPLAY)->EnableWindow(TRUE);
	//Jo̓tH[}bgRAW-10bit,RAW-12bitłȂRAWrbgATC͖Ƃ
	this->GetDlgItem(IDC_BIT_ASS0)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS1)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS2)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_BIT_ASS3)->EnableWindow(FALSE);
}
// 2006.03.22 V3.3.6.0 ********************************************************
