// SviStatus.h: CSviStatus NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SVISTATUS_H__4F331F97_EB6B_48BA_BFEF_048081F36895__INCLUDED_)
#define AFX_SVISTATUS_H__4F331F97_EB6B_48BA_BFEF_048081F36895__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SVIPluginComm.h"
#include "SVIComm.h"
#include SVIUSB20_H

//SVIn[hEGAXe[^XێNX
class CSviStatus  
{
public:
	CSviStatus();
	CSviStatus(GET_STATUS &status);
	virtual ~CSviStatus();

	//SVIn[hEGAXe[^Xݒ肵܂
	void setStatus(GET_STATUS &status);

	//SVIn[hEGAXe[^XԂ܂
	GET_STATUS* getStatus(void){return &SviStatus;};

	//SVIn[hEGAXe[^X̂{Xe[^X݂̂ݒ肵܂
	void setBaseStatus(ULONG status);

	//SVIn[hEGAXe[^X̂{Xe[^X݂̂Ԃ܂
	ULONG getBasicStatus(void){return SviStatus.ulBasicStatus;};

	//{Xe[^XIǂ
	bool IsSuccess(void);

	//{Xe[^X𕶎񉻂܂B
	CString getBasicStatusString(ULONG basicStatus);

	//AChԂmF
	bool IsIdle(void){return (SviStatus.ulOPStatus==0);};

	//j^OԂmF
	bool IsMonitring(void){return (SviStatus.ulOPStatus==1);};

	//R[fBOԂmF
	bool IsRecording(void){return (SviStatus.ulOPStatus==2);};

	//Abvf[gmF
	bool IsUpdating(void){return (SviStatus.ulOPStatus==8);};

	//ۗt[Ef[^邩mF
	bool IsFramePending(void){return (SviStatus.ulBasicStatus==SVI_STS_FRAMEPENDING);};

	//IWi̕擾
	int getOriginalWidth(void){return SviStatus.ulOrgSizeW;};

	//IWi̍擾
	int getOriginalHeight(void){return SviStatus.ulOrgSizeH;};

	//j^Oo͂̕擾
	int getMonSizeWidth(void){return SviStatus.ulCutSizeW;};

	//j^Oo͂̍擾
	int getMonSizeHeight(void){return SviStatus.ulCutSizeH;};

// 2005.03.30 V3.01 *********************************************************
// InformationCutout SizeCutoutSettingƓl\Ă邽
// Monitoring wb_̃TCYݒ肷悤ɏC
#if 1  // ===================================================================
	void setMonheader(MON_HEADER Monheader);
	MON_HEADER getMonheader();
#endif // ===================================================================
// 2005.03.30 V3.01 *********************************************************

// 2005.04.06 V3.01 *********************************************************
// VSync̏ꍇA摜擾łȂ
#if 1  // ===================================================================
	inline bool IsVsync() { return (SviStatus.ulCamStatus&Mask_CameraStatus_VSYNC); }
#endif // ===================================================================
// 2005.04.06 V3.01 *********************************************************

// 2006.11.01 V3.37 *********************************************************
// {[ho[WAPLLgǉ
	void setBoardInfo(int iBoardVer,int iPllData){
		m_iBoardVer = iBoardVer;
		m_iPllData  = iPllData;
		return;
	};
	void getBoardInfo(int *iBoardVer,int *iPllData){
		*iBoardVer = m_iBoardVer;
		*iPllData  = m_iPllData;
		return;
	};
// 2006.11.01 V3.37 *********************************************************

private:
	//SVIn[hEGAXe[^X
	GET_STATUS SviStatus;
// 2005.03.30 V3.01 *********************************************************
// InformationCutout SizeCutoutSettingƓl\Ă邽
// Monitoring wb_̃TCYݒ肷悤ɏC
#if 1  // ===================================================================
	MON_HEADER SviMonheader;
#endif // ===================================================================
// 2005.03.30 V3.01 *********************************************************
// 2006.11.01 V3.37 *********************************************************
// {[ho[WAPLLgǉ
	int m_iBoardVer;
	int m_iPllData;
// 2006.11.01 V3.37 *********************************************************
};

#endif // !defined(AFX_SVISTATUS_H__4F331F97_EB6B_48BA_BFEF_048081F36895__INCLUDED_)
