/********************************************************************/
/*	SVIPlugin Common Header											*/
/********************************************************************/
#ifndef	_SVIPLUGINCOMM_H
#define	_SVIPLUGINCOMM_H

#include <stdio.h>
#include <stdlib.h>

/********************************************************/
/*	SVIUSB.h`										*/
/********************************************************/
#define SVIUSB20_H	"SVIUSB20.h"

/********************************************************/
/*	`												*/
/********************************************************/
typedef WORD			DMAD;				// DMA]f[^^Cv
typedef DMAD*			PDMAD;				// DMADւ̃|C^^

/********************************************************/
/*	YUV,RGB֘A											*/
/********************************************************/
#define	YUVLENGTH	4	// YUV
#define	RGB24LENGTH	3	// 24BitRGB
#define	RGB16LENGTH	2	// 16BitRGB

#define CONV_OFFSET	1000	// YUVϊItZbg

/********************************************************/
/*	t[̍ő吔									*/
/********************************************************/
#define	MAX_FRAME	500		// 擾t[̍ő吔

/********************************************************/
/*	1t[őTCY									*/
/********************************************************/
#define	MAX_FRAMEXSIZE	1600			// 1t[̍őwTCY
#define	MAX_FRAMEYSIZE	1600			// 1t[̍őxTCY

#define	MAX_FRAMESIZE	0x800000		// 1t[̏őTCY

/********************************************************/
/*	ԋplyѐ^Ul									*/
/********************************************************/
#define DEF_OK			1	// 
#define	DEF_ERR			-1	// ُ
#define	DEF_READ		1	// rbg}bvt@CǍ
#define DEF_UNREAD		-1	// rbg}bvt@CǍ
#define DEF_PREVIEW		1	// 摜vr[
#define DEF_UNPREVIEW	0	// 摜Xgbv
#define DEF_NONMON		-2	// obt@㏑
#define DEF_NONFRAME	-3	// Jo͉摜TCY0̂Ƃ
#define DEF_OVER64M		-4	// j^Ot[TCY64MB𒴂ꍇ 2004.03.22 kimura-add
#define DEF_NOTFOUNDPLG	-1	// vOCȂꍇ

/********************************************************/
/*	萔												*/
/********************************************************/
#define	MAX_16		16		// 萔16
#define	MAX_32		32		// 萔32
#define	MAX_64		64		// 萔64
#define	MAX_128		128		// 萔128
#define	MAX_256		256		// 萔256
#define	MAX_512		512		// 萔512
#define	MAX_1024	1024	// 萔1024
#define MAX_2048	2048	// 萔2048

#define MAX_FILEPATH	MAX_PATH + 1

/********************************************************/
/*	G[bZ[W									*/
/********************************************************/
#define	MSG_ERR_SHAREDMEMORY			"A shared memory was not securable."				// LmۂłȂƂ
#define	MSG_ERR_SHAREDMEMORYMUPPING		"Mapping of a shared memory went wrong."			// L̃}bsOɎsƂ
#define	MSG_ERR_SHAREDMEMORYNOTFOUND	"The shared memory is not secured."					// LȂƂ
#define MSG_ERR_BUFFERERROR				"Reservation of a buffer went wrong."				// obt@mێs
#define MSG_ERR_INPUTDATA				"An error is in an input."							// ̓f[^Ɍ肪ꍇ

/********************************************************/
/*	EBhEbZ[W								*/
/********************************************************/
// CommonbZ[W
#define	COMMONMESSAGE		WM_USER + 100

enum {
	WM_STARTRECORDING = COMMONMESSAGE,				// RecordingJnbZ[W
	WM_STOPRECORDING,								// Recording~bZ[W
	WM_PLUGIN_DATAINFO1,							// PLUGINւ̃bZ[Wi摜cTCYj
	WM_PLUGIN_DATAINFO2,							// PLUGINւ̃bZ[Wi摜TCYj
	WM_PLUGIN_START,								// PLUGINւ̊JnbZ[W
	WM_WAVE_DRAWSTARTPOS,							// WaveMonitorRec,Viewւ̃bZ[WiJnʒuj
	WM_WAVE_DRAWENDPOS,								// WaveMonitorRec,Viewւ̃bZ[WiIʒuj
	WM_CLOSEPLUGIN,									// vOCN[YbZ[W
	WM_PLUGINSETSTEPCLIP,							// StepClipLevelZbgbZ[W
	WM_PLUGINCHANGEAUTORESIZE,						// AutoResizeZbgbZ[W
	WM_PLUGIN_XYPOINT,								// Pluginւ̃bZ[W X,Y point
	WM_PLUGIN_YVALUE,								// Pluginւ̃bZ[W y Value
	WM_DRAWREDOFFSETSTART,							// Pluginŉ摜Ԃɂ`Jn
	WM_DRAWREDOFFSETEND,							// Pluginŉ摜Ԃɂ`I
	WM_STARTDRAWRECT,								// Pluginŉ摜Ɏlp`悷̂Jn
	WM_STOPDRAWRECT,								// Pluginŉ摜Ɏlp`悷̂𒆎~
	WM_SETRECTPOS,									// Pluginŕ`悷lp`̍ʒu𑗐M
	WM_SETRECTWH_AND_DRAW,							// Pluginŕ`悷lp`̑̕Mƕ`Jn
	WM_CLOSEPARENTS,								// ĂяoN[YbZ[W
	WM_PAINTCONTROL,								// Ăяo\䃁bZ[Wi\j
	WM_UNPAINTCONTROL,								// Ăяo\䃁bZ[Wi\j
	WM_CLOSECOLORDLG,								// Color BarꂽƂ̃bZ[W
	WM_MEMORYRELOCK,								// MemoryĊmۃbZ[W
	WM_PLUGINBMPSNAPSHOT,							// vOCBMPSnapShotsbZ[W
	WM_PLUGIN_SHAREDMEMORY,							// R[fBOf[^Lɏ񂾂Ƃʒm郁bZ[W
	WM_DISPLAYPAGE,									// y[W\v
	WM_YCONTOUR	,									// y[W\v
	WM_VECTORSCOPE,									// DMAf[^m->\v
	WM_MOVECOLORPOS,								// ColorPostionύXɂȂƂ̃bZ[W
	WM_CLOSECOLORPOS,								// ColorPostionꂽƂ̃bZ[W
#if 1	// 2004.09.29 vOC_CAONʒm kimura add
	WM_CREATEWINDOW,								// EBhE\ꂽɃbZ[W
#endif
#if 1	// 2004.10.01 vOC̃j^OTCYύXΉ kimura add
	WM_SETMONSIZE,									// j^OTCYύXʒm
	WM_STOPMONITORING,								// j^O~ʒm
#endif
#if 1	// 2004.10.03 vOC̃j^OJnΉ kimura add
	WM_STARTMONITORING,
#endif
// 2005.04.06 V2.01 *********************************************************
// vOCPIC[hύXł悤ύX
#if 1  // ===================================================================
	WM_SETPICMODE,									// PICTURE TYPEύX
#endif // ===================================================================
// 2005.04.06 V2.01 *********************************************************

// 2005.04.28 V3.06 *********************************************************
// X`摜擾bZ[W
#if 1  // ===================================================================
	WM_GETSTILLIMAGE,									// SVImonStill摜擾邽߂̃bZ[W
#endif // ===================================================================
// 2005.04.28 V3.06 *********************************************************

// 2005.05.04 V3.07 *********************************************************
// X`摜TCYݒ胁bZ[W
#if 1  // ===================================================================
	WM_SETSTILLSIZE,									// SVImonStill摜̔s߂̃TCYݒ肷郁bZ[W
#endif // ===================================================================
// 2005.05.04 V3.07 *********************************************************
#if 1 // Vxxxx
    WM_CURRENTFRAME,    // SVIView ŕ\Ăt[ԍʒm
    WM_MOUSECLICKXY,    // SVIView ŕ\Ă摜ENbNꍇɔ
#endif
};

/********************************************************/
/*	ʃ֘A										*/
/********************************************************/
// eʃ
#define	SHARED_RECORDER_NAME		"SharedMonr"			// SVIMonpʃ
#define SHARED_RECORDER_PLUGIN		"SharedMonPlugin"		// vOCpRecorderʃ
#define	SHARED_VIEWER_NAME			"SharedView"			// SVIViewpʃ
#define SHARED_VIEWERONLY_NAME		"SharedViewOnly"		// SVIViewOnlypʃ

// eʃTCY
#define MONITORING_BUFFER_SIZE		0x4000000
#if 1 // 2006.11.09 128MB->256MB
#define	SHARED_MEMORY_SIZE			0x10000000				// ʃTCYi256MBj
#else
#define	SHARED_MEMORY_SIZE			0x8000000				// ʃTCYi128MBj
#endif // 2006.11.09 128MB->256MB

/********************************************************/
/*	Datwb_֘A										*/
/********************************************************/
#define DEF_8BITSDAT	0	// 8BitsDatt@C
#define DEF_16BITSDAT	1	// 16BitsDatt@C
#define	DEF_OTHERFILE	2	// ُt@C

// Datt@Cwb_
#pragma pack(1)
typedef struct {
	char			ApplicationID[10];		// AvP[VID
	unsigned char	version_of_firmware;	// t@[EFAo[Wԍ
	unsigned char	version_of_hardware;	// n[hEFÃo[Wԍ
	short			num_of_channel;			// 0x0001Œ
	unsigned char	compression_flag;		// ktO 0:񈳏k 1:k
	long			num_of_scan;			// f[^TCY
	short			data_width;				// f[^ 0:8bits 1:16bits Œ
	short			channel_order;			// 0x0000Œ
	short			ad_range;				// 0x0000Œ
	double			scan_rate;				// 0x0000000000000000Œ
	short			num_of_channel_range;	// 0x0000Œ
	char			start_date[8];			// ^Jn
	char			start_time[8];			// ^Jn
	char			start_millsec[3];		// ^Jn(ms)
	char			reserved[2];			// 0x0000Œ
	long			offset;					// 摜f[^ւ̃ItZbg	0x00000000(͌Œ)
}sDatFileHeader;
#pragma pack()

// Datt@Cwb_
#pragma pack(1)
typedef struct {
	char			ApplicationID[10];		// AvP[VID
	short			card_type;				// t@[EFAo[Wԍ
	short			num_of_channel;			// 0x0001Œ
	unsigned char	channel_no;				// 0x00Œ
	long			num_of_scan;			// f[^TCY
	short			data_width;				// f[^ 0:8bitsŒ
	short			channel_order;			// 0x0000Œ
	short			ad_range;				// 0x0000Œ
	double			scan_rate;				// 0x0000000000000000Œ
	short			num_of_channel_range;	// 0x0000Œ
	char			start_date[8];			// ^Jn
	char			start_time[8];			// ^Jn
	char			start_millsec[3];		// ^Jn(ms)
	char			reserved[6];			// 0x000000000000Œ
}sOldDatFileHeader;
#pragma pack()

// Datڐ
#define DATITEMNUM		16	// 16BitDatt@CTCY
#define OLDDATITEMNUM	14	// 8BitDatt@CTCY

// Datt@Cwb_[TCY
#define	DATHEADERSIZE	60

// Datwb_ڃTCY
#define	APPLICATIONIDSIZE	10
#define	STARTDATESIZE		8
#define	STARTTIMESIZE		8
#define	STARTMILLSECSIZE	3
#define	RESERVEDSIZE		2
#define DATOFFSET			4
#define	OLDRESERVEDSIZE		6

#define	DEF_SIGNPLUS	"+"
#define	DEF_SIGNMINUS	"-"

/********************************************************/
/*	AutoResize֘A										*/
/********************************************************/
#define DEF_AUTORESIZE		1
#define DEF_UNAUTORESIZE	0


// 2005.07.20 V3.20 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 1  // ===================================================================
/********************************************************/
/*	摜J[֘A										*/
/********************************************************/
//PictureTypeݒ
typedef enum enumPictureType
{
	PicYUV = 0,	//R[fBOAj^O摜f[^UYVYƂ݂Ȃ܂
	PicRGB,		//R[fBOAj^O摜f[^RGB565Ƃ݂Ȃ܂
	PicY,		//R[fBOAj^O摜f[^Y(RAW-8rbg)Ƃ݂Ȃ܂
	PicYUY2,	//R[fBOAj^O摜f[^YUY2Ƃ݂Ȃ܂
	PicYVYU,	//R[fBOAj^O摜f[^YVYUƂ݂Ȃ܂
	PicVYUY,	//R[fBOAj^O摜f[^VYUYƂ݂Ȃ܂
// 2005.10.05 V3.30 *********************************************************
// RAWf[^10rbgA12rbgǉ
	PicY10,		//R[fBOAj^O摜f[^Y(RAW-10rbg)Ƃ݂Ȃ܂
	PicY12,		//R[fBOAj^O摜f[^Y(RAW-12rbg)Ƃ݂Ȃ܂
// 2005.10.05 V3.30 *********************************************************
// 2005.12.21 V3.32 *********************************************************
	PicUYVY16,	//R[fBOAj^O摜f[^UYVY-16rbgƂ݂Ȃ܂
	PicVYUY16,	//R[fBOAj^O摜f[^VYUY-16rbgƂ݂Ȃ܂
// 2005.12.21 V3.32 *********************************************************
// 2006.03.22 V3.3.6.0 ******************************************************
	PicYUY216,	//R[fBOAj^O摜f[^YUY2-16rbgƂ݂Ȃ܂
// 2006.03.22 V3.3.6.0 ******************************************************
} PictureType, *PPictureType;
#else  // ===================================================================
// 2005.04.05 V3.01 *********************************************************
// t[f[^̃J[̎ނ̎ʕ@ύX
#if 1  // ===================================================================
/********************************************************/
/*	摜J[֘A										*/
/********************************************************/
//PictureTypeݒ
typedef enum enumPictureType
{
	PicYUV = 0,	//R[fBOAj^O摜f[^YUVƂ݂Ȃ܂
	PicRGB,		//R[fBOAj^O摜f[^RGBƂ݂Ȃ܂
	PicY,		//R[fBOAj^O摜f[^YƂ݂Ȃ܂
} PictureType, *PPictureType;
#endif // ===================================================================
// 2005.04.05 V3.01 *********************************************************

#endif  // ===================================================================
// 2005.07.20 V3.20 *********************************************************

/********************************************************/
/*	t@C									*/
/********************************************************/
#define SVI_INIFILE			"SVIcomm.ini"		// init@C

// ʕ
#define	DEF_APPCOMMNAME			"SVI"				// ZNV
#define	DEF_MAXBUFFSIZEKEY		"MAXBUFFSIZE"		// j^Opobt@TCYL[
#define DEF_MAXFRAMEXSIZEKEY	"MAXFRAMEXSIZE"		// MAXFRAMEXSIZEL[
#define DEF_MAXFRAMEYSIZEKEY	"MAXFRAMEYSIZE"		// MAXFRAMEYSIZEL[
#define	DEF_SHAREDMEMORYSIZEKEY	"SHAREDMEMORYSIZE"	// RecorderLTCYL[

extern	_TCHAR	ggszCommIniFile[MAX_FILEPATH];	// init@CpX

/********************************************************/
/*	vOC֘A										*/
/********************************************************/
#if 0	// vOCC^[tF[XύX
typedef HWND (CALLBACK *PSHOWDIALOG)();						// pShowDialog֐
#else
typedef UINT (CALLBACK *PSHOWDIALOG)(int nNo);						// pShowDialog֐
#endif
#if 1	// vOCC^[tF[XύX
typedef HWND (CALLBACK *PWAITSIGNAL)();						// plg_sviWaitSignal֐
#define	DEF_PROCNAME_WAIT		"plg_sviWaitSignal"			// plg_sviWaitSignal֐֐
#endif

typedef void (CALLBACK *LPFNDLLFUNC)(						// GetPluginInfo֐
									 HWND	hParentWnd,		// [IN]  ĂяoEBhEnh
									 BOOL	bPMode,			// [IN]  ĂяoʃtO
									 LPSTR	strSharedName,	// [IN]  ĂяoL
									 LPSTR	strPlugInfo,	// [OUT] vOC
									 int*	iSpec );		// [OUT] vOCΉ

#define	DEF_PROCNAME_INFO		"plg_sviGetPluginInfo"			// plg_sviGetPluginInfo֐
#define	DEF_PROCNAME_PLUGIN		"plg_sviCreatePlugin"			// plg_sviCreatePlugin֐

// vOCfBNg
#define	DEF_PLUGINFILEPATH		"\\plg"

// vOC
#if 1	// 2004.10.06 vOCI[gNΉ kimura add
// mon, viewΉ
#define SPEC_MON		0x01				// SVImovpvOC
#define	SPEC_VIEW		0x02				// SVIViewpvOC
#define	SPEC_COMMON		0x03				// ʃvOC
// I[gNΉ
#define PLG_AUTO_ON		0x10				// I[gNON
#define PLG_AUTO_OFF	0x00				// I[gNOFF
#else
enum {
	SPEC_MON	= 0,			// SVImovpvOC
	SPEC_VIEW,					// SVIViewpvOC
	SPEC_COMMON,				// ʃvOC
}
#endif

#define DEF_LINEBOLD		1				// Wave MonitorCiRecorderAViewerj
#define DEF_MESSAGECOUNT	5				// Pluginւ̃bZ[WJEg

enum {
	eStartLens	= 0,		// Lens ShadingN
	eStopLens,				// Lens Shading~
};

enum {
	UNDRAWLINE	= 0,		// WaveMonitor `֎~
	DRAW_HORIZON,			// `
	DRAW_VERTICAL,			// `
};

enum {
	SURELYREAD = 0,			// KM
	UNSURELYREAD,			// vOCCӎM
};

#define RMODE	TRUE		// Recorder[h
#define VMODE	FALSE		// Viewer[h

#define DEF_VECTORAREACOLOR	RGB( 0, 255, 0 )	// GREEN
#define DEF_WAVESTARTLINE	RGB( 255, 0, 0 )	// RED
#define DEF_WAVEENDLINE		RGB( 0, 0, 255 )	// BLUE

#define DEF_MAXPLUGIN		32								// o^\vOCő吔
#define DEF_PLUGINID		0xE000							// vOCJnID
#define DEF_PLUGINENDID		DEF_PLUGINID + DEF_MAXPLUGIN	// vOCIID(0xF000ȉł邱)

// vOCi[\
#pragma pack(1)
typedef struct {
	int			iNo;								// vOCԍiTj
	char		strFileName[MAX_FILEPATH];			// vOCt@C
	char		strPluginName[MAX_FILEPATH];		// vOCl[
	char		strCreateName[MAX_FILEPATH];		// N֐
	char		strVersion[MAX_16];					// o[W
	HINSTANCE	hPluginInstance;					// CX^X
	HWND		hWnd;								// EBhEnh
	int			nSpec;								// vOCΉ
}sPluginInfo;
#pragma pack()

// 2005.04.28 V3.06 *********************************************************
// X`摜擾
#if 1  // ===================================================================
typedef enum enumStillResult {
	STILL_OK = 0,
	STILL_ERROR,
} StillResult, *PStillResult;
#endif // ===================================================================
// 2005.04.28 V3.06 *********************************************************

/********************************************************/
/*	ʊ֐											*/
/********************************************************/

/********************************************************************/
/*	֐hcFIsFigure												*/
/*	֐́F`FbN										*/
/*	@\TvF^ꂽ񂪐ϊłDEF_OK,				*/
/*			  ϊłȂDEF_NGԂ						*/
/********************************************************************/
int	IsFigure(
			CString& strCheckData );	// [IN] `FbNf[^

/********************************************************************/
/*	֐hcFCreateMapping											*/
/*	֐́FL}bsO									*/
/*	@\TvFL}bsO							*/
/*  ߂l  F\z/ُ											*/
/********************************************************************/
int CreateMapping(
				HANDLE*	hMapping,				// [IO] L}bsOnh
				DWORD	dwMemorySize,			// [IN] LmۃTCY
				CString	strSharedMemoryName );	// [IN] L

/********************************************************************/
/*	֐hcFCheckMapping											*/
/*	֐́F}bvr[`FbN									*/
/*	@\TvF}bvꂽr[`FbN						*/
/*  ߂l  F/ُ												*/
/********************************************************************/
int CheckMapping(
						HANDLE*	hMapping,			// [IO] L}bsOnh
						void*	pMapViewAddress );	// [IN] }bvꂽr[̊JnAhX

/********************************************************************/
/*	֐hcFOpenMapping											*/
/*	֐́FLI[v									*/
/*	@\TvFLI[v								*/
/*  ߂l  F\z/ُ											*/
/********************************************************************/
int OpenMapping(
				DWORD	dwDesiredAccess,		// [IN] LANZX[h
				HANDLE*	hMapping,				// [IO] L}bsOnh
				CString	strSharedMemoryName );	// [IN] L

/********************************************************************/
/*	֐hcFCreateSharedMemory									*/
/*	֐́FL\z										*/
/*	@\TvFL\ziBYTE^j						*/
/*  ߂l  Fnh												*/
/********************************************************************/
HANDLE CreateSharedMemory(
							  LPBYTE*	pDataBuff,				// [OUT] Lւ̃|C^
							  HANDLE	hMapping,				// [IN]  L̃nh
							  DWORD		dwSharedMemorySize,		// [OUT] L̃TCY
							  CString	strSharedName );		// [IN]  L

/********************************************************************/
/*	֐hcFCreateSharedMemory									*/
/*	֐́FL\z										*/
/*	@\TvFL\ziBYTE^j						*/
/*  ߂l  Fnh												*/
/********************************************************************/
HANDLE CreateSharedMemory(
							  PDMAD*	pDataBuff,				// [OUT] Lւ̃|C^
							  HANDLE	hMapping,				// [IN]  L̃nh
							  DWORD		dwSharedMemorySize,		// [OUT] L̃TCY
							  CString	strSharedName );		// [IN]  L

/********************************************************************/
/*	֐hcFCalcPadding											*/
/*	֐́FpfBOvZ										*/
/*	@\TvF摜̃pfBOvZ							*/
/*  ߂l  F쐬/ُ											*/
/********************************************************************/
DWORD CalcPadding( DWORD dwXSize );

#endif	// _SVIPLUGINCOMM_H
