// MonHeadMonitorDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "MonHeadMonitor.h"
#include "MonHeadMonitorDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMonHeadMonitorDialog _CAO


CMonHeadMonitorDialog::CMonHeadMonitorDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CMonHeadMonitorDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMonHeadMonitorDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}


void CMonHeadMonitorDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMonHeadMonitorDialog)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMonHeadMonitorDialog, CDialog)
	//{{AFX_MSG_MAP(CMonHeadMonitorDialog)
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP

	//[U[`bZ[W}bv
	ON_MESSAGE(WM_PLUGIN_START,OnWM_PLUGIN_START)
	ON_MESSAGE(WM_CLOSEPARENTS,OnWM_CLOSEPARENTS)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMonHeadMonitorDialog bZ[W nh

void CMonHeadMonitorDialog::OnRead() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetInfo(MonitorDataHeader);
}

BOOL CMonHeadMonitorDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	// XgRg[擾EX^Cݒ

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ

	CListCtrl* listctrl = (CListCtrl*)this->GetDlgItem(IDC_INFOLIST);
	
	listctrl->ModifyStyle(0, LVS_REPORT | LVS_SHOWSELALWAYS | LVS_NOSORTHEADER, 0);
	DWORD style = listctrl->GetExtendedStyle();
	style |=  LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_HEADERDRAGDROP;
	listctrl->SetExtendedStyle(style);

	CSize size1, size2;
	LV_COLUMN lvcol;
	const int adj = 70;// ꎞIȗ

	lvcol.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.pszText = _T("PARAM");
	lvcol.cx = adj;
	lvcol.iSubItem = 0;
	listctrl->InsertColumn(0, &lvcol);

	lvcol.pszText = _T("HEX");
	lvcol.cx = adj;
	lvcol.iSubItem = 1;
	listctrl->InsertColumn(1, &lvcol);

	lvcol.pszText = _T("VALUE");
	lvcol.cx = adj;
	lvcol.iSubItem = 2;
	listctrl->InsertColumn(2, &lvcol);
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

int CMonHeadMonitorDialog::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ


	HWND hWnd = ((CMonHeadMonitorApp*)AfxGetApp())->hParentWnd;
	
	// FvOCʃR[h@FʐMpEChEnh
	::PostMessage(hWnd,WM_CREATEWINDOW,((CMonHeadMonitorApp*)AfxGetApp())->PluginNo,(long)m_hWnd);
	
	return 0;
}

//bZ[WWM_PLUGIN_STARTM
LRESULT CMonHeadMonitorDialog::OnWM_PLUGIN_START(WPARAM wParam, LPARAM lParam)
{
	// LI[v
	HANDLE hMapping = ::OpenFileMapping(FILE_MAP_READ,FALSE,SharedMemName);
	if(hMapping == NULL)
	{
		TRACE("CMonHeadMonitorDialog::OnWM_PLUGIN_START L擾s\r\n");
		return 0;//L擾s
	}

	// L}bsO
	void* lpBuf = ::MapViewOfFile( hMapping, FILE_MAP_READ,0, 0, 0);
	if(lpBuf == NULL)
	{
		TRACE("CMonHeadMonitorDialog::OnWM_PLUGIN_START L}bvs\r\n");
		::CloseHandle(hMapping);
		return 0;//L擾s
	}
	memcpy(&MonitorDataHeader,lpBuf,sizeof(MON_HEADER));

	CButton* check = (CButton*)GetDlgItem(IDC_REALTIME);

	// `FbNɂă^C}[ON/OFF
	if(check->GetCheck()) OnRead();

	// |C^}bsO
	::UnmapViewOfFile(lpBuf);
	//LN[Y
	::CloseHandle(hMapping);

	return 0;
}

//bZ[WWM_CLOSEPARENTSM
LRESULT CMonHeadMonitorDialog::OnWM_CLOSEPARENTS(WPARAM wParam, LPARAM lParam)
{
	//Iʒm	
	this->PostMessage(WM_CLOSE,0,0);
	return 0;
}


// Hex̐ݒ
void CMonHeadMonitorDialog::SetHex(CString& strRtn,void* value, size_t size)
{
	vector<byte> vecWork;
	vecWork.resize(size);
	memcpy(&vecWork[0],value,size);

	CString strWork;
	// tɒǉ
	for(int i = 0 ;i < size;i++)
	{
		strWork.Format("%02X ",vecWork[i]);
		strRtn = strWork + strRtn;
	}
}

void CMonHeadMonitorDialog::AddElm(LPCTSTR param ,LPCTSTR hex ,LPCTSTR value)
{
	CListCtrl* listctrl = (CListCtrl*)this->GetDlgItem(IDC_INFOLIST);
	LV_ITEM item;
	memset(&item, 0, sizeof(LV_ITEM));

	// sɃACeǉ
	int cntItem = listctrl->GetItemCount();
	int cntColum = 0;

	item.mask = LVIF_TEXT | LVIF_PARAM;
	item.iItem = cntItem;
	item.pszText = (LPTSTR)param;
	item.iSubItem = cntColum;
	listctrl->InsertItem(&item);

	// ύX
	cntColum++;
	item.mask = LVIF_TEXT;
	item.pszText = (LPTSTR)hex;
	item.iSubItem = cntColum;
	listctrl->SetItem(&item);

	cntColum++;
	item.pszText = (LPTSTR)value;
	item.iSubItem = cntColum;
	listctrl->SetItem(&item);
}

void CMonHeadMonitorDialog::SetInfo(MON_HEADER MonitorDataHeader)
{
	// XgRg[擾EX^Cݒ
	CListCtrl* listctrl = (CListCtrl*)this->GetDlgItem(IDC_INFOLIST);
	
	listctrl->DeleteAllItems();
	// ACe\
	AddList("Status",MonitorDataHeader.ulStatus,sizeof(MonitorDataHeader.ulStatus));
	AddList("PendingInfo",MonitorDataHeader.ulPendingInfo,sizeof(MonitorDataHeader.ulPendingInfo));
	AddList("OrgSizeW",MonitorDataHeader.ulOrgSizeW,sizeof(MonitorDataHeader.ulOrgSizeW));
	AddList("OrgSizeH",MonitorDataHeader.ulOrgSizeH,sizeof(MonitorDataHeader.ulOrgSizeH));
	AddList("Cutout_x",MonitorDataHeader.ulCutout_x,sizeof(MonitorDataHeader.ulCutout_x));
	AddList("Cutout_y",MonitorDataHeader.ulCutout_y,sizeof(MonitorDataHeader.ulCutout_y));
	AddList("MonSizeW",MonitorDataHeader.ulMonSizeW,sizeof(MonitorDataHeader.ulMonSizeW));
	AddList("MonSizeH",MonitorDataHeader.ulMonSizeH,sizeof(MonitorDataHeader.ulMonSizeH));
	AddList("FrameRate",MonitorDataHeader.ulFrameRate,sizeof(MonitorDataHeader.ulFrameRate));
	AddList("LoseFrame",MonitorDataHeader.ulLoseFrame,sizeof(MonitorDataHeader.ulLoseFrame));
	AddList("OpticalAxisInfo",MonitorDataHeader.ulOpticalAxisInfo,sizeof(MonitorDataHeader.ulOpticalAxisInfo));
	AddList("CursorX",MonitorDataHeader.usCursorX,sizeof(MonitorDataHeader.usCursorX));
	AddList("CursorY",MonitorDataHeader.usCursorY,sizeof(MonitorDataHeader.usCursorY));
	AddList("WakuLeftX",MonitorDataHeader.usWakuLeftX,sizeof(MonitorDataHeader.usWakuLeftX));
	AddList("WakuLeftY",MonitorDataHeader.usWakuLeftY,sizeof(MonitorDataHeader.usWakuLeftY));
	AddList("WakuRightX",MonitorDataHeader.usWakuRightX,sizeof(MonitorDataHeader.usWakuRightX));
	AddList("WakuRightY",MonitorDataHeader.usWakuRightY,sizeof(MonitorDataHeader.usWakuRightY));

	// 񕝂̍œK
	listctrl->SetColumnWidth(0,LVSCW_AUTOSIZE);
	listctrl->SetColumnWidth(1,LVSCW_AUTOSIZE);
}

void CMonHeadMonitorDialog::AddList(LPCTSTR param, unsigned long value, size_t size)
{
	CString strValue,strHex;
	// Value̐ݒ
	strValue.Format("%d",value);
	// Hex̐ݒ
	SetHex(strHex,&value,size);
	AddElm(param,strHex,strValue);
}

void CMonHeadMonitorDialog::AddList(LPCTSTR param, unsigned short value, size_t size)
{
	CString strValue,strHex;
	// Value̐ݒ
	strValue.Format("%d",value);
	// Hex̐ݒ
	SetHex(strHex,&value,size);
	AddElm(param,strHex,strValue);
}

//EChȄI
void CMonHeadMonitorDialog::OnClose() 
{
	HWND hWnd = ((CMonHeadMonitorApp*)AfxGetApp())->hParentWnd;

	//ĂяoWM_CLOSEPLUGIN̑M
	::PostMessage(hWnd,WM_CLOSEPLUGIN,UINT(m_hWnd),0);

	CDialog::OnClose();
}
