// SVIGPIODialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "SVIGPIO.h"
#include "SVIGPIODialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSVIGPIODialog _CAO


CSVIGPIODialog::CSVIGPIODialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSVIGPIODialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSVIGPIODialog)
	//}}AFX_DATA_INIT
}


void CSVIGPIODialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSVIGPIODialog)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSVIGPIODialog, CDialog)
	//{{AFX_MSG_MAP(CSVIGPIODialog)
	ON_BN_CLICKED(IDC_INPUT_BTN, OnInputBtn)
	ON_BN_CLICKED(IDC_OUTPUT_BTN, OnOutputBtn)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_EN_KILLFOCUS(IDC_OUTP3_EDIT, OnKillfocusOutp3Edit)
	ON_EN_KILLFOCUS(IDC_OUTP4_EDIT, OnKillfocusOutp4Edit)
	ON_EN_KILLFOCUS(IDC_OUTP5_EDIT, OnKillfocusOutp5Edit)
	ON_EN_KILLFOCUS(IDC_OUTP6_EDIT, OnKillfocusOutp6Edit)
	ON_EN_KILLFOCUS(IDC_OUTP7_EDIT, OnKillfocusOutp7Edit)
	ON_EN_KILLFOCUS(IDC_OUTP8_EDIT, OnKillfocusOutp8Edit)
	ON_EN_KILLFOCUS(IDC_OUTP9_EDIT, OnKillfocusOutp9Edit)
	ON_EN_KILLFOCUS(IDC_OUTP10_EDIT, OnKillfocusOutp10Edit)
	//}}AFX_MSG_MAP

	//[U[`bZ[W}bv
	ON_MESSAGE(WM_CLOSEPARENTS,OnWM_CLOSEPARENTS)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSVIGPIODialog bZ[W nh

BOOL CSVIGPIODialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: ̈ʒuɏ̕⑫ǉĂ
	
	// EBhE^Cgݒ
	CString csDlgTitle;
	this->GetWindowText(csDlgTitle);
	csDlgTitle += ggVersionInfo;
	this->SetWindowText(csDlgTitle);

	// _CAO
	InitDialogInfo();

	// GPIOԎ擾
	OnInputBtn();
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    DialogInfoInit
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    _CAÕ`FbN{bNXEDIT{bNX
//
//  EXPLANATION
//    Init@Cݒ擾ݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::InitDialogInfo()
{
	BOOL bSetChkStat;		// `FbN{bNXݒl擾
	CButton* cbGetChkID;	// `FbN{bNXID擾
	CEdit* ceGetEditID;	// `FbN{bNXID擾
	
	// INIt@C̓ǂݍ
	CIniFileControl IniFileCtrl(DEF_INI_APP, ggszIniFile);

	// InP0ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P0,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP0_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//InP1ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P1,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP1_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//InP2ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P2,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP2_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//InP11ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P11,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP11_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//InP12ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P12,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP12_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//InP13ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P13,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP13_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);	

	//InP14ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P14,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP14_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//InP15ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_IN_P15,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP15_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP3ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P3,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP3_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP4ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P4,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP4_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP5ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P5,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP5_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP6ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P6,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP6_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP7ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P7,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP7_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP8ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P8,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP8_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP9ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P9,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP9_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);

	//OutP10ݒ擾
	bSetChkStat = IniFileCtrl.getInt(DEF_OUT_P10,FALSE);
	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP10_CHK);
	// {^ԃZbg
	cbGetChkID->SetCheck(bSetChkStat);
	
	// eLXg{bNXl擾
	// eLXg{bNXl擾P3ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP3_EDIT);
	ceGetEditID->SetWindowText("0");
	// eLXg{bNXl擾P4ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP4_EDIT);
	ceGetEditID->SetWindowText("0");
	// eLXg{bNXl擾P5ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP5_EDIT);
	ceGetEditID->SetWindowText("0");
	// eLXg{bNXl擾P6ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP6_EDIT);
	ceGetEditID->SetWindowText("0");
	// eLXg{bNXl擾P7ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP7_EDIT);
	ceGetEditID->SetWindowText("0");
	// eLXg{bNXl擾P8ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP8_EDIT);
	ceGetEditID->SetWindowText("0");
	// eLXg{bNXl擾P9ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP9_EDIT);
	ceGetEditID->SetWindowText("0");
	// eLXg{bNXl擾P10ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP10_EDIT);
	ceGetEditID->SetWindowText("0");
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnInputBtn
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    INPUT{^
//
//  EXPLANATION
//    _CAOŎw肵|[g̏擾\܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::OnInputBtn() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	DWORD	dwRet;			//GpioAccʎ擾
	ULONG	ulMode;			// o̓tOiOF́APGój
	ULONG	ulBitMask;		// bit2bit0ŃANZX|[ĝ݂PZbgAOŖ
	ULONG	ulData;			// o̓f[^(bit2bit0L)
	ULONG	ulRsv;			// \(2005/10/14݂͖gp̂0Zbg)

	// GPIOANZXf[^쐬
	// ϐ̏
	ulMode = 0;				// OF
	ulBitMask = 0xFF;		//@S|[gANZXtOݒ
	ulData = 0;				// o̓f[^
	ulRsv = 0;				// \(2005/10/14݂͖gp̂0Zbg)

	// foCXhCoI[v܂
	dwRet = SVIUSB20_Open(SVIUSB20_APP_WHO_CTL);
	if(dwRet != SVIUSB20_RET_NORMAL)
	{
		CString ErrMessage;
		ErrMessage.Format("foCXhCõI[vɎs܂BG[R[h %X",dwRet);
		MessageBox(ErrMessage);
		return;
	}

	// GPIOANZX܂iS|[gf[^擾j
	dwRet = SVIUSB20_GpioAcc(ulMode, ulBitMask, &ulData, 0);
	// 擾
	if(dwRet == SVIUSB20_RET_NORMAL)
	{
		// 擾GPIOInPort̃X^eBbNeLXgɔf
		GetInPortInfo(ulData);

		// foCXhCoN[Y܂
		dwRet = SVIUSB20_Close(SVIUSB20_APP_WHO_CTL);
		if(dwRet != SVIUSB20_RET_NORMAL)
		{
			CString ErrMessage;
			ErrMessage.Format("foCXhCõN[YɎs܂BG[R[h %X",dwRet);
			MessageBox(ErrMessage);
			return;
		}
	}
	// 擾s
	else
	{
		// G[̂Ƃ͂ǂ܂傤H
		if(dwRet == SVIUSB20_RET_ERROR_PARAMETER)
		{
			MessageBox("ɊԈႢ܂");
		}
		else if(dwRet == SVIUSB20_RET_ERROR_NOOPEN)
		{
			MessageBox("I[vĂ܂");
		}
		else
		{
			CString ErrMessage;
			ErrMessage.Format("GPIO̐ݒɎs܂BG[R[h %X",dwRet);
			MessageBox(ErrMessage);
		}
	}
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnOutputBtn
//
//  PARAMETER
//    NONE
//
//  SUMMARY
//    OUTPUT{^
//
//  EXPLANATION
//    _CAOŎw肵|[g̏ݒ肵܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::OnOutputBtn() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	DWORD	dwRet;			//GpioAccʎ擾
	ULONG	ulMode;			// o̓tOiOF́APGój
	ULONG	ulBitMask;		// bit2bit0ŃANZX|[ĝ݂PZbgAOŖ
	ULONG	ulData;		// o̓f[^(bit2bit0L)
	ULONG	ulRsv;			// \(2005/10/14݂͖gp̂0Zbg)

	// GPIOANZXf[^쐬
	// ϐ̏
	ulMode = 1;		// 1Fo
	ulBitMask = 0;	// tO
	ulData = 0;	// o̓f[^
	ulRsv = 0;		// \(2005/10/14݂͖gp̂0Zbg)
	
	// GPIO݃f[^쐬
	SetOutPortInfo(&ulBitMask, &ulData);

	// foCXhCoI[v܂
	dwRet = SVIUSB20_Open(SVIUSB20_APP_WHO_CTL);
	if(dwRet != SVIUSB20_RET_NORMAL)
	{
		CString ErrMessage;
		ErrMessage.Format("foCXhCõI[vɎs܂BG[R[h %X",dwRet);
		MessageBox(ErrMessage);
		return;
	}

	// GPIOANZX܂
	dwRet = SVIUSB20_GpioAcc(ulMode, ulBitMask, &ulData, 0);
	if(dwRet != SVIUSB20_RET_NORMAL){
		// G[̂Ƃ͂ǂ܂傤H
		if(dwRet == SVIUSB20_RET_ERROR_PARAMETER)
		{
			MessageBox("ɊԈႢ܂");
		}
		else if(dwRet == SVIUSB20_RET_ERROR_NOOPEN)
		{
			MessageBox("I[vĂ܂");
		}
		else
		{
			CString ErrMessage;
			ErrMessage.Format("GPIO̐ݒɎs܂BG[R[h %X",dwRet);
			MessageBox(ErrMessage);
		}
	}

	// foCXhCoN[Y܂
	dwRet = SVIUSB20_Close(SVIUSB20_APP_WHO_CTL);
	if(dwRet != SVIUSB20_RET_NORMAL)
	{
		CString ErrMessage;
		ErrMessage.Format("foCXhCõN[YɎs܂BG[R[h %X",dwRet);
		MessageBox(ErrMessage);
		return;
	}
	
}
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetInPortInfo
//
//  PARAMETER
//    ULONG ulGpioValue ; GPIOsݒ
//
//  SUMMARY
//    GPIOݒl_CAOɐݒ
//
//  EXPLANATION
//    _CAOɎ擾ݒl𔽉f܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::GetInPortInfo(ULONG ulGpioValue)
{
	BOOL	bGetIn0ChkStat;	 // `FbN{bNXP0ݒl擾
	BOOL	bGetIn1ChkStat;	 // `FbN{bNXP1ݒl擾
	BOOL	bGetIn2ChkStat;  // `FbN{bNXP2ݒl擾
	BOOL	bGetIn11ChkStat; // `FbN{bNXP11ݒl擾
	BOOL	bGetIn12ChkStat; // `FbN{bNXP12ݒl擾
	BOOL	bGetIn13ChkStat; // `FbN{bNXP13ݒl擾
	BOOL	bGetIn14ChkStat; // `FbN{bNXP14ݒl擾
	BOOL	bGetIn15ChkStat; // `FbN{bNXP15ݒl擾
	CButton* cbGetChkID;	// `FbN{bNXID擾
	CStatic* csGetStcID;	// X^eBbNeLXgID擾
	CString csSetStcString;	// X^eBbNeLXgɐݒ肷l擾

	// `FbN{bNXP0ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP0_CHK);
	// {^ԃZbg
	bGetIn0ChkStat = cbGetChkID->GetCheck();

	// `FbN{bNXP1ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP1_CHK);
	// {^ԃZbg
	bGetIn1ChkStat = cbGetChkID->GetCheck();

	// `FbN{bNXP2ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP2_CHK);
	// {^ԃZbg
	bGetIn2ChkStat = cbGetChkID->GetCheck();

	// `FbN{bNXP11ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP11_CHK);
	// {^ԃZbg
	bGetIn11ChkStat = cbGetChkID->GetCheck();

	// `FbN{bNXP12ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP12_CHK);
	// {^ԃZbg
	bGetIn12ChkStat = cbGetChkID->GetCheck();

	// `FbN{bNXP13ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP13_CHK);
	// {^ԃZbg
	bGetIn13ChkStat = cbGetChkID->GetCheck();

	// `FbN{bNXP14ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP14_CHK);
	// {^ԃZbg
	bGetIn14ChkStat = cbGetChkID->GetCheck();

	// `FbN{bNXP15ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP15_CHK);
	// {^ԃZbg
	bGetIn15ChkStat = cbGetChkID->GetCheck();

	// GPIOANZXf[^ݒ
	// P0ݒ
	if(bGetIn0ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",ulGpioValue & DEF_INP0_BITMASK);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP0_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP0_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);

	// P1ݒ
	if(bGetIn1ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",(ulGpioValue & DEF_INP1_BITMASK) >> 1);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP1_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP1_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);

	// P2ݒ
	if(bGetIn2ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",(ulGpioValue & DEF_INP2_BITMASK) >> 2);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP2_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP2_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);

	// P11ݒ
	if(bGetIn11ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",(ulGpioValue & DEF_INP11_BITMASK) >> 3);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP11_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP11_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);

	// P12ݒ
	if(bGetIn12ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",(ulGpioValue & DEF_INP12_BITMASK) >> 4);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP12_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP12_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);

	// P13ݒ
	if(bGetIn13ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",(ulGpioValue & DEF_INP13_BITMASK) >> 5);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP13_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP13_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);

	// P14ݒ
	if(bGetIn14ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",(ulGpioValue & DEF_INP14_BITMASK) >> 6);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP14_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP14_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);

	// P15ݒ
	if(bGetIn15ChkStat == TRUE)
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=@%d",(ulGpioValue & DEF_INP15_BITMASK) >> 7);
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP15_STC);
	}
	else
	{
		// GPIOݒlCStringϐ
		csSetStcString.Format("=");
		// CStaticID擾
		csGetStcID = (CStatic*)GetDlgItem(IDC_INP15_STC);
	}
	// CStaticGPIOlݒ
	csGetStcID->SetWindowText(csSetStcString);
}


/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    SetOutPortInfo
//
//  PARAMETER
//		ULONG* ulGpioMask ;	GPIOݒ}XN
//		ULONG* ulGpioValue; GPIOݒl
//  SUMMARY
//    GPIOݒs
//
//  EXPLANATION
//    GPIOݒl𔽉f܂
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::SetOutPortInfo(ULONG* ulGpioMask, ULONG* ulGpioValue)
{
	BOOL	bGetIn3ChkStat;	// `FbN{bNXP3ݒl擾
	BOOL	bGetIn4ChkStat;	// `FbN{bNXP4ݒl擾
	BOOL	bGetIn5ChkStat; // `FbN{bNXP5ݒl擾
	BOOL	bGetIn6ChkStat; // `FbN{bNXP6ݒl擾
	BOOL	bGetIn7ChkStat; // `FbN{bNXP7ݒl擾
	BOOL	bGetIn8ChkStat; // `FbN{bNXP8ݒl擾
	BOOL	bGetIn9ChkStat; // `FbN{bNXP9ݒl擾
	BOOL	bGetIn10ChkStat; // `FbN{bNXP10ݒl擾
	CButton* cbGetChkID;	// `FbN{bNXID擾
	CEdit* ceGetEditID;	// `FbN{bNXID擾
	CString	ceGetOut3Val;	// GfBbg{bNXP3l
	CString	ceGetOut4Val;	// GfBbg{bNXP4l
	CString	ceGetOut5Val;	// GfBbg{bNXP5l
	CString	ceGetOut6Val;	// GfBbg{bNXP6l
	CString	ceGetOut7Val;	// GfBbg{bNXP7l
	CString	ceGetOut8Val;	// GfBbg{bNXP8l
	CString	ceGetOut9Val;	// GfBbg{bNXP9l
	CString	ceGetOut10Val;	// GfBbg{bNXP10l

	// 
	*ulGpioMask = 0;
	*ulGpioValue = 0;

	// `FbN{bNXP3ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP3_CHK);
	// {^ԃZbg
	bGetIn3ChkStat = cbGetChkID->GetCheck();
	// `FbN{bNXP4ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP4_CHK);
	// {^ԃZbg
	bGetIn4ChkStat = cbGetChkID->GetCheck();
	// `FbN{bNXP5ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP5_CHK);
	// {^ԃZbg
	bGetIn5ChkStat = cbGetChkID->GetCheck();
	// `FbN{bNXP6ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP6_CHK);
	// {^ԃZbg
	bGetIn6ChkStat = cbGetChkID->GetCheck();
	// `FbN{bNXP7ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP7_CHK);
	// {^ԃZbg
	bGetIn7ChkStat = cbGetChkID->GetCheck();
	// `FbN{bNXP8ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP8_CHK);
	// {^ԃZbg
	bGetIn8ChkStat = cbGetChkID->GetCheck();
	// `FbN{bNXP9ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP9_CHK);
	// {^ԃZbg
	bGetIn9ChkStat = cbGetChkID->GetCheck();
	// `FbN{bNXP10ID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP10_CHK);
	// {^ԃZbg
	bGetIn10ChkStat = cbGetChkID->GetCheck();

	// eLXg{bNXl擾
	// eLXg{bNXl擾P3ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP3_EDIT);
	ceGetEditID->GetWindowText(ceGetOut3Val);
	// eLXg{bNXl擾P4ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP4_EDIT);
	ceGetEditID->GetWindowText(ceGetOut4Val);
	// eLXg{bNXl擾P5ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP5_EDIT);
	ceGetEditID->GetWindowText(ceGetOut5Val);
	// eLXg{bNXl擾P6ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP6_EDIT);
	ceGetEditID->GetWindowText(ceGetOut6Val);
	// eLXg{bNXl擾P7ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP7_EDIT);
	ceGetEditID->GetWindowText(ceGetOut7Val);
	// eLXg{bNXl擾P8ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP8_EDIT);
	ceGetEditID->GetWindowText(ceGetOut8Val);
	// eLXg{bNXl擾P9ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP9_EDIT);
	ceGetEditID->GetWindowText(ceGetOut9Val);
	// eLXg{bNXl擾P10ID擾
	ceGetEditID = (CEdit*)GetDlgItem(IDC_OUTP10_EDIT);
	ceGetEditID->GetWindowText(ceGetOut10Val);
	
	// GPIOANZXf[^ݒ
	if(bGetIn3ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP3_BITMASK;
		// GPIOݒlݒiP3̐ݒl1rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | atoi(ceGetOut3Val);
	}
	if(bGetIn4ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP4_BITMASK;
		// GPIOݒlݒiP4̐ݒl2rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | (atoi(ceGetOut4Val) << 1);
	}
	if(bGetIn5ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP5_BITMASK;
		// GPIOݒlݒiP5̐ݒl3rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | (atoi(ceGetOut5Val)  << 2);
	}
	if(bGetIn6ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP6_BITMASK;
		// GPIOݒlݒiP6̐ݒl4rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | (atoi(ceGetOut6Val)  << 3);
	}
	if(bGetIn7ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP7_BITMASK;
		// GPIOݒlݒiP7̐ݒl5rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | (atoi(ceGetOut7Val)  << 4);
	}
	if(bGetIn8ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP8_BITMASK;
		// GPIOݒlݒiP8̐ݒl6rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | (atoi(ceGetOut8Val)  << 5);
	}
	if(bGetIn9ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP9_BITMASK;
		// GPIOݒlݒiP9̐ݒl7rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | (atoi(ceGetOut9Val)  << 6);
	}
	if(bGetIn10ChkStat == TRUE)
	{
		// rbg}XNݒ
		*ulGpioMask = *ulGpioMask | DEF_OUTP10_BITMASK;
		// GPIOݒlݒiP10̐ݒl8rbgڂɐݒj
		*ulGpioValue = *ulGpioValue | (atoi(ceGetOut10Val)  << 7);
	}


}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnCreate
//
//  PARAMETER
//		LPCREATESTRUCT lpCreateStruct
//  SUMMARY
//    _CAO쐬̓
//
//  EXPLANATION
//    _CAO쐬ɌĂяoAvOC𑗂܂
//
//  RETURN
//    0
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
int CSVIGPIODialog::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: ̈ʒuɌŗL̍쐬pR[hǉĂ
	
	// SVIGPIOŎĂhParentWndl擾
	HWND hWnd = ((CSVIGPIOApp*)AfxGetApp())->hParentWnd;
	
	// FvOCʃR[h@FʐMpEChEnh
	::PostMessage(hWnd,WM_CREATEWINDOW,((CSVIGPIOApp*)AfxGetApp())->PluginNo,(long)m_hWnd);

	return 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnWM_CLOSEPARENTS
//
//  PARAMETER
//		WPARAM wParam
//		LPARAM lParam
//  SUMMARY
//    [U`bZ[WM̓
//
//  EXPLANATION
//    [U`bZ[WMieEBhEN[YjɌĂяoB
//	  ĂяoꂽIsB
//  RETURN
//    0
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
LRESULT CSVIGPIODialog::OnWM_CLOSEPARENTS(WPARAM wParam, LPARAM lParam)
{
	//Iʒm	
	this->PostMessage(WM_CLOSE,0,0);
	return 0;
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnClose
//
//  PARAMETER
//
//  SUMMARY
//    _CAOI̓
//
//  EXPLANATION
//    evOCɏʒmA_CAȌԂۑI
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::OnClose() 
{
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉ邩܂̓ftHg̏ĂяoĂ

	// vOCʒm̂߂̃nh擾
	HWND hWnd = ((CSVIGPIOApp*)AfxGetApp())->hParentWnd;

	//ĂяoWM_CLOSEPLUGIN̑M
	::PostMessage(hWnd,WM_CLOSEPLUGIN,UINT(m_hWnd),0);
	
	// _CAOۑ
	SaveDialogInfo();

	CDialog::OnClose();
}

/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    OnKillfocusOutp3Edit
//
//  PARAMETER
//
//  SUMMARY
//    EDITtH[JXړ̓
//
//  EXPLANATION
//    EDITtH[JXړɐݒlK̂̂肷
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::OnKillfocusOutp3Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP3_EDIT);
}

void CSVIGPIODialog::OnKillfocusOutp4Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP4_EDIT);
}

void CSVIGPIODialog::OnKillfocusOutp5Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP5_EDIT);

}

void CSVIGPIODialog::OnKillfocusOutp6Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP6_EDIT);

}

void CSVIGPIODialog::OnKillfocusOutp7Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP7_EDIT);

}

void CSVIGPIODialog::OnKillfocusOutp8Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP8_EDIT);

}

void CSVIGPIODialog::OnKillfocusOutp9Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP9_EDIT);

}

void CSVIGPIODialog::OnKillfocusOutp10Edit() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// eLXg{bNXl
	CheckEditValue(IDC_OUTP10_EDIT);

}

// eLXg{bNX̓͒l̔
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    CheckEditValue
//
//  PARAMETER
//
//  SUMMARY
//    EDIT͒l
//
//  EXPLANATION
//    EDIT肵KOł΃G[oAEDIT{bNXl0ɂ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::CheckEditValue(int DlgID)
{
	CString csGetEditVal;		//Edit{bNXl擾

	// eLXg{bNXl擾PE0ID擾
	CEdit* ceGetEditID = (CEdit*)GetDlgItem(DlgID);
	ceGetEditID->GetWindowText(csGetEditVal);
	
	// O܂͂PȊȌꍇIFs
	if(csGetEditVal != "0" && csGetEditVal != "1")
	{
		MessageBox("O܂͂PĂ");
		ceGetEditID->SetWindowText("0");
	}

}
/*MFUNC-----------------------------------------------------------------------*/
//
//  NAME
//    DialogInfoSave
//
//  PARAMETER
//
//  SUMMARY
//    _CAȌԂInit@Cɕۑ
//
//  EXPLANATION
//    _CAȌԂInit@Cɕۑ
//
//  RETURN
//    NONE
//
//  REMARKS
//    NONE
//
/*MFUNC-----------------------------------------------------------------------*/
void CSVIGPIODialog::SaveDialogInfo()
{
	BOOL bSetChkStat;		// `FbN{bNXݒl擾
	CButton* cbGetChkID;	// `FbN{bNXID擾
	
	// INIt@C̓ǂݍ
	CIniFileControl IniFileCtrl(DEF_INI_APP, ggszIniFile);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP0_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	// InPE3ݒ擾
	IniFileCtrl.setInt(DEF_IN_P0,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP1_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//InPE9ݒ擾
	IniFileCtrl.setInt(DEF_IN_P1,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP2_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//InPE10ݒ擾
	IniFileCtrl.setInt(DEF_IN_P2,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP11_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//InPE10ݒ擾
	IniFileCtrl.setInt(DEF_IN_P11,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP12_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//InPE10ݒ擾
	IniFileCtrl.setInt(DEF_IN_P12,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP13_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//InPE10ݒ擾
	IniFileCtrl.setInt(DEF_IN_P13,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP14_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//InPE10ݒ擾
	IniFileCtrl.setInt(DEF_IN_P14,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_INP15_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//InPE10ݒ擾
	IniFileCtrl.setInt(DEF_IN_P15,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP3_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE0ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P3,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP4_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE1ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P4,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP5_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE2ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P5,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP6_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE2ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P6,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP7_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE2ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P7,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP8_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE2ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P8,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP9_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE2ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P9,bSetChkStat);

	// `FbN{bNXID擾
	cbGetChkID = (CButton*)GetDlgItem(IDC_OUTP10_CHK);
	// {^ԃZbg
	bSetChkStat = cbGetChkID->GetCheck();
	//OutPE2ݒ擾
	IniFileCtrl.setInt(DEF_OUT_P10,bSetChkStat);
}
